package pwc.taxtech.atms.common;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

import org.junit.Assert;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import pwc.taxtech.atms.CommonIT;
import pwc.taxtech.atms.entity.Stock;

public class JsonIT extends CommonIT {

    @Autowired
    private ObjectMapper objectMapper;
    @Test
    public void nullToString() throws JsonProcessingException {
        System.out.println("############# PRINT START #################");
        System.out.println(objectMapper.writeValueAsString(null));
        System.out.println("############# PRINT END   #################");
    }

    @Test
    public void testNumber() throws JsonParseException, JsonMappingException, IOException {
        Stock obj = new Stock();
        BigDecimal capitalAmount = new BigDecimal("123456789012345678.888");
        obj.setCapitalAmount(capitalAmount);
        String jsonString = objectMapper.writeValueAsString(obj);
        System.out.println(jsonString);

        double d = 123456789012345678.888;
        Map<String, Object> map = new HashMap<>();
        map.put("key1", d);
        System.out.println(objectMapper.writeValueAsString(map));

    }

    @Test
    public void test() throws JsonParseException, JsonMappingException, IOException {
        {
            IdModel module = objectMapper.readValue("{\"id\":\"dummy\"}", IdModel.class);
            Assert.assertEquals("dummy", module.getId());
        }
        {
            IdModel module = objectMapper.readValue("{\"id\":\"dummy\"}", IdModel.class);
            Assert.assertEquals("dummy", module.getId());
        }
        {
            IdModel module = objectMapper.readValue("{\"id\":\"dummy\"}", IdModel.class);
            Assert.assertEquals("dummy", module.getId());
        }
        {
            IdModel module = objectMapper.readValue("{\"Id\":\"dummy\"}", IdModel.class);
            Assert.assertEquals("dummy", module.getId());
        }
    }

    public static class IdModel {

        private String id;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            id = id;
        }
    }
}
