package pwc.taxtech.atms.common;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.*;
import org.apache.poi.ss.formula.functions.FreeRefFunction;
import org.apache.poi.ss.util.CellReference;

/*
TmpFunction("g2",5)
 */
public class TmpFunction implements FreeRefFunction {
    @Override
    public ValueEval evaluate(ValueEval[] valueEvals, OperationEvaluationContext operationEvaluationContext) {
//        if (valueEvals.length != 3) {
//            return ErrorEval.VALUE_INVALId;
//        }
        try {
            ValueEval v1 = OperandResolver.getSingleValue(valueEvals[0],
                    operationEvaluationContext.getRowIndex(),
                    operationEvaluationContext.getColumnIndex());
            ValueEval v2 = OperandResolver.getSingleValue(valueEvals[1],
                    operationEvaluationContext.getRowIndex(),
                    operationEvaluationContext.getColumnIndex());

            String val1 = OperandResolver.coerceValueToString(v1);
            int val2 = OperandResolver.coerceValueToInt(v2);
            CellReference reference = new CellReference(val1);
            int referenceSheetIndex = operationEvaluationContext.getWorkbook().getSheetIndex(reference.getSheetName());

            return new NumberEval(operationEvaluationContext.getWorkbook()
                    .getSheet(referenceSheetIndex)
                    .getCell(reference.getRow(), reference.getCol())
                    .getNumericCellValue()
                    + val2);
        } catch (EvaluationException e) {
            e.printStackTrace();
        }
        return null;
    }
}
