package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.dto.VMRegionDevTreeData;
import pwc.taxtech.atms.dto.navtree.DevTreeDto;
import pwc.taxtech.atms.dto.navtree.IvhTreeDto;
import pwc.taxtech.atms.entity.Region;
import pwc.taxtech.atms.service.RegionService;

@RunWith(MockitoJUnitRunner.class)
public class RegionControllerTest {
    
    @Mock
    private RegionService regionService;

    @InjectMocks
    private RegionController regionController = new RegionController();
    
    @Test
    public void getSettingRegionTreeNotNullResult() {
        
        List<DevTreeDto<VMRegionDevTreeData>> devTreeDto = new ArrayList<>();
        when(regionService.getRegionAreaTree()).thenReturn(devTreeDto);
        assertThat(regionController.getSettingRegionTree()).isNotNull();
    }
    
    @Test
    public void getProvinceAndCityTreeListNotNullResult() {
        
        List<DevTreeDto<IvhTreeDto<Region>>> devTreeDto = new ArrayList<>();
        when(regionService.getProvinceAndCityTreeList()).thenReturn(devTreeDto);
        assertThat(regionController.getProvinceAndCityTreeList()).isNotNull();
    }
    
    @SuppressWarnings("rawtypes")
    @Test
    public void getAreRegionTreeByNodeIdTest() {
        List<DevTreeDto> devTreeDto = new ArrayList<>();
        when(regionService.getAreaRegionTreeByNodeId("1")).thenReturn(devTreeDto);
        assertThat(regionController.getAreRegionTreeByNodeId("1")).isNotNull();
    }
}
