package pwc.taxtech.atms.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;

import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.entity.EnterpriseAccount;

@Mapper
public interface CustomAccountMapper extends MyMapper {

    @Select("SELECT ea.id,ea.Code,ea.Name,ea.ParentCode,ea.FullName,"
            + "CASE WHEN am.StandardAccountCode='0000' THEN am.StandardAccountCode ELSE sa.Code END StdCode,"
            + "sa.Name StdName,sa.ParentCode StdParentCode "
            + "FROM (SELECT * FROM EnterpriseAccount where parentcode=#{parentCode} and Enterpriseaccountsetid=#{accountSetId}) ea "
            + "LEFT JOIN (SELECT * FROM AccountMapping WHERE OrganizationID=#{orgId} AND IndustryID=#{industryId} AND EnterpriseAccountSetID=#{accountSetId}) am ON ea.Code=am.EnterpriseAccountCode "
            + "LEFT JOIN (SELECT * FROM StandardAccount WHERE IndustryID=#{industryId}) sa ON am.StandardAccountCode=sa.Code "
            + "ORDER BY ea.CODE")
    @Results({
        @Result(id = true, column = "id", property = "id"),
        @Result(column = "Code", property = "code"),
        @Result(column = "Name", property = "name"),
        @Result(column = "ParentCode", property = "parentCode"),
        @Result(column = "FullName", property = "fullName"),
        @Result(column = "StdCode", property = "stdCode"),
        @Result(column = "StdName", property = "stdName")
        //@Result(column = "StdParentCode", property = "stdParentCode")
    })
    List<EnterpriseAccount> getMappingResult(@Param(value="accountSetId") String accountSetId,
            @Param(value="industryId") String industryId, @Param(value="orgId") String orgId,
            @Param(value="parentCode") String parentCode);
    
    
    
    @Select("SELECT COUNT(1) FROM AccountMapping "
            + "WHERE EnterpriseAccountCode=#{enterpirseAccountCode} "
            + "AND EnterpriseAccountSetID=#{enterpriseAccountSetId} "
            + "AND OrganizationID=#{organizationId} "
            + "AND IndustryID=#{organizationId} "
            + "AND StandardAccountCode<>'0000'")
    Long countStandardAccounts(@Param(value="enterpriseAccountSetId") String enterpriseAccountSetId,
            @Param(value="enterpirseAccountCode") String enterpirseAccountCode, 
            @Param(value="industryId") String industryId,
            @Param(value="organizationId") String organizationId);
}
