﻿infrastructureModule
    .controller('OrganizationAreaViewController', ['$scope', '$log', 'SweetAlert', 'regionService', '$translate', 'areaRegionService', 'uiGridTreeViewConstants', '$timeout', 'areaService', 'uiGridConstants', '$interval', 'orgService', 'dimensionService', '$state', '$stateParams', 'statisticAttributeService', '$q', 'roleService', 'enums',
        function ($scope, $log, SweetAlert, regionService, $translate, areaRegionService, uiGridTreeViewConstants, $timeout, areaService, uiGridConstants, $interval, orgService, dimensionService, $state, $stateParams, statisticAttributeService, $q, roleService, enums) {
            'use strict';

            // 机构缩略图
            var isGeneral = true;

            var defaultValue = {
                unknownArea: '未知分区',
                notSetAttribute: '未設置值',
            };

            // 机构缩略图ID
            var orgGeneralInfoPopId = '#orgGeneralInfoPop';
            var unassisgnText = $translate.instant('UnAssignText');
            $scope.unassisgnText = unassisgnText;
            var areaCommonCardID = '#areaOrgCard';
            var areaUserCardID = '#areaUserCard';

            // 系统级别的纬度id列表
            var systemDimensionIdList = [
                constant.attributeId.businessUnitID,
                constant.attributeId.areaID,
                constant.attributeId.organizationStructureID,
                constant.attributeId.userID,
                constant.attributeId.industryID,
                constant.attributeId.rgSubChildrenID
            ];

            // 颜色模板
            var colorPanel = {

                // 颜色列表
                // yellow,orange,gold
                colorList: ['#FFB300', '#FEE002', '#FFFA23'],

                createNew: function () {
                    var colorPanelInstance = {};
                    colorPanelInstance.index = -1;
                    colorPanelInstance.getNextColor = function () {
                        if (colorPanelInstance.index >= colorPanel.colorList.length - 1) {
                            colorPanelInstance.index = 0;
                        } else {
                            colorPanelInstance.index++;
                        }

                        return colorPanel.colorList[colorPanelInstance.index];
                    }

                    return colorPanelInstance;
                }
            };

            // 颜色实例
            var colorPanelInstance = colorPanel.createNew();

            var barColorPanel = {

                // 颜色列表
                // yellow,orange,gold
                colorList: [{
                    name: 'orange-color',
                    value: '#FDB37F',
                    lightColor: '#FEDEBB'
                }, {
                    name: 'purple-color',
                    value: '#CE97D7',
                    lightColor: '#F3DEF0'
                }, {
                    name: 'green-color',
                    value: '#B0DC56',
                    lightColor: '#E0E0A4'
                }],
                createNew: function () {
                    var colorPanelInstance = {};
                    colorPanelInstance.index = -1;
                    colorPanelInstance.currentColor = {};
                    colorPanelInstance.getNextColor = function () {
                        if (colorPanelInstance.index >= barColorPanel.colorList.length - 1) {
                            colorPanelInstance.index = 0;
                        } else {
                            colorPanelInstance.index++;
                        }

                        colorPanelInstance.currentColor = barColorPanel.colorList[colorPanelInstance.index];
                        return colorPanelInstance.currentColor;
                    };

                    return colorPanelInstance;
                }
            };

            // 柱状图颜色实例
            var barColorPanelInstance = barColorPanel.createNew();

            // 初始化维度展示列表Grid
            var areaDimensionORGGridListInit = function () {

                var columns = [{
                    field: 'name',
                    name: $translate.instant('ProjectCompanyCol'),
                    headerCellClass: 'text-align-left',
                    width: '100%',
                    cellTemplate: '<div ng-if="row.entity.isOrg" ng-class="{0: \'text-align-left\', 1: \'padding-left1\', 2:\'padding-left2\'}[row.entity.paddingLevel]">\
                        <span class="org-show-general" ng-click="grid.appScope.ShowOrgGeneralInfo(row,$event)" title="{{row.entity.name}}" id="{{row.entity.id}}">{{row.entity.name|limitString:16}}</span>\
                        </div>\
                        <div ng-if="!row.entity.isOrg" ng-class="{0: \'text-align-left\', 1: \'padding-left1\', 2:\'padding-left2\'}[row.entity.paddingLevel]">\
                        <span title="{{row.entity.name}}" id="{{row.entity.id}}">{{row.entity.name|limitString:16}}</span>\
                        </div>\
                        '
                }];

                $scope.areaDimensionORGGridList = {
                    enableRowSelection: true,
                    enableSelectAll: false,
                    rowHeight: constant.UIGrid.rowHeight,
                    enableRowHeaderSelection: false,
                    modifierKeysToMultiSelect: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
                    selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                    enableSorting: true,
                    enableColumnMenus: false,
                    enableFiltering: false,
                    showTreeExpandNoChildren: false,
                    enableFullRowSelection: true, //是否点击行任意位置后选中,默认为false
                    multiSelect: false, // 是否可以选择多个,默认为true;
                    columnDefs: columns,
                    onRegisterApi: function (gridApi) {
                        $scope.gridApiareaDimensionORGGridList = gridApi;

                        // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                        $interval(function () {
                            $scope.gridApiareaDimensionORGGridList.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                };


                $scope.areaDimensionORGGridList.data = [];
            };

            // 区域UI-Grid图
            var areaORGGridInit = function () {

                $scope.columns = [{
                    field: 'name',
                    name: $translate.instant('FieldorgName'),
                    headerCellClass: '',
                    // width: '50%',
                    cellTemplate: '<div ng-class="{0: \'text-align-left\', 1: \'padding-left1\', 2:\'padding-left2\'}[row.entity.paddingLevel]">\
                        <span class="org-show-general" ng-click="grid.appScope.ShowOrgGeneralInfo(row,$event)" title="{{row.entity.name}}" id="{{row.entity.id}}">{{row.entity.name|limitString:16}}</span>\
                        </div>'
                }];

                $scope.areaORGGridList = {
                    enableRowSelection: true,
                    enableSelectAll: false,
                    rowHeight: constant.UIGrid.errorRowHeight,
                    enableRowHeaderSelection: false,
                    modifierKeysToMultiSelect: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
                    selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                    enableSorting: true,
                    enableColumnMenus: false,
                    enableFiltering: false,
                    showTreeExpandNoChildren: false,
                    enableFullRowSelection: true, //是否点击行任意位置后选中,默认为false
                    multiSelect: false, // 是否可以选择多个,默认为true;
                    columnDefs: $scope.columns,
                    onRegisterApi: function (gridApi) {
                        $scope.gridApiAreaORGGridList = gridApi;

                        // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                        $interval(function () {
                            $scope.gridApiAreaORGGridList.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                };

                $scope.areaORGGridList.data = [];
            };

            var initUserSumDevGrid = function () {

                $scope.userDatagridDataSource = [];
                $scope.areaUserdatagridOptions = {
                    bindingOptions: {
                        dataSource: 'userDatagridDataSource'
                    },
                    selection: {
                        mode: "single"
                    },
                    columns: [{
                        dataField: "userName",
                        caption: $translate.instant('UserDesc'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<a>' + options.value + '</a>')
                                    .attr('href', '#/userDetail/' + options.row.data.userID)
                                    .appendTo(container);
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    }, {
                        dataField: "roleInfo",
                        caption: $translate.instant('Role')
                    }, {
                        dataField: "orgCount",
                        caption: $translate.instant('OrganizationCount'),
                        alignment: 'center'

                    }, ],
                    loadPanel: {
                        enabled: false
                    },
                    scrolling: {
                        mode: "virtual"
                    },
                    noDataText: $translate.instant('NoDataText'),
                    showColumnLines: false,
                    showRowLines: false,
                    rowAlternationEnabled: true,
                    showBorders: false,
                    sorting: {
                        mode: "none"
                    }
                };
            };

            $scope.$on("DimensionUpdate", function (event, data) {
                // console.log('DimensionUpdate' + JSON.stringify(data));
                // 强制刷新机构部分
                $scope.forceOrgUpdate = true;
                // 修改维度可能修改到的值
                init();

            });

            // 绘制中国地图
            var drawChinaMap = function () {

                $.get('/app-resources/map/china.json', function (chinaJson) {
                    echarts.registerMap('china', chinaJson);
                    var mychart = echarts.init(document.getElementById('chinaShowOrganizationMap'));
                    var option = {
                        // remove hover show
                        // tooltip: {
                        //     trigger: 'item',
                        //     // triggerOn: 'click', 调试tooltip样式使用
                        //     showDelay: 10,
                        //     enterable: true,
                        //     formatter: fomatterFunction,
                        // },
                        legend: {
                            orient: 'vertical',
                            left: 'left',
                            data: []
                        },
                        textStyle: {
                            color: '#000',
                            fontWeight: 'bold'
                        },
                        series: [{
                            type: 'map',
                            map: 'china',
                            nameMap: {
                                'China': '中国'
                            },
                            label: {
                                normal: {
                                    show: true,
                                    textStyle: {
                                        color: '#894A00',
                                        fontWeight: 'normal'
                                    }
                                },
                                emphasis: {
                                    //textStyle: {
                                    //    color: '#fff'
                                    //}
                                }
                            },
                            itemStyle: {
                                normal: {
                                    areaColor: '#C9C9C9',
                                    borderColor: 'white',
                                    borderWidth: 0.5,
                                    label: {
                                        show: false
                                    }
                                },
                                emphasis: {
                                    areaColor: '#F2D997',
                                    label: {
                                        show: true
                                    }
                                }
                            },
                            zoom: 1.2,
                            scaleLimit: {
                                min: 1
                            },
                            selectedMode: false,
                            roam: true,
                            data: [],
                            markPoint: {
                                symbol: 'pin',
                                symbolSize: 50,
                                label: {
                                    normal: {
                                        show: true,
                                        formatter: function (d) {
                                            return d.name
                                        }
                                    }
                                },
                                data: [
                                    // {
                                    //     name: '武汉',
                                    //     coord: [114.31, 30.52]
                                    // },{
                                    //     name:'临汾市',
                                    //     coord:[111.517975,36.08415]
                                    // }
                                ]
                            }
                        }]
                    };

                    $scope.chinaMapOption = option;
                    mychart.setOption(option);
                    $scope.chinaMapChart = mychart;
                });

            };

            // 自动加上id、颜色及样式信息
            var generateID = function () {
                var index = 0;

                if ($scope.areaInfoList && $scope.areaInfoList.length > 0) {
                    $scope.areaInfoList.forEach(function (row) {

                        row.randomID = "area" + index;
                        row.totalCount = 0;
                        if (row.cityStatistics && row.cityStatistics.length > 0) {
                            row.cityStatistics.forEach(function (r) {
                                row.totalCount += r.organizationBusinessUnitStatistics.length;
                            });
                        }

                        // var areaOrgList = _.filter($scope.organizationList, function(org){
                        //     return org.areaID === row.id;
                        // });

                        // if (areaOrgList && areaOrgList.length > 0){
                        //     row.organizationCount = areaOrgList.length;
                        // } else{
                        //     row.organizationCount = 0;
                        // }

                        // 颜色及样式
                        row.theme = barColorPanelInstance.getNextColor();
                        row.detailTitle = row.name + $translate.instant('AreaDetail');
                        index++;
                    });
                }
            };

            $scope.getGridHeight = function () {

                return {};
            };

            // 构造机构层级父子节点树
            var parseDataGridOnlyOrg = function () {

                var gridData = [];

                // 直接看区域上设置的AreaID，不用根据行政区域划分到哪个分区来计算【简单做】
                var allOrgList = $scope.panelArea.organizationList;

                if (allOrgList && allOrgList.length > 0) {
                    // $scope.panelArea.cityStatistics.forEach(function (r) {
                    //     if (r.organizationBusinessUnitStatistics && r.organizationBusinessUnitStatistics.length > 0) {
                    //         allOrgList = _.union(r.organizationBusinessUnitStatistics, allOrgList);
                    //     }

                    // });

                    // 先复制一份，要改parentId，不要相互影响
                    allOrgList = angular.copy(allOrgList);

                    // 设置自定义维度的值
                    for (var i = 0; i < $scope.statisticAttrList.length; i++) {
                        var index = i + 1;
                        var attr = $scope.statisticAttrList[i];

                        if (attr.attributeType === constant.attributeType.SelfDimension) {
                            var relevantOrgList = _.filter($scope.dimensionOrgList, function (dimensionOrg) {
                                return dimensionOrg.dimensionId === attr.belongDimensionId;
                            });

                            relevantOrgList.forEach(function (dimensionOrg) {
                                var org = _.find(allOrgList, function (org) {
                                    return org.id === dimensionOrg.organizationID;
                                });

                                if (org) {
                                    org['selfDimension' + index] = dimensionOrg.dimensionValue;
                                }
                            });
                        }
                    }


                    if ($scope.selectAttribute.attributeType === constant.attributeType.OrgSubChildren) {

                        // 机构维度
                        gridData = buildOrgTreeData(allOrgList);


                    } else if ($scope.selectAttribute.attributeType === constant.attributeType.SelfDimension) {
                        // 自定义维度
                        var row = $scope.selectAttribute;

                        var orgidList = _.pluck(allOrgList, 'id');

                        var targetDimensionValueList = _.filter($scope.dimensionOrgList, function (data) {
                            return data.dimensionId === row.belongDimensionId && orgidList.indexOf(data.organizationID) > -1;
                        });

                        var orgList = [];
                        if (targetDimensionValueList && targetDimensionValueList.length > 0) {
                            orgList = _.uniq(_.pluck(targetDimensionValueList, 'dimensionValueID'));
                        }

                        gridData = selfDimensionOrgTree(allOrgList, targetDimensionValueList);

                    } else {
                        // 其他维度
                        var idCol = constant.attributeTypeIDColMap[$scope.selectAttribute.attributeType];
                        var nameCol = constant.attributeTypeNameColMap[$scope.selectAttribute.attributeType];
                        gridData = systemDimensionOrgTree(allOrgList, idCol, nameCol);

                    }

                }

                $scope.areaORGGridList.data = gridData;
                // $log.debug("gridData:" + JSON.stringify(gridData));
            };

            var buildOrgTreeData = function (allOrgList) {

                $scope.commonCountDataSource = [];

                if (!allOrgList) {
                    allOrgList = [];
                }

                $scope.commonCountDataSource.push({
                    name: '机构数',
                    count: allOrgList.length
                });

                // 获取所有根节点的机构
                var idList = _.pluck(allOrgList, 'id');
                var topNodeList = _.filter(allOrgList, function (org) {
                    return idList.indexOf(org.parentId) === -1;
                });

                var orglist = [];
                topNodeList.forEach(function (org) {
                    var temp = buildOrgTree(org, allOrgList);
                    orglist.push(temp);
                });

                var templist = parseUIGridTreeList(orglist, 0);

                return templist;
            };

            // 获取父节点
            var getParentID = function (current, allList, orgDtoList) {
                if (current.parentId === null) {
                    return null;
                }

                var findParent = _.find(allList, function (num) {
                    return num.id === current.parentId;
                });

                var parent = _.find(orgDtoList, function (num) {
                    return num.id === findParent.id;
                });

                if (parent != null) {
                    return parent.id;
                } else {
                    return getParentID(findParent, allList, orgDtoList);
                }
            };

            // 构造UITree
            var parseUIGridTreeList = function (orglist, level) {
                var all = [];
                if (orglist && orglist.length > 0) {
                    orglist.forEach(function (org) {

                        if (level <= 2) {
                            org.paddingLevel = level;
                        } else {
                            org.paddingLevel = 2;
                        }

                        if (org.children && org.children.length > 0) {

                            org.$$treeLevel = level;

                            all.push(org);
                            var temp = parseUIGridTreeList(org.children, level + 1);
                            all = _.union(all, temp);
                        } else {


                            org.$$treeLevel = level;
                            all.push(org);
                        }
                    });
                }

                return all;
            };

            // tree 数据
            var buildOrgTree = function (or, orgList) {

                var orgItem = or;
                var selfDimensionIndex = 1;

                var sublist = _.filter(orgList, function (org) {
                    return org.parentId === or.id;
                });

                var children = [];

                if (sublist != null && sublist.length > 0) {
                    sublist.forEach(function (org) {
                        var temp = buildOrgTree(org);
                        children.push(temp);
                    });
                }

                orgItem.children = children;

                return orgItem;
            };

            // 转换为UI Grid数据格式
            var parseDataGrid = function () {
                var gridData = [];

                if ($scope.panelArea.cityStatistics && $scope.panelArea.cityStatistics.length > 0) {

                    $scope.panelArea.cityStatistics.forEach(function (r) {
                        var cityItem = {
                            id: r.id,
                            name: r.name,
                            isOrganization: false,
                            businessUnitName: '',
                            structureName: '',
                            userCount: 0,
                            $$treeLevel: 0
                        };

                        gridData.push(cityItem);

                        if (r.organizationBusinessUnitStatistics && r.organizationBusinessUnitStatistics.length > 0) {
                            for (var i = 0; i <= r.organizationBusinessUnitStatistics.length - 1; i++) {
                                var or = r.organizationBusinessUnitStatistics[i];

                                var orgItem = {
                                    id: or.id,
                                    name: or.name,
                                    isOrganization: true,
                                    businessUnitName: or.businessUnitName,
                                    structureName: or.structureName,
                                    userCount: or.userCount,
                                    areaName: or.areaName,
                                    industryName: or.industryName
                                };

                                var selfDimensionIndex = 1;
                                $scope.subDimensionidList.forEach(function (id) {
                                    if (systemDimensionIdList.indexOf(id) === -1) {

                                        var targetValue = _.find($scope.dimensionOrgList, function (valueOrg) {
                                            return valueOrg.organizationID === or.id && valueOrg.dimensionId === id;
                                        });

                                        if (targetValue) {
                                            orgItem['selfDimension' + selfDimensionIndex] = targetValue.dimensionValue;
                                        } else {
                                            orgItem['selfDimension' + selfDimensionIndex] = '';
                                        }

                                    }

                                    selfDimensionIndex++;
                                });

                                cityItem.userCount += cityItem.userCount + or.userCount;
                                gridData.push(orgItem);
                            }
                        }
                    });
                }

                $log.debug("gridData:" + JSON.stringify(gridData));
                $log.debug("columns:" + JSON.stringify($scope.columns));

                $scope.areaORGGridList.data = gridData;
            };

            // 显示机构缩略图
            $scope.ShowOrgGeneralInfo = function (row, $event) {

                $scope.orgIdGeneralInfo = row.entity.id;
                var orgGeneralInfoPopup = $(orgGeneralInfoPopId);
                var a = $('#' + row.entity.id);
                showOrgCard(orgGeneralInfoPopup, a, 30, 50);
                $event.stopPropagation();
            };

            // 显示用户数卡片
            var showUserSumCard = function () {
                // 关闭其他卡片
                $scope.closeOrgCard();
                $scope.dimensionValue = $scope.panelArea.name;
                $scope.attributeName = '用户数';
                $(areaUserCardID).css('visibility', 'visible');

                $scope.userDatagridDataSource = [];
                $scope.roleCountDataSource = [];
                roleService.getActiveUserRoleListByAreaID($scope.panelArea.id).success(function (data) {

                    buildUserCardInfo(data);
                });
            };

            // 显示机构数
            var showAreaOrgCard = function () {
                // 关闭用户卡片
                $scope.closeUserCard();

                $scope.areaORGGridList.data = [];
                $scope.commonCountDataSource = [];
                if ($scope.panelArea.organizationList && $scope.panelArea.organizationList.length > 0) {
                    parseDataGridOnlyOrg();
                } else {
                    orgService.getOrganizationListByAreaID($scope.panelArea.id, $scope.selectAttribute.attributeId).success(function (data) {

                        $scope.panelArea.organizationList = data;
                        parseDataGridOnlyOrg();
                    });
                }

                $scope.isShowOrgCard = true;

                $(areaCommonCardID).css('visibility', 'visible');

                $timeout(function () {
                    $scope.gridApiAreaORGGridList.treeBase.collapseAllRows();
                }, 500);
            };

            // 根据维度展示卡片
            $scope.showDimensionCard = function (row) {

                $scope.selectAttribute = row;

                $scope.cardTitle = $scope.panelArea.name + '-' + row.attributeName;
                if (row.attributeType === constant.attributeType.User) {
                    showUserSumCard();
                    return;
                } else {
                    setColumns();
                    showAreaOrgCard();
                    return;
                }

            };

            // 构造用户卡片
            var buildUserCardInfo = function (thisAreaUserRoleList) {
                var userList = [];

                var userIdList = _.uniq(_.pluck(thisAreaUserRoleList, 'id'));

                // 当修改用户权限的时候可能会改到用户个数
                if (userIdList) {

                    var findUserAttr = _.find($scope.statisticAttrList, function (row) {
                        return row.attributeType === constant.attributeType.User;
                    });

                    if (findUserAttr) {
                        findUserAttr.count = userIdList.length;
                    }
                }

                var roleCountDataSource = [];

                userIdList.forEach(function (row) {

                    var thisUserOrgList = _.filter(thisAreaUserRoleList, function (num) {
                        return num.id === row;
                    });

                    var first = thisUserOrgList[0];
                    var item = {
                        userID: first.id,
                        userName: first.userName,
                        orgCount: thisUserOrgList.length,
                    };

                    var roleNameList = [];
                    thisUserOrgList.forEach(function (user) {
                        if (user.roleInfoList && user.roleInfoList.length > 0) {
                            var tempRoleNameList = _.pluck(user.roleInfoList, 'name');
                            roleNameList = _.union(roleNameList, tempRoleNameList);
                        }
                    });

                    roleNameList = _.uniq(roleNameList);

                    // 设置角色统计
                    for (var i = 0; i < roleNameList.length; i++) {
                        var roleName = roleNameList[i];
                        var find = _.find(roleCountDataSource, function (num) {
                            return num.name === roleName;
                        });
                        if (find) {
                            find.count++;
                        } else {
                            roleCountDataSource.push({ name: roleName, count: 1 });
                        }
                    }


                    item.roleInfo = roleNameList.join(',');
                    userList.push(item);

                });

                $scope.roleCountDataSource = roleCountDataSource;

                $scope.panelArea.userDatagridDataSource = userList;

                $scope.userDatagridDataSource = userList;

            };

            $scope.closeUserCard = function () {
                $(areaUserCardID).css('visibility', 'hidden');
            };

            // 地图上面绘制泡泡图markPoint
            var writeMap = function () {

                // clear old Map data
                $scope.chinaMapOption.series[0].markPoint.data = [];
                if ($scope.panelArea.cityStatistics && $scope.panelArea.cityStatistics.length > 0) {
                    $scope.panelArea.cityStatistics.forEach(function (row) {
                        var item = {
                            name: row.name,
                            coord: [row.longitude, row.latitude]
                        };

                        if (row.organizationBusinessUnitStatistics && row.organizationBusinessUnitStatistics.length > 0) {
                            $scope.chinaMapOption.series[0].markPoint.data.push(item);
                        }
                    });
                }

                $scope.chinaMapOption.color = [$scope.panelArea.theme.value];
                $scope.chinaMapChart.setOption($scope.chinaMapOption);
            };

            // 选中区域
            $scope.chooseArea = function (areaInfo) {


                $scope.isChooseAllArea = false;
                //$scope.closeUserCard();
                //$scope.closeOrgCard();
                $scope.panelArea = areaInfo;
                setAreaStatisticAttrOrgCount();

                //var firstDimension = null;
                //var secondDimension = null;
                //$scope.belowDimensionList = [];

                //if ($scope.statisticAttrList) {

                //    if ($scope.statisticAttrList.length > 0) {
                //        firstDimension = $scope.statisticAttrList[0];
                //    }

                //    if ($scope.statisticAttrList.length > 1) {
                //        secondDimension = $scope.statisticAttrList[1];
                //    }

                //    if ($scope.statisticAttrList.length > 2) {

                //        for (var i = 2; i < $scope.statisticAttrList.length; i++) {
                //            var row = $scope.statisticAttrList[i];
                //            $scope.belowDimensionList.push(row);
                //        }
                //    }
                //}

                //$scope.firstDimension = firstDimension;
                //$scope.secondDimension = secondDimension;

                setMapData();
                //hideOrgGeneralInfo();

                thisCardService.closeALLCard();
                //$timeout(function () {
                //    // writeMap();
                //    setMapData();
                //    hideOrgGeneralInfo();
                //    $scope.hideCard();
                //}, 10);
            };

            // choose all area
            $scope.chooseAllArea = function () {
                // body...
                $scope.isChooseAllArea = true;
                $scope.closeUserCard();
                $scope.closeOrgCard();
                $scope.panelArea = {};

                setAllAreaMapData();
                //$timeout(function () {
                //    setAllAreaMapData();
                //}, 10);
            };

            // 自定义维度机构树
            var selfDimensionOrgTree = function (thisAreaOrgList, targetDimensionValueList) {
                var dimensionValueObjList = [];

                targetDimensionValueList.forEach(function (row) {
                    var find = _.find(dimensionValueObjList, function (num) {
                        return num.id === row.dimensionValueID;
                    });

                    if (!find && row.dimensionValue) {
                        var item = {
                            id: row.dimensionValueID,
                            name: row.dimensionValue
                        };

                        dimensionValueObjList.push(item);
                    }
                });

                return buildDimensionTreeList(thisAreaOrgList, dimensionValueObjList, targetDimensionValueList);
            };

            // 构造维度机构树
            var buildDimensionTreeList = function (thisAreaOrgList, dimensionValueObjList, targetDimensionValueList) {
                dimensionValueObjList = _.sortBy(dimensionValueObjList, 'name');
                var treeList = [];

                $scope.commonCountDataSource = [];
                dimensionValueObjList.forEach(function (attr) {

                    var dimensionOrgList = _.filter(targetDimensionValueList, function (row) {
                        return row.dimensionValueID === attr.id;
                    });

                    var orgidlist = _.pluck(dimensionOrgList, 'organizationID');

                    var itemCount = {};
                    itemCount.name = attr.name;
                    itemCount.count = orgidlist.length;
                    $scope.commonCountDataSource.push(itemCount);

                    var orgList = _.filter(thisAreaOrgList, function (org) {
                        return orgidlist.indexOf(org.id) > -1;
                    });

                    var firstNode = {};
                    firstNode.id = attr.id;
                    firstNode.name = attr.name;
                    firstNode.isOrg = false;
                    firstNode.$$treeLevel = 0;

                    treeList.push(firstNode);


                    orgList.forEach(function (org) {

                        var orgItem = org;
                        orgItem.isOrg = true;
                        orgItem.paddingLevel = 1;
                        //var orgItem = {
                        //    id: org.id,
                        //    name: org.name,
                        //    isOrg: true,
                        //    paddingLevel: 1,
                        //};

                        treeList.push(orgItem);
                    });
                });

                return treeList;
            };

            // 系统级维度树
            var systemDimensionOrgTree = function (thisAreaOrgList, idCol, nameCol) {
                var dimensionValueObjList = [];
                thisAreaOrgList.forEach(function (row) {

                    var find = _.find(dimensionValueObjList, function (num) {
                        return num.id === row[idCol];
                    });

                    if (!find && row[nameCol]) {
                        var item = {
                            id: row[idCol],
                            name: row[nameCol]
                        };

                        dimensionValueObjList.push(item);
                    }

                });

                dimensionValueObjList = _.sortBy(dimensionValueObjList, 'name');

                var treeList = [];
                $scope.commonCountDataSource = [];
                dimensionValueObjList.forEach(function (attr) {

                    var itemCount = {};
                    itemCount.name = attr.name;

                    var orgList = _.filter(thisAreaOrgList, function (org) {
                        return org[idCol] === attr.id;
                    });

                    var firstNode = {};
                    firstNode.id = attr.id;
                    firstNode.name = attr.name;
                    firstNode.isOrg = false;
                    firstNode.$$treeLevel = 0;

                    treeList.push(firstNode);

                    itemCount.count = orgList.length;
                    $scope.commonCountDataSource.push(itemCount);
                    orgList.forEach(function (org) {
                        var orgItem = org;
                        orgItem.isOrg = true;
                        orgItem.paddingLevel = 1;
                        //var orgItem = {
                        //    id: org.id,
                        //    name: org.name,
                        //    isOrg: true,
                        //    paddingLevel: 1,
                        //};

                        treeList.push(orgItem);
                    });
                });

                return treeList;

            };

            // 设置每个维度的个数、事业部，统计这个区域下有几个事业部 
            var setAreaStatisticAttrOrgCount = function () {

                var thisAreaOrgList = _.filter($scope.organizationList, function (num) {
                    return num.areaID === $scope.panelArea.id;
                });

                var orgidList = _.pluck(thisAreaOrgList, 'id');

                $scope.panelArea.organizationCount = orgidList.length;

                $scope.panelArea.organizationIDList = orgidList;

                // 设置每个维度的个数
                $scope.statisticAttrList.forEach(function (row) {

                    row.count = $scope.panelArea.attributeStatics[row.attributeId];
                    //var orgList = [];

                    //if (row.attributeType === constant.attributeType.SelfDimension) {

                    //    var targetDimensionValueList = _.filter($scope.dimensionOrgList, function (data) {
                    //        return data.dimensionId === row.belongDimensionId && orgidList.indexOf(data.organizationID) > -1;
                    //    });

                    //    if (targetDimensionValueList && targetDimensionValueList.length > 0) {
                    //        orgList = _.uniq(_.pluck(targetDimensionValueList, 'dimensionValueID'));
                    //    }

                    //} else if (row.attributeType === constant.attributeType.RegionID) {
                    //    // 行政省市

                    //    var administrativeAreaIDList = _.uniq(_.pluck(thisAreaOrgList, 'cityID'));
                    //    row.count = administrativeAreaIDList.length;
                    //} else if (row.attributeType === constant.attributeType.Unknown) {
                    //    // 未知不做
                    //} else if (row.attributeType === constant.attributeType.User) {
                    //    // 用户 不做
                    //    row.count = $scope.panelArea.userCount;
                    //} else if (row.attributeType === constant.attributeType.OrgSubChildren) {
                    //    // 机构个数
                    //    row.count = orgidList.length;
                    //} else {
                    //    var idCol = constant.attributeTypeIDColMap[row.attributeType];
                    //    orgList = _.uniq(_.pluck(thisAreaOrgList, idCol));
                    //}

                    //if (orgList && orgList.length > 0) {

                    //    orgList = _.filter(orgList, function (num) {
                    //        if (num) {
                    //            return true;
                    //        } else {
                    //            return false;
                    //        }
                    //    });

                    //    row.count = orgList.length;
                    //}
                });
            };

            // 统计用户数
            var setUserCount = function () {

                $scope.panelArea.userCount = 0;

                if ($scope.userRoleList && $scope.userRoleList.length > 0) {
                    var filterList = _.filter($scope.userRoleList, function (row) {

                        return row.areaID === $scope.panelArea.id;
                    });

                    if (filterList && filterList.length > 0) {
                        var userIdList = _.uniq(_.pluck(filterList, 'id'));
                        $scope.panelArea.userCount = userIdList.length;
                    }
                }
            };

            // 隐藏机构数
            $scope.closeOrgCard = function () {
                $(areaCommonCardID).css('visibility', 'hidden');
            };

            // 显示卡片
            $scope.showCard = function () {
                // parseDataGrid();
                parseDataGridOnlyOrg();
                $scope.isShowCard = true;
                $timeout(function () {
                    $scope.gridApiareaDimensionORGGridList.treeBase.collapseAllRows();
                }, 500);
            };

            // 隐藏机构缩略图
            var hideOrgGeneralInfo = function () {
                $(orgGeneralInfoPopId).hide();
            };

            // 设置UI grid的列
            var setColumns = function () {

                if ($scope.columns.length > 1) {
                    $scope.columns.splice(1);
                }

                if ($scope.statisticAttrList && $scope.statisticAttrList.length > 0) {

                    for (var i = 0; i < $scope.statisticAttrList.length; i++) {
                        var row = $scope.statisticAttrList[i];

                        var index = i + 1;

                        if (row.attributeId === $scope.selectAttribute.attributeId) {
                            continue;
                        }

                        if (row.attributeType === constant.attributeType.SelfDimension) {

                            var str = '<div class="text-align-left text-align-left-padding"><span title="{{row.entity.selfDimension' + index + '}}">{{row.entity.selfDimension' + index + '|limitString:16}}</span></div>';
                            var nameCol = 'selfDimension' + index;

                            var businessUnit = {
                                field: nameCol,
                                name: row.attributeName,
                                headerCellClass: '',
                                cellTemplate: str
                            };

                            $scope.columns.push(businessUnit);
                        } else if (row.attributeType === constant.attributeType.Unknown) {
                            // 未知不做
                        } else if (row.attributeType === constant.attributeType.User) {
                            // 用户不做
                        } else if (row.attributeType === constant.attributeType.OrgSubChildren) {
                            // 机构个数
                        } else if (row.attributeType === constant.attributeType.RegionID) {
                            // 行政省市
                            var str = '<div class="text-align-left text-align-left-padding"><span title="{{row.entity.regionName}}">{{row.entity.regionName|limitString:16}}</span></div>';
                            var nameCol = 'regionName';
                            var businessUnit = {
                                field: nameCol,
                                name: row.attributeName,
                                headerCellClass: '',
                                cellTemplate: str
                            };

                            $scope.columns.push(businessUnit);
                        } else {
                            var idCol = constant.attributeTypeIDColMap[row.attributeType];
                            var nameCol = constant.attributeTypeNameColMap[row.attributeType];

                            var str = '<div class="text-align-left text-align-left-padding"><span title="{{row.entity.' + nameCol +
                                '}}">{{row.entity.' + nameCol + '|limitString:16}}</span></div>';

                            var nameStr = row.attributeName;
                            if (row.attributeType === constant.attributeType.OrgSubChildren ||
                                row.attributeType === constant.attributeType.OrganizationStructure) {
                                nameStr = $translate.instant('OrganizationLevelType');
                            }
                            var businessUnit = {
                                field: nameCol,
                                name: nameStr,
                                headerCellClass: '',
                                cellTemplate: str
                            };

                            $scope.columns.push(businessUnit);
                        }

                    }

                }

            };

            // 设置选中区域地图背景色
            var setMapData = function () {
                $scope.chinaMapOption.series[0].data = [];
                if ($scope.panelArea.provinceNameList &&
                    $scope.panelArea.provinceNameList.length > 0
                ) {
                    var reg = /省$/gi;
                    var cityreg = /市$/gi;


                    var provinceNameList = $scope.panelArea.provinceNameList;

                    provinceNameList.forEach(function (provinceName) {

                        var provinceNameShow = provinceName;
                        if (provinceName === '香港特别行政区') {
                            provinceNameShow = '香港';
                        } else if (provinceName === '澳门特别行政区') {
                            provinceNameShow = '澳门';
                        } else {
                            provinceNameShow = provinceName.replace(reg, '').replace(cityreg, '')
                        }

                        var item = {
                            name: provinceNameShow,
                            itemStyle: {
                                normal: {
                                    areaColor: $scope.panelArea.theme.lightColor
                                }
                            },
                            label: {
                                normal: {
                                    show: true,
                                    textStyle: {
                                        color: '#894A00',
                                        fontWeight: 'normal'
                                    }
                                }
                            }
                        };

                        $scope.chinaMapOption.series[0].data.push(item);

                    });
                };

                $scope.chinaMapChart.setOption($scope.chinaMapOption);
            };

            // choose all area
            var setAllAreaMapData = function () {
                $scope.chinaMapOption.series[0].data = [];
                if ($scope.areaInfoList && $scope.areaInfoList.length > 0) {
                    var reg = /省$/gi;
                    var cityreg = /市$/gi;
                    $scope.areaInfoList.forEach(function (row) {

                        if (row.provinceNameList && row.provinceNameList.length > 0) {
                            var provinceNameList = row.provinceNameList;

                            provinceNameList.forEach(function (provinceName) {

                                var provinceNameShow = provinceName;
                                if (provinceName === '香港特别行政区') {
                                    provinceNameShow = '香港';
                                } else if (provinceName === '澳门特别行政区') {
                                    provinceNameShow = '澳门';
                                } else {
                                    provinceNameShow = provinceName.replace(reg, '').replace(cityreg, '')
                                }

                                var item = {
                                    name: provinceNameShow,
                                    itemStyle: {
                                        normal: {
                                            areaColor: row.theme.lightColor
                                        }
                                    },
                                    label: {
                                        normal: {
                                            show: true,
                                            textStyle: {
                                                color: '#894A00',
                                                fontWeight: 'normal'
                                            }
                                        }
                                    }
                                };

                                $scope.chinaMapOption.series[0].data.push(item);
                            });
                        }
                    });
                }

                $scope.chinaMapChart.setOption($scope.chinaMapOption);
            };

            // 隐藏卡片
            $scope.hideCard = function () {
                $scope.isShowCard = false;
                hideOrgGeneralInfo();
            };

            // 添加区域
            $scope.addRegion = function ($event) {
                $scope.regionOperateType = 'add';
                $scope.isRegionUpdate = false;
                $scope.selectedRegion = null;
                $event.stopPropagation();
            };

            // 编辑区域
            $scope.editRegion = function (areaInfo, $event) {
                $scope.regionOperateType = 'edit';
                $scope.selectedRegion = {
                    id: areaInfo.id
                };

                $scope.isRegionUpdate = false;
                $event.stopPropagation();
            };

            // 添加或者编辑区域成功之后，刷新当前页面的数据
            $scope.$watch('isRegionUpdate', function (newValue, oldValue) {
                if (newValue) {
                    getAreaStatistics();
                }
            });

            // 添加机构
            $scope.addOrg = function ($event) {
                $scope.orgOperateType = 'add';

                $scope.newOrganization = {
                    areaID: $scope.panelArea.id,
                    areaName: $scope.panelArea.name
                };

                $scope.selectedOrg = null;
                $event.stopPropagation();
            };

            //添加现有机构到当前的维度
            $scope.addExistOrg = function () {
                $scope.selectedKeyItems = [];

                var selectedKeyItem = $scope.panelArea.organizationIDList;

                $scope.selectedKeyItems = selectedKeyItem;
                $scope.addExistOrgOperateType = constant.Operation.Add;
                $scope.addExistOrgIsUpdate = false;
                $scope.addExistOrgDimensionValueID = $scope.panelArea.id;

            };

            // add exist org succes and refresh page
            $scope.$watch('addExistOrgIsUpdate', function (newValue, oldValue) {
                if (newValue) {

                    if ($scope.selectedExistOrgList && $scope.selectedExistOrgList.length > 0) {
                        orgService.updateOrgToDimension($scope.panelArea.id, $scope.parentDimensionID, $scope.selectedExistOrgList).success(function (data) {
                            if (data && !data.result) {

                                SweetAlert.warning($translate.instant(data.resultMsg));
                                return;
                            }

                            SweetAlert.success($translate.instant('SaveSuccess'));
                            getAreaStatistics();
                        });
                    }
                }
            });

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    init();
                }
            });

            //自定义显示内容修改
            $scope.$watch('isAttributeUpdate', function (newValue, oldValue) {
                if (newValue) {
                    getAreaStatistics();
                }
            });

            // 获取所有机构
            var getAllOrgList = function () {

                // var organizationList = [];

                // {
                //     areaList:[{
                //             id:'',
                //             name:'',
                //             cityStatistics:[
                //                 {
                //                     RegionID:'',
                //                     AreaID:'',
                //                     Name:'',
                //                     ProvinceName:'',
                //                     Longitude:'',
                //                     Latitude:'',
                //                 },
                //             ]
                //     }]
                //     organizationList:[{
                //             ID:'',
                //             Name:'',
                //             ParentID:'',
                //             BusinessUnitID:'',
                //             BusinessUnitName:'',
                //             UserCount:'',
                //             RegionID:'',
                //             IndustryID:'',
                //             IndustryName:'',
                //             StructureID:'',
                //             StructureName:'',
                //     }]
                // }

                if ($scope.originalData && $scope.originalData.areaList.length > 0) {
                    $scope.originalData.areaList.forEach(function (area) {
                        if (area.cityStatistics && area.cityStatistics.length > 0) {
                            area.cityStatistics.forEach(function (city) {
                                city.organizationBusinessUnitStatistics = _.filter($scope.originalData.organizationList, function (org) {
                                    return org.cityID === city.regionID;
                                });
                            });
                        }

                    });
                };

                return $scope.originalData.organizationList;
            };

            // 以区域划分s属性
            var showDimensionByArea = function (idcol, namecol, dimensionName, attributeId) {
                // 第一个纬度始终是区域
                $scope.organizationList = _.sortBy($scope.organizationList, 'areaName');
                var structureidList = _.uniq(_.pluck($scope.organizationList, 'areaID'));
                $scope.areaInfoList = [];
                var structureList = [];
                if ($scope.originalData.areaList && $scope.originalData.areaList.length > 0) {

                    $scope.originalData.areaList.forEach(function (row) {
                        var model = {};
                        model.id = row.id;
                        model.name = row.name;
                        model.organizationCount = 0;
                        model.userCount = row.userCount;
                        if (!model.name) {
                            model.name = defaultValue.unknownArea;
                            model.id = '';
                        }

                        var areaIDList = _.uniq(_.pluck(row.cityStatistics, 'areaID'));

                        var matchOrgList = _.filter($scope.organizationList, function (num) {
                            return num.areaID === row.id;
                        });

                        model.cityStatistics = [];

                        if (matchOrgList && matchOrgList.length > 0) {

                            model.orgIDList = _.pluck(matchOrgList, 'id');
                            if (attributeId) {
                                model.cityStatistics = getSelfAttributeCityStatistics(attributeId, matchOrgList);
                            } else {
                                model.cityStatistics = getSystemAttributeCityStatistics(row, idcol, namecol, matchOrgList);
                            }

                            $scope.areaInfoList.push(model);

                            model.organizationCount = matchOrgList.length;
                        }
                    });
                }

                // 未设置部分
                var notsetOrgList = _.filter($scope.organizationList, function (org) {
                    return !org.areaID;
                });

                if (notsetOrgList && notsetOrgList.length > 0) {
                    var model = {};
                    // model.id = 'noset' + idcol;
                    model.name = defaultValue.notSetAttribute;

                    if (attributeId) {
                        model.cityStatistics = getSelfAttributeCityStatistics(attributeId, notsetOrgList);
                    } else {
                        model.cityStatistics = getSystemAttributeCityStatistics(idcol, namecol, notsetOrgList);
                    }

                    $scope.areaInfoList.push(model);
                }

                renderUI();
            };

            // 按照系统属性构造数据
            var getSystemAttributeCityStatistics = function (area, idcol, namecol, matchOrgList) {
                var cityStatistics = [];
                if (!matchOrgList || matchOrgList.length === 0) {
                    return cityStatistics;
                }

                matchOrgList = sortAttribute(matchOrgList, namecol);

                var attributeList = [];


                if (idcol === 'businessUnitID') {
                    // 事业部
                    attributeList = $scope.originalData.businessUnitList;

                } else if (idcol === 'structureID') {

                    // 行业
                    attributeList = $scope.originalData.organizationStructureList;

                } else if (idcol === 'industryID') {
                    // 机构层级
                    attributeList = $scope.originalData.industryList;

                } else if (idcol === 'cityID') {

                    if (area.cityStatistics && area.cityStatistics.length > 0) {
                        area.cityStatistics.forEach(function (city) {
                            var cityItem = {};
                            cityItem.organizationBusinessUnitStatistics = _.filter(matchOrgList, function (org) {
                                return org.cityID === city.regionID;
                            });;
                            cityItem.name = city.name;
                            cityItem.id = city.regionID;
                            cityStatistics.push(cityItem);
                        });
                    }

                    return cityStatistics;
                }

                var setOrgIDList = [];
                if (attributeList && attributeList.length > 0) {
                    attributeList.forEach(function (attr) {
                        var cityItem = {};
                        cityItem.organizationBusinessUnitStatistics = _.filter(matchOrgList, function (num) {
                            return num[idcol] === attr.id;
                        });

                        cityItem.name = attr.name;
                        cityItem.id = attr.id;

                        if (cityItem.organizationBusinessUnitStatistics && cityItem.organizationBusinessUnitStatistics.length > 0) {
                            var orgidList = _.pluck(cityItem.organizationBusinessUnitStatistics, 'id');
                            setOrgIDList = _.union(setOrgIDList, orgidList);
                        }

                        cityStatistics.push(cityItem);
                    });

                    if (setOrgIDList && setOrgIDList.length === matchOrgList.length) {
                        // 全部设置完毕
                    } else {
                        // 未设置
                        var cityItem = {};
                        cityItem.id = idcol + 'notSet';
                        cityItem.name = defaultValue.notSetAttribute;
                        cityItem.organizationBusinessUnitStatistics = _.filter(matchOrgList, function (org) {
                            return setOrgIDList.indexOf(org.id) === -1;
                        });

                        cityStatistics.push(cityItem);
                    }
                }

                return cityStatistics;
            };

            // 按照自定义属性去构造数据
            var getSelfAttributeCityStatistics = function (attributeId, matchOrgList) {
                var dimensionId = $scope.statisticAttrList[0].belongDimensionId;
                var targetDimensionValueList = _.filter($scope.dimensionOrgList, function (data) {
                    return data.dimensionId === dimensionId;
                });
                var dimensionVauleIDList = _.uniq(_.pluck(targetDimensionValueList, 'dimensionValueID'));

                var cityStatistics = [];

                var setOrgIDList = [];
                if (dimensionVauleIDList && dimensionVauleIDList.length > 0) {
                    dimensionVauleIDList.forEach(function (valueID) {
                        var cityItem = {};
                        var relaventOrgList = _.filter(targetDimensionValueList, function (org) {
                            return org.dimensionValueID === valueID;
                        });

                        if (relaventOrgList && relaventOrgList.length > 0) {
                            cityItem.name = relaventOrgList[0].dimensionValue;

                            var orgidList = _.uniq(_.pluck(relaventOrgList, 'organizationID'));

                            cityItem.organizationBusinessUnitStatistics = _.filter(matchOrgList, function (num) {
                                return orgidList.indexOf(num.id) > -1;
                            });

                            if (orgidList && orgidList.length > 0) {
                                setOrgIDList = _.union(setOrgIDList, orgidList);
                            }

                            cityStatistics.push(cityItem);
                        }

                    });
                }

                if (setOrgIDList.length === matchOrgList.length) {
                    // 全部设置好属性的
                } else {

                    var notSetAttributeList = _.filter(matchOrgList, function (org) {
                        return setOrgIDList.indexOf(org.id) === -1;
                    });

                    if (notSetAttributeList && notSetAttributeList.length > 0) {
                        var cityItem = {};
                        cityItem.name = defaultValue.notSetAttribute;
                        cityItem.organizationBusinessUnitStatistics = notSetAttributeList;
                        cityStatistics.push(cityItem);
                    }

                }

                return cityStatistics
            };

            // 切换主 纬度的时候， 渲染UI
            var renderUI = function () {
                generateID();
                $scope.hideCard();
                //setColumns();


                // default choose all area
                var findArea = null;
                if ($scope.panelArea && $scope.panelArea.id) {

                    findArea = _.find($scope.areaInfoList, function (row) {
                        return row.id === $scope.panelArea.id;
                    });
                }

                if (findArea) {
                    $scope.chooseArea(findArea);
                } else {
                    $scope.chooseAllArea();
                }

            };

            // 获取所有机构设置的自定义纬度
            var getAllDimensionOrgList = function () {
                dimensionService.getAllDimensionOrgList().success(function (data) {
                    $scope.dimensionOrgList = data;
                });
            };

            // 初始化数据
            var init = function () {
                // 获取区域统计数据
                getAreaStatistics();

                // 获取所有机构设置的自定义纬度
                getAllDimensionOrgList();
            };

            // 排序方法，包含中英文
            var sortAttribute = function (data, colName) {
                if (data && data.length > 0) {
                    try {
                        var charList = [];
                        var nocharList = [];
                        var digitalReg = /^\d+/;
                        var charReg = /^[a-zA-Z]+/;
                        data.forEach(function (row) {
                            if (digitalReg.test(row[colName]) || charReg.test(row[colName])) {
                                charList.push(row);
                            } else {
                                nocharList.push(row);
                            }

                        });

                        charList = _.sortBy(charList, colName);

                        nocharList = nocharList.sort(function compareFunction(param1, param2) {
                            return param1[colName].localeCompare(param2[colName]);
                        });

                        var all = _.union(charList, nocharList);
                        return all;
                    } catch (e) {
                        $log.debug("sort exception:" + e);
                    }
                }

                return data;
            };

            // 出事化参数
            var initParams = function () {
                $scope.orgIdGeneralInfo = null;
                $scope.isRenderCompletedGeneralInfo = false;
                $scope.isShowUserCard = false;
                $scope.isShowCard = false;
                $scope.isShowOrgCard = false;
                $scope.isChooseAllArea = true;
            };

            // 显示机构缩略图，并设置好位置
            var showOrgCard = function (pop, row, topOffset, leftOffset) {

                pop.css("display", "block");
                var top = window.innerHeight - pop.height();
                if (row.offset().top + topOffset < window.innerHeight - pop.height()) {
                    top = row.offset().top + topOffset;
                }

                pop.css('top', top + 'px');

                var left = window.innerWidth - pop.width();
                if (row.offset().left + leftOffset < window.innerWidth - pop.width()) {
                    left = row.offset().left - leftOffset;
                }

                pop.css('left', left + 'px');

                pop.show();

                $(document).one('click', function () {
                    hideOrgGeneralInfo();
                });
            };

            //show自定义显示属性
            $scope.showCustomAttriute = function () {

                $scope.statisticAttrListCopy = $scope.statisticAttrList;
                $scope.attributeOperateType = constant.Operation.Edit;
                $scope.showAttributeDimensionID = $scope.parentDimensionID;
                $scope.isAttributeUpdate = false;
            };

            // 获取机构区域统计
            var getAreaStatistics = function () {
                orgService.getAreaStatistics().success(function (data) {
                    $scope.originalData = data;
                    $scope.organizationList = data.organizationList;
                    $scope.areaInfoList = data.areaList;

                    $scope.statisticAttrList = data.attributeList;

                    renderUI();
                    //getStatisticAttribute();
                });
            };

            // 获取设置过的纬度值
            var getStatisticAttribute = function () {
                statisticAttributeService.getByParentDimensionID($scope.parentDimensionID).success(function (data) {
                    if (data) {

                        //$scope.statisticAttrList = data;
                        //renderUI();
                        // switchByCustomAttriute();
                    }
                });
            };


            $scope.userBUSetting = function () {
                $scope.userBUOperateType = constant.Operation.Edit;
                $scope.userBUIsUpdate = false;
                $scope.userBUDimensionID = $scope.parentDimensionID;
                $scope.userBUDimensionValueID = $scope.panelArea.id; //dimensionValueID，如事业部1，事业部2，产品线1 等
            };

            // 获取用户权限
            var getUserPermission = function () {

                var list = [];
                var editRegionCode = constant.adminPermission.basicData.areaManage.editCode;
                var orgPermission = constant.adminPermission.infrastructure.organizationManage.addCode;
                //自定义显示属性的权限
                var tempAttr = constant.adminPermission.infrastructure.customAttribute;
                list.push(editRegionCode);
                list.push(orgPermission.addCode);
                list.push(orgPermission.editCode);
                list.push(tempAttr.queryCode);

                //权限设置的权限
                var tempAcess = constant.adminPermission.infrastructure.accessSetting;
                list.push(tempAcess.queryCode);
                list.push(tempAcess.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasEditRegionPermission = data[editRegionCode];
                    $scope.hasAddOrgPermission = data[orgPermission.addCode];
                    $scope.hasEditOrgPermission = data[orgPermission.addCode];
                    $scope.hasAttributeQueryPermission = data[tempAttr.queryCode];


                    $scope.hasAccessSettingQueryPermission = data[tempAcess.queryCode];
                    $scope.hasAccessSettingEditPermission = data[tempAcess.editCode];
                });
            };

            //用户权限更新，刷新orgchart
            $scope.$watch('userBUIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    showUserSumCard();
                    $scope.userBUIsUpdate = false;
                }
            });

            // UI 服务
            var thisCardService = {

                closeALLCard: function () {

                    // 用户和机构卡片
                    $('.card').css('visibility', 'hidden');

                    // 机构general
                    $(orgGeneralInfoPopId).hide();
                } 
            };

            (function initialize() {
                $log.debug('OrganizationAreaViewController.ctor()...' + $state.params.dimensionId);
                $log.debug($state.params.dimensionId);
                var dimensionId = constant.dimensionId.areaID;

                $scope.parentDimensionID = $state.params.dimensionId || dimensionId;
                $scope.showAttributeDimensionID = $scope.parentDimensionID;
                $scope.panelArea = {};
                getUserPermission();

                // uigrid 定义
                init();

                initParams();

                // 总机构数统计
                areaORGGridInit();

                // 初始化维度展示列表
                areaDimensionORGGridListInit();

                // 用户卡片里面的devGrid
                initUserSumDevGrid();

                $scope.userRoleList = [];

                drawChinaMap();

                $scope.forceOrgUpdate = false;
            })();
        }
    ]);
