﻿infrastructureModule
    .controller('organizationBusinessUnitViewController', ['$scope', '$log', 'SweetAlert', '$translate', 'uiGridTreeViewConstants', 'uiGridConstants', '$timeout', 'orgService', 'statisticAttributeService', 'dimensionService', '$state', '$stateParams', '$interval', 'roleService', '$q','userService',
        function ($scope, $log, SweetAlert, $translate, uiGridTreeViewConstants, uiGridConstants, $timeout, orgService, statisticAttributeService, dimensionService, $state, $stateParams, $interval, roleService, $q, userService) {
            'use strict';
            // 机构缩略图ID
            var orgGeneralInfoPopId = '#orgGeneralInfoPop';

            var template = {
                topNodeTemplate: $("#dimension-topNode").html(),  //最顶层节点
                nameNodeEdit: $("#dimension-node-name-edit").html(),  //机构名称
                nameNodeQuery: $("#dimension-node-name-query").html(),  //机构名称
                hightNode: $("#dimension-hight-node").html(), //子分公司，高亮部分
                rowNode: $("#dimension-row-node").html() //普通行
            };

            var ReplaceObj = {
                //顶部节点
                topNodeName: '{{#topNodeName#}}',
                //事业部名称
                dimensionValue: '{{#dimensionValue#}}',
                dimensionValueID: '{{#dimensionValueID#}}',
                createNewOrg: '{{#AddOrganization#}}',
                addExistOrg: '{{#AddExistOrganization#}}',
                //高亮部分统计
                //hightNodeCount: '{{#dimensionValueCount#}}', //比如 '100'
                //hightNodeName: '{{#attributeName#}}',   //比如'分公司'
                //普通维度统计
                attributeId: '{{#attributeId#}}',
                attributeName: '{{#attributeName#}}',  //维度名字，如用户数，覆盖区域，所属行业等
                attributeValueCount: '{{#attributeValueCount#}}',      //对于维度的统计
                attributeType: '{{#attributeType#}}'             //维度的类型区分值，如1:事业部，2:分公司
            };

            var showWarning = function (resultMsg) {

                var errMsg = $translate.instant(resultMsg);
                SweetAlert.warning(errMsg);
            };

            var showSuccessMsg = function (resultMsg) {

                var errMsg = $translate.instant(resultMsg);
                SweetAlert.success(errMsg);
            };

            var createNewOrg = $translate.instant('AddOrganization');
            var addExistOrg = $translate.instant('AddExistOrganization');
            var unassisgnText = $translate.instant('UnAssignText');
            $scope.unassisgnText = unassisgnText;
            //构造Echart模板，并且初始化数据
            var PopulateChartDatasource = function () {
                //如果没有编辑维度值的权限，则不显示编辑的笔icon
                var templateNameNode = template.nameNodeQuery;
                if ($scope.hasDimensionValueEditPermission) {
                    templateNameNode = template.nameNodeEdit;
                };

                orgService.getOrgDashboard($scope.parentDimensionID).success(function (data) {
                    //重置 orgchart
                    $scope.renderOrgChart({});

                    if (data !== undefined && data !== null && data.length > 0) {
                        //console.log(JSON.stringify(data));
                        var topNodeName = template.topNodeTemplate.replace(ReplaceObj.topNodeName, $scope.parentDimensionName);

                        var datascource = {
                            'name': topNodeName,
                            'children': []
                        };

                        data.forEach(function (row) {
                            var temp = [];
                            var node = {
                                'name': templateNameNode.replaceToEnd(ReplaceObj.dimensionValue, row.dimensionValue)
                                    .replaceToEnd(ReplaceObj.dimensionValueID, row.dimensionValueID),

                                'title': (function () {

                                    row.orgDtoList.forEach(function (item, index) {

                                        if (index == 0) //第一条数据为高亮数据
                                        {
                                            temp = template.hightNode.replaceToEnd(ReplaceObj.attributeName, item.attributeName)
                                                .replaceToEnd(ReplaceObj.attributeValueCount, item.attributeValueCount)
                                                .replaceToEnd(ReplaceObj.dimensionValueID, row.dimensionValueID)
                                                .replaceToEnd(ReplaceObj.dimensionValue, row.dimensionValue)
                                                .replaceToEnd(ReplaceObj.attributeId, item.attributeId)
                                                .replaceToEnd(ReplaceObj.createNewOrg, createNewOrg)
                                                .replaceToEnd(ReplaceObj.addExistOrg, addExistOrg)
                                               .replaceToEnd(ReplaceObj.attributeType, item.attributeType);
                                        }
                                        else {
                                            temp += template.rowNode.replaceToEnd(ReplaceObj.attributeName, item.attributeName)
                                                  .replaceToEnd(ReplaceObj.attributeValueCount, item.attributeValueCount)
                                                  .replaceToEnd(ReplaceObj.dimensionValueID, row.dimensionValueID)
                                                  .replaceToEnd(ReplaceObj.dimensionValue, row.dimensionValue)
                                                 .replaceToEnd(ReplaceObj.attributeId, item.attributeId)
                                                 .replaceToEnd(ReplaceObj.attributeType, item.attributeType);
                                        }
                                    });
                                    return temp;

                                })()
                            }

                            datascource.children.push(node);
                        });

                        //生成orgchart
                        $scope.renderOrgChart(datascource);
                    }
                });
            };

            //将角色列表换成逗号分隔
            var formatRoleList = function (roleInfoList) {
                var newList = "";
                roleInfoList.forEach(function (row) {
                    if (row) {
                        newList += row.name + constant.comma;
                    }
                });
                if (newList.length > 0) {
                    newList = newList.substr(0, newList.length - 1);
                }

                return newList;
            };


            var array_unique = function (array) {
                var unique = [];
                for (var i = 0 ; i < array.length ; ++i) {
                    if (unique.indexOf(array[i]) == -1)
                        unique.push(array[i]);
                }
                return unique;
            }

            //用户卡片弹框
            var getUserStatisCard = function (dimensionValueID, dimensionValue, attributeName, attributeId) {

                $scope.userBUDimensionValueID = dimensionValueID;
                $scope.dimensionValue = dimensionValue;
                $scope.attributeName = attributeName;

                userService.getDimensionUserRoleList($scope.parentDimensionID, dimensionValueID).success(function (data) {
                    if (data) {

                        var groupByRole = _.groupBy(data, function (item) {
                            return item.roleID;
                        });

                        var dataRoleList = _.map(groupByRole, function (group) {
                            return {
                                roleID: group[0].roleID,
                                roleName: group[0].roleName
                            }
                        });
                        //角色下面，多少个用户
                        var roleSource = [];
                        dataRoleList.forEach(function (row) {
                            var filterData = _.filter(data, function (item) { return item.roleID == row.roleID; });
                            var userData = array_unique(_.pluck(filterData, 'userID'));  //用户下 去重复，一个用户，2个机构，同一个角色，统计算一个角色
                            var roleName = row.roleName;
                            var object = {
                                name: roleName,
                                count: userData.length
                            }
                            roleSource.push(object);
                        });

                        $scope.roleCountDataSource = roleSource;

                        //用户下面多个角色，多少个机构
                        var groupByUser = _.groupBy(data, function (item) {
                            return item.userID;
                        });

                        var dataUserList = _.map(groupByUser, function (group) {
                            return {
                                userID: group[0].userID,
                                userName: group[0].userName
                            }
                        });

                        var userSource = [];
                        dataUserList.forEach(function (row) {
                            var filterData = _.filter(data, function (item) { return item.userID == row.userID; });
                            var roleNames = array_unique(_.pluck(filterData, 'roleName')); //用户下的角色
                            var orgIDList = array_unique(_.pluck(filterData, 'orgID')); //用户下的访问机构数

                            var object = {
                                userID: row.userID,
                                userName: row.userName,
                                roleInfo: roleNames.join(constant.comma),
                                orgCount: orgIDList.length
                            }
                            userSource.push(object);
                        });

                        $scope.userDatagridDataSource = userSource;

                    }
                });
            };

            //所属行业弹框,也是通用模板
            var getCommonCard = function (dimensionValueID, dimensionValue, attributeName, attributeId) {
                var deferred = $q.defer();
                $scope.gridApi.treeBase.collapseAllRows();
                $scope.commonUIGridList.data = [];
                //参数，维度值的ID，如事业部1，事业部2 ，然后是顶层事业部，如事业部
                orgService.getOrgCustomDashbord(dimensionValueID, $scope.parentDimensionID, attributeId).success(function (data) {
                    if (data) {
                        //console.log(JSON.stringify(data));
                        data.orgDtoList.forEach(function (row) {
                            if (row.level != null) {
                                row.$$treeLevel = parseInt(row.level);
                            }
                        });

                        $scope.orgCustomList = data.orgCustomDtoList;
                        $scope.orgList = data.orgDtoList;

                        for (var i = 0; i < $scope.orgList.length; i++) {
                            var row = $scope.orgList[i];

                            //自定义显示属性
                            if ($scope.attributeList && $scope.attributeList.length > 0) {

                                for (var j = 0; j < $scope.attributeList.length; j++) {
                                    //只有是自定义的属性才构造新列
                                    if ($scope.attributeList[j].attributeType === constant.attributeType.SelfDimension) {
                                        var targetVaule = _.find($scope.orgCustomList, function (data) {
                                            return data.orgID === row.orgID && data.dimensionId === $scope.attributeList[j].belongDimensionId;
                                        });

                                        if (targetVaule) {
                                            row["selfDimension" + j] = targetVaule.dimensionValueName;
                                        } else {
                                            row["selfDimension" + j] = '';
                                        }
                                    }
                                }
                            }
                        };

                        $scope.dimensionValue = dimensionValue;
                        $scope.attributeName = attributeName;
                        $scope.commonUIGridList.data = $scope.orgList;
                        $scope.commonCountDataSource = data.orgCountList;
                        //console.log("Org: "+JSON.stringify($scope.orgList));
                        // console.log("cusomer:" + JSON.stringify(data.orgCustomDtoList));
                        //console.log("111:" + JSON.stringify($scope.attributeList));
                        //console.log("orgcountList:" + JSON.stringify(data.orgCountList));
                        deferred.resolve(data);
                    }
                });

                return deferred.promise;
            };

            //ng-repeat,根据字符串转换为json对象
            var getJson = function (obj) {
                if (obj) {
                    return JSON.parse(obj);
                }
            };

            var initOrgChartData = function () {
                PopulateChartDatasource();
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    notifyTopPage();
                }
            });

            // 添加或者编辑事业部成功之后，刷新当前页面的数据
            $scope.$watch('isBusinessUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    notifyTopPage();
                }
            });

            // 添加或者编辑机构层级成功之后，刷新当前页面的数据
            $scope.$watch('isOrgStructureUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    notifyTopPage();
                }
            });

            //自定义显示属性更新后，刷新当前页面的orgchart
            $scope.$watch('isAttributeUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    populateUIGridColumns();
                }
            });

            //自定义维度值(添加)更新后，刷新当前页面的orgchart
            $scope.$watch('isDimensionValueUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    notifyTopPage();
                }
            });

            //用户权限更新，刷新orgchart
            $scope.$watch('userBUIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                }
            });

            //添加现有机构
            $scope.$watch('addExistOrgIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectedExistOrgList && $scope.selectedExistOrgList.length > 0) {
                        // console.log(JSON.stringify($scope.selectedExistOrgList));
                        UpdateOrgToDimensionValue($scope.selectedExistOrgList).then(function (data) {
                            if (data) {
                                initOrgChartData();
                                notifyTopPage();
                            }
                        });
                    }
                }
            });

            //顶部的维度状态改变，更新orgchart
            $scope.$on('DimensionUpdate', function (event, data) {
                initOrgChartData();
                setParentDimension();
            })

            //通知父层去更新统计
            var notifyTopPage = function () {
                $scope.$emit("hasDimensionUpdated", { isupdated: true });
            };


            //添加现有机构到当前维度
            var UpdateOrgToDimensionValue = function (existOrgList) {
                var deferred = $q.defer();
                orgService.updateOrgToDimension($scope.addExistOrgDimensionValueID, $scope.parentDimensionID, existOrgList).success(function (data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            };

            // 新增机构
            $scope.editOrg = function (buID) {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.selectedOrg = null;
                $scope.isOrgUpdate = false;
                $scope.organization = {
                    businessUnitID: buID
                };
            };
            //添加现有机构到当前的维度
            $scope.addExistOrg = function (demensionValueID, attributeId) {
                $scope.selectedKeyItems = [];

                getCommonCard(demensionValueID, '', '', attributeId).then(function (data) {

                    var selectedKeyItem = [];
                    $scope.commonUIGridList.data.forEach(function (row) {
                        selectedKeyItem.push(row.orgID);
                    });
                    $scope.selectedKeyItems = selectedKeyItem;
                    $scope.addExistOrgOperateType = constant.Operation.Add;
                    $scope.addExistOrgIsUpdate = false;
                    $scope.addExistOrgDimensionValueID = demensionValueID;
                });
            };

            //编辑事业部
            $scope.editBu = function (buID) {
                $scope.orgOperateBusinessType = constant.Operation.Edit;
                $scope.businessUnitID = buID;
                $scope.isBusinessUpdate = false;
            };

            //编辑机构层级
            $scope.editOrgStructureType = function (selectedId) {
                $scope.orgOperateOrgStructureType = constant.Operation.Edit;
                $scope.selectedOrgStructureID = selectedId;
                $scope.isOrgStructureUpdate = false;
            };

            //添加事业部,机构层级，自定义维度的值等等
            $scope.addDimensionValue = function () {
                if ($scope.parentDimensionType == constant.dimensionType.BusinessUnit) {
                    $scope.orgOperateBusinessType = constant.Operation.Add;
                    $scope.businessUnitID = null;
                    $scope.isBusinessUpdate = false;
                }
                if ($scope.parentDimensionType == constant.dimensionType.OrganizationStructure) {
                    $scope.orgOperateOrgStructureType = constant.Operation.Add;
                    $scope.selectedOrgStructureID = null;
                    $scope.isOrgStructureUpdate = false;
                }
                else if ($scope.parentDimensionType == constant.dimensionType.SelfDimension) {
                    $scope.dimensionValueOperateType = constant.Operation.Add;
                    $scope.dimensionId = $scope.parentDimensionID;
                    $scope.dimensionName = $scope.parentDimensionName;
                    $scope.isDimensionValueUpdate = false;
                    $scope.selectedDimensionValueID = null;
                }
            };

            //编辑自定义显示属性
            $scope.showCustomAttriute = function () {
                $scope.attributeOperateType = constant.Operation.Edit;
                $scope.showAttributeDimensionID = $scope.parentDimensionID;
                $scope.isAttributeUpdate = false;
            };
            //编辑自定义维度的值，功能如编辑事业部的，事业部1，事业部2 的值
            $scope.editCustomDimensionValue = function (dimensionValueID) {
                $scope.dimensionValueOperateType = constant.Operation.Edit;
                $scope.dimensionId = $scope.parentDimensionID;
                $scope.dimensionName = $scope.parentDimensionName;
                $scope.isDimensionValueUpdate = false;
                $scope.selectedDimensionValueID = dimensionValueID;
            };
            //点击机构名称，显示详细信息
            $scope.showOrgGenerateInfo = function (row) {
               // $scope.isRenderCompletedGeneralInfo = false;
                $scope.orgIdGeneralInfo = row.entity.orgID;

                var orgGeneralInfoPopup = $(orgGeneralInfoPopId);
                var rowId = $('#' + row.entity.orgID);
                showOrgCard(orgGeneralInfoPopup, rowId, 30, 50);
            };

            //用户权限设置，乘用车事业部
            $scope.userBUSetting = function () {
                $scope.userBUOperateType = constant.Operation.Edit;
                $scope.userBUIsUpdate = false;
                $scope.userBUDimensionID = $scope.parentDimensionID;
                $scope.userBUDimensionValueID; //dimensionValueID，如事业部1，事业部2，产品线1 等
            };


            //隐藏机构general info
            var hideOrgGeneralInfo = function () {
                $(orgGeneralInfoPopId).hide();
            };

            // 显示机构general info，并设置好位置
            var showOrgCard = function (popCard, row, topOffset, leftOffset) {

                popCard.css("display", "block");

                var top = row.offset().top + topOffset;
                if (top + popCard.height() > window.innerHeight) {
                    top = window.innerHeight - popCard.height() - topOffset;
                    //top = row.offset().top - topOffset - popCard.height();
                }

                popCard.css('top', top + 'px');

                var left = row.offset().left + leftOffset;
                if (left + popCard.width() > window.innerWidth) {
                    left = row.offset().left - popCard.width() - leftOffset;
                }

                popCard.css('left', left + 'px');

                popCard.show();

                $(document).one('click', function (e) {
                    hideOrgGeneralInfo();
                });
            };

            var InitDXDataGrid = function () {
                loadUserDatagrid();
            };


            //构造用户datagrid
            var loadUserDatagrid = function () {

                $scope.userdatagridOptions = {
                    bindingOptions: {
                        dataSource: 'userDatagridDataSource'
                    },
                    selection: {
                        mode: "single"
                    },
                    columns: [
                        {
                            dataField: "userName",
                            caption: $translate.instant('UserDesc'),
                            width:"30%",
                            cellTemplate: function (container, options) {
                                try {
                                    $('<a>' + options.value + '</a>')
                                        .attr('href', '#/userDetail/' + options.row.data.userID)
                                        .appendTo(container);
                                }
                                catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "roleInfo",
                            caption: $translate.instant('Role'),
                            width: "50%",
                        },
                        {
                            dataField: "orgCount",
                            caption: $translate.instant('OrganizationCount'),
                            alignment: 'center',
                            width: "20%",

                        },
                    ],
                    loadPanel: {
                        enabled: false
                    },
                    scrolling: {
                        mode: "virtual"
                    },
                    allowColumnResizing: true,
                    noDataText: $translate.instant('NoDataText'),
                    showColumnLines: false,
                    showRowLines: false,
                    rowAlternationEnabled: true,
                    showBorders: false,
                    sorting: {
                        mode: "none"
                    }
                };
            };


            //根据自定义维度设置显示的卡片的列
            var populateUIGridColumns = function () {
                //获取维度值数据
                statisticAttributeService.getByParentDimensionID($scope.parentDimensionID).success(function (result) {
                    if (result) {

                        $scope.attributeList = result;
                        var column = {};
                        $scope.uigridColumns.splice(1);

                        var index = 0;
                        result.forEach(function (attr) {
                            if (attr.attributeType == constant.attributeType.BusinessUnit) {
                                column = {
                                    field: 'businessUnitName',
                                    name: attr.attributeName,
                                    headerCellClass: 'text-align-left',
                                    cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.businessUnitName}}">{{row.entity.businessUnitName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.OrganizationStructure) {
                                column = {
                                    type: 'string',
                                    field: 'structureName',
                                    name: attr.attributeName,
                                    headerCellClass: 'text-align-left',
                                    cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.structureName}}">{{row.entity.structureName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.Industry) {
                                column = {
                                    type: 'string',
                                    field: 'industryName',
                                    name: attr.attributeName,
                                    headerCellClass: 'text-align-left',
                                    cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.industryName}}">{{row.entity.industryName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.Area) {
                                column = {
                                    type: 'string',
                                    field: 'areaName',
                                    name: attr.attributeName,
                                    headerCellClass: 'text-align-left',
                                    cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.areaName}}">{{row.entity.areaName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.SelfDimension) {
                                var column = {
                                    field: 'selfDimension' + index,
                                    name: attr.attributeName,
                                    headerCellClass: 'text-align-left',
                                    cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.selfDimension' + index + '}}">{{row.entity.selfDimension' + index + '}}</span></div>'
                                };

                                $scope.uigridColumns.push(column);
                            }

                            index++;
                        });
                    }
                });

            };
            var initUIGrid = function () {
                commonUIGridInit();
                populateUIGridColumns();
            };

            //设置维度的名称和值，和类型
            var setParentDimension = function () {
                var deferred = $q.defer();
                dimensionService.getDimensionById($scope.parentDimensionID).success(function (data) {
                    if (data) {
                        $scope.parentDimensionName = data.name;
                        $scope.parentDimensionType = data.dimensionType;
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            }

            //通用的ui grid 模板
            var commonUIGridInit = function () {
                $scope.uigridColumns = [{
                    field: 'orgName',
                    name: $translate.instant('OrganizationName'),
                    //cellTemplate: '<div ng-mouseover="grid.appScope.showOrgGenerateInfo(row)" ng-class="{true: \'text-align-left\', false: \'text-align-left-padding\'}[row.entity.level==' + constant.level.First + ']">\
                    //<a title="{{row.entity.orgName}}" href="#/organization/{{row.entity.orgID}}" target="_blank" id="{{row.entity.orgID}}">{{row.entity.orgName|limitString:16}}</a>\
                    //</div>'
                    cellTemplate: '<div ng-class="{true: \'text-align-left\', false: \'text-align-left-padding\'}[row.entity.level==' + constant.level.First + ']"><span title="{{row.entity.orgName}}" id="{{row.entity.orgID}}" ng-click="grid.appScope.showOrgGenerateInfo(row)">{{row.entity.orgName==null||row.entity.orgName==""?"' + unassisgnText + '":row.entity.orgName}}</span></div>'
                }
                ];

                $scope.commonUIGridList = {
                    data:[],
                    enableRowSelection: true,
                    enableSelectAll: false,
                    rowHeight: 30,
                    enableRowHeaderSelection: false,
                    modifierKeysToMultiSelect: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,

                    enableColumnResizing: true,
                    enableSorting: true,
                    enableColumnMenus: false,
                    enableFiltering: false,
                    showTreeExpandNoChildren: false,
                    enableFullRowSelection: true, //是否点击行任意位置后选中,默认为false
                    multiSelect: false, // 是否可以选择多个,默认为true; 
                    columnDefs: $scope.uigridColumns,

                    onRegisterApi: function (gridApi) {

                        $scope.gridApi = gridApi;

                        //$scope.gridSelectCount = $scope.gridApi.selection.getSelectedRows().length;

                        // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                        $interval(function () {
                            $scope.gridApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);

                    }
                };

            };

            //权限check
            var checkUserPermission = function () {

                var list = [];
                $scope.hasAddPermission = false;
                $scope.hasQueryPermission = false;
                $scope.hasEditPermission = false;

                $scope.hasAttributeQueryPermission = false;

                $scope.hasAccessSettingQueryPermission = false;
                $scope.hasAccessSettingEditPermission = false;
           
                //查看机构的权限
                var tempOrg = constant.adminPermission.infrastructure.organizationManage;
                list.push(tempOrg.addCode);
                list.push(tempOrg.queryCode);
                list.push(tempOrg.editCode);

                //自定义显示属性的权限
                var tempAttr = constant.adminPermission.infrastructure.customAttribute;
                list.push(tempAttr.queryCode);

                //权限设置的权限
                var tempAcess = constant.adminPermission.infrastructure.accessSetting;
                list.push(tempAcess.queryCode);
                list.push(tempAcess.editCode);

                $scope.hasDimensionValueEditPermission = false;
                  //编辑自定义维度值的时候的权限
                if ($scope.parentDimensionType == constant.dimensionType.BusinessUnit) {
                    var tempDV = constant.adminPermission.basicData.businessUnit;
                    list.push(tempDV.editCode);
                }
                else {
                    //自定义维度的权限
                    var tempDV = constant.adminPermission.basicData.selfDimension;
                    list.push(tempDV.editCode);
                }

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    // console.log('data: ' + JSON.stringify(data));
                    $scope.hasAddPermission = data[tempOrg.addCode];
                    $scope.hasQueryPermission = data[tempOrg.queryCode];
                    $scope.hasEditPermission = data[tempOrg.editCode];

                    $scope.hasAttributeQueryPermission = data[tempAttr.queryCode];

                    $scope.hasAccessSettingQueryPermission = data[tempAcess.queryCode];
                    $scope.hasAccessSettingEditPermission = data[tempAcess.editCode];

                    $scope.hasDimensionValueEditPermission = data[tempDV.editCode];

                    if ($scope.hasQueryPermission) {
                        initOrgChartData();
                    }
                });
            };


            (function initialize() {
                $log.debug('organizationBusinessUnitViewController.ctor()...');
                $log.debug($state.params.dimensionId);
                var dimensionId = 'c61a5bd6-a996-4952-9869-d053995237e5'; //集团为事业部
                //  $scope.parentDimensionID = $state.params.dimensionId || 'c61a5bd6-a996-4952-9869-d053995237e8';
                var parentDimensionID = $state.params.dimensionId || dimensionId;
                $scope.parentDimensionID = parentDimensionID;
                $scope.showAttributeDimensionID = $scope.parentDimensionID;
                initUIGrid();
                InitDXDataGrid();
                //事业部和自定义维度的权限
                setParentDimension().then(function (data) {
                    checkUserPermission();
                });;

                $scope.getCommonCard = getCommonCard;
                $scope.getUserStatisCard = getUserStatisCard;

            })();
        }
    ]);