﻿infrastructureModule.directive('organizationBusinessUnitView', ['$log', '$compile', '$timeout', '$interval',
   function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('organizationBusinessUnitView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/admin/infrastructure/organizationBusinessUnitView/organization-business-unit-view.html' + '?_=' + Math.random(),
            scope: {},
            replace: true,
            controller: 'organizationBusinessUnitViewController',
            link: function (scope, element) {
               
                $(".card").draggable({ containment: "parent", cursor: "cursor", handle: ".card-header" });

                var showCardSeleted = '.show-card';
                // 机构缩略图ID
                var orgGeneralInfoPopId = '#orgGeneralInfoPop';

                //$(document).off('click');
                element.off('click');
                scope.renderOrgChart = function (datasource) {
                    $('.card').css('visibility', 'hidden');
                    $('#chart-container').html('');
                    //渲染orgchart
                    $('#chart-container').orgchart({
                        'data': datasource,
                        'pan': false,
                        'zoom': false,
                        "draggable": false,
                        'exportButton': false,
                        'nodeContent': 'title',
                        'exportFilename': 'SportsChart',
                        'parentNodeSymbol': 'fa-th-large'
                    });
                    //var chartWidth = $('#chart-container').width()
                    //var chartWidth = ($(window).width() - $(this).outerWidth()) / 2;
                    var horizontalCenter = Math.floor(window.innerWidth / 2);
                    console.log('horizontalCenter: ' + horizontalCenter);
                    $("#chart-container").scrollLeft(horizontalCenter);
                }


                //点击header，选中高亮
                element.on('click', '.title-header', function () {
                    $('.title-header').removeClass('title-header-active');
                    $(this).toggleClass("title-header-active");
                });

                var hideDropdownMenu = function () {
                    $('.title-header .dropdown-menu').css('display', 'none');
                };

                //点击高亮部分弹框，弹框去选择新增机构或者添加现有机构
                element.on('mouseenter', '.title-header .add-org', function () {
           
                    if (!scope.hasAddPermission) {
                        return false;
                    }
     
                    $('.title-header .dropdown-menu').css('display', 'none');

                    var thisCard = $(this).closest('.dropdown').find('.dropdown-menu');
                    thisCard.css('display', 'block');

                    element.one("click", function () {
                        thisCard.css('display', 'none');
                    });

                     stopPropagation();
                });

               element.on('mouseleave', '.title-header', function () {
                    $('.title-header .dropdown-menu').css('display', 'none');
                    stopPropagation();
               });
               element.on('click', showCardSeleted, function () {
                   $(orgGeneralInfoPopId).css('display', 'none');
                   stopPropagation();
               });

                //点击高亮部分新增机构
                element.on('click', '.title-header .add-new-org', function () {
                    stopPropagation();
                    hideCard();
                    //事业部ID
                    var demensionValueID = $(this).attr("data-demension-value-id"); //维度的值，如产品，事业部等
                    var attrbutetype = $(this).attr("data-attribute-type"); //自定义属性枚举值，如分公司，产品等
                    console.log("demensionValueID: " + demensionValueID);
                    //前提：高亮部分为分公司（机构）才触发这个事件
                    //if (attrbutetype == constant.dimensionType.OrgSubChildren) {
                    if (scope.parentDimensionType == constant.dimensionType.BusinessUnit) {
                        scope.editOrg(demensionValueID);
                    }
                    else {
                        scope.editOrg('');
                    }
                });


                //点击高亮部分添加现有机构
                element.on('click', '.title-header  .add-exist-org', function () {
                    stopPropagation();
                    hideCard();
                    //事业部ID
                    var demensionValueID = $(this).attr("data-demension-value-id"); //维度的值，如产品，事业部等
                    var attrbutetype = $(this).attr("data-attribute-type"); //自定义属性枚举值，如分公司，产品等
                    var attributeId = $(this).attr("data-attribute-id");
                    console.log("demensionValueID: " + demensionValueID);
                    //前提：高亮部分为分公司（机构）才触发这个事件
                   // if (attrbutetype == constant.dimensionType.OrgSubChildren) {
                    scope.addExistOrg(demensionValueID, attributeId);
                   // }
              
                });

                //如果维度是事业部，编辑事业部名称,如果是自定义维度，则编辑其定义维度的值
                element.on('click', '.edit-dimension-value', function () {
                    hideCard();
          
                    if (!scope.hasDimensionValueEditPermission) {
                        return false;
                    }
                    //事业部ID
                    var demensionValueID = $(this).attr("data-dimension-value-id");
                    if (demensionValueID) {
                        console.log("demensionValueID: " + demensionValueID);
                        if (scope.parentDimensionType == constant.dimensionType.BusinessUnit) {
                            scope.editBu(demensionValueID);
                        }
                            //如果是机构层级
                        else if (scope.parentDimensionType == constant.dimensionType.OrganizationStructure) {
                            scope.editOrgStructureType(demensionValueID);
                        }
                          //如果是自定义的维度
                        else if (scope.parentDimensionType == constant.dimensionType.SelfDimension) {
                            scope.editCustomDimensionValue(demensionValueID);
                        }
                    }
                    return false;
                  //  stopPropagation();
                });

                //点击不同的属性显示卡片
                element.on('click', showCardSeleted, function (e) {

                    stopPropagation();
                  
                    $(showCardSeleted).removeClass('row-highlight');
                    var $this = $(this);
                    $this.addClass('row-highlight');

                     //维度，如用户数，覆盖区域，所属行业等
                    var attributeType = $this.attr("data-attribute-type");
                    //维度值的ID,相当于某个事业部ID,
                    var dimensionValueID = $this.attr("data-demension-value-id");
                    var dimensionValue = $this.attr('data-demension-value');
                    var attributeName = $this.attr('data-attribute-name');
                    var attributeId = $this.attr("data-attribute-id");
                    //data-attribute-name
                    //如果是用户数
                    if (attributeType == constant.attributeType.User)
                    {
                        scope.getUserStatisCard(dimensionValueID, dimensionValue, attributeName, attributeId);
                        showCard('.user-card', $this.closest('.node'));
                    }  
                     //自定义维度，如产品线1，产品线2,通用,分公司，机构层级
                    else {
                        scope.getCommonCard(dimensionValueID, dimensionValue, attributeName, attributeId);
                        showCard('.common-card',$this.closest('.node'));
                    }

                    stopPropagation();
                });


                $(".card").on("click", function (e) {
                    stopPropagation();
                });
                $(".close-card").on("click", function (e) {
                    hideCard();
                    //$(this).closest('.card').css('visibility', 'hidden');
                });
                var hideCard = function () {
                    $(".card").css('visibility', 'hidden');
                    $(orgGeneralInfoPopId).hide();
                };

                var showCard = function (thisCard,node) {

                    hideCard();
                   var nodeOffset = $(node).offset();

                    // var nodeOuterWidth = $("#chart-container  .node").first().outerWidth();
                    var nodeOuterWidth = $(node).outerWidth();
                    var leftLen = nodeOffset.left + nodeOuterWidth + 10;
                    if (leftLen + $(thisCard).width() > window.innerWidth) {
                        leftLen = leftLen - nodeOuterWidth - $(thisCard).width() - 20;
                    }

                    $(thisCard).css("left", leftLen);
                    $(thisCard).css("top", nodeOffset.top);

                    if ($(thisCard + ":hidden")) {
                        $(thisCard).css('visibility', 'visible');

                    } else {
                        $(thisCard).css('visibility', 'hidden');
                    }
                };

                scope.fullScreenText = '全屏展示';
                scope.showFullScreen = function () {

                    $('.business-unit-view').parent().toggleClass('fullScreen');
                    if ($('.business-unit-view').parent().hasClass('fullScreen')) {
                        scope.fullScreenText = '退出全屏';
                        scope.isShowFullScreen = true;
                    } else {
                        scope.fullScreenText = '全屏展示';
                        scope.isShowFullScreen = false;
                    }
                }

                var stopPropagation = function (event) {
                    event = event || window.event;
                    if (event.stopPropagation) {
                        event.stopPropagation();
                    } else {
                        event.cancelBubble = true;
                    }
                }  
            }
        };
    }
]);

