﻿infrastructureModule
    .controller('OrganizationManageController', ['$scope', '$log', 'orgService', '$interval', 'uiGridTreeViewConstants', 'uiGridConstants', 'SweetAlert', 'projectService', '$translate', '$timeout', 'organizationStructureService', 'areaRegionService', 'apiInterceptor', 'enterpriseAccountService', 'businessUnitService', 'userService', 'roleService', '$q', 'permissionService', 'dimensionService','region',
        function ($scope, $log, orgService, $interval, uiGridTreeViewConstants, uiGridConstants, SweetAlert, projectService, $translate, $timeout, organizationStructureService, areaRegionService, apiInterceptor, enterpriseAccountService, businessUnitService, userService, roleService, $q, permissionService, dimensionService, region) {
            'use strict';


            var showWarning = function (resultMsg) {

                var errMsg = $translate.instant(resultMsg);
                SweetAlert.warning(errMsg);
            };

            var showSuccessMsg = function (resultMsg) {

                var errMsg = $translate.instant(resultMsg);
                SweetAlert.success(errMsg);
            };

            //jack
            $scope.getBottomHeight = function () {

                if ($scope.isLoadComplete) {
                    var y = $(".company-detail").height();
                    var parent = $('.org-right-container').height();
                    return { height: parent - y + 'px' };
                }

                return {};
            };

            var getDimensionList = function () {
                dimensionService.getDimensionList().success(function (data) {
                    if (data) {
                        $scope.customDimensionList = data;

                        $log.debug($scope.customDimensionList);

                        $scope.businessName = dimension.getBusinessUnitName();
                        $scope.areaName = dimension.getAreaName();
                    }
                });
            };

            var dimension = {
                getBusinessUnitName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionId.businessUnitID;
                    });
                    if (findResult) {
                        return findResult.name;
                    }
                    else {
                        return '';
                    }
                },
                getAreaName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionId.areaID;
                    });
                    if (findResult) {
                        return findResult.name;
                    }
                    else {
                        return '';
                    }
                }
            };

            ////添加企业账套
            //$scope.newAccountSetModal = function ()
            //{
            //    $scope.accountSetOperateType = constant.Operation.Add;
            //    $scope.accountSetIsUpdate = false;

            //};

            // 机构树
            var tree;

            // 是佛启用禁用Map
            var isActiveMap = {
                false: 'Enable',
                true: 'Disable'
            };

            // 获取账套
            var loadEnterpriseAccountSetList = function () {
                enterpriseAccountService.getEnterpriseAccountSetList().success(function (data) {
                    // 只获取启用状态的账套
                    //data = _.filter(data, function (num) { return num.isActive });
                    $scope.enterpriseAccountSetList = sortByEnterpriseName(data);
                    if (data && data.length > 0) {
                        $scope.hasEnterpriseAccountSet = true;

                    } else {
                        $scope.hasEnterpriseAccountSet = false;
                    }
                });
            };

            var dataType = {
                isPrefixNumber: function (value) {
                    var reg = /^\d+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixChar: function (value) {
                    var reg = /^[a-zA-Z]+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixNumberOrChar: function (value) {
                    if (dataType.isPrefixNumber(value)) {
                        return true;
                    }

                    if (dataType.isPrefixChar(value)) {
                        return true;
                    }

                    return false;
                }
            };

            var sortByEnterpriseName = function (data) {
                if (data && data.length > 0) {

                    var charList = [];
                    var nocharList = [];

                    data.forEach(function (row) {
                        if (dataType.isPrefixNumberOrChar(row.name)) {

                            row.nameSort = row.name;

                            if (row.nameSort) {
                                row.nameSort = row.nameSort.toLowerCase();
                            }
                            charList.push(row);
                        } else {
                            nocharList.push(row);
                        }

                    });

                    charList = _.sortBy(charList, 'nameSort');

                    nocharList = nocharList.sort(function compareFunction(param1, param2) {
                        return param1.name.localeCompare(param2.name, 'zh');
                    });

                    var all = _.union(charList, nocharList);
                    return all;
                }

                return data;
            };

            // 初始化函数
            var initOrg = function () {
                getDimensionList();
                loadorgTree();
                loadEnterpriseAccountSetList();
                getServiceList();
            };

            // 保存启用、启用的操作结果
            $scope.updateIsActive = function () {
                $scope.isCanOrganizationIsActiveBtn = false;
                var isActive = !$scope.selectCompany.isActive;
                if (isActive) {
                    orgService.enableOrgs($scope.selectCompany.id).success(function () {
                        SweetAlert.success($translate.instant('EnableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('enabled success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;

                    });
                } else {
                    var list = [];
                    list.push($scope.selectCompany.id);
                    orgService.disableOrgs(list).success(function () {
                        SweetAlert.success($translate.instant('DisableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('disabled orgs success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;
                    });
                }

            };

            // 进入高级配置编辑状态
            $scope.editAdvancedConfigurationStatus = function () {
                $scope.selectCompany.isUpdate = true;
                setEnterpriseOrgRowList($scope.selectCompany);

                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {

                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {

                        row.templateGroupList = _.find($scope.serviceList, function (num) {
                            return num.id === row.serviceTypeID
                        }).templateGroupList;
                    });
                }

            };

            // 添加服务模板
            $scope.addOrganizationServiceTemplateGroupRow = function () {
                var row = {};

                $scope.selectCompany.isUpdate = true;
                $scope.selectCompany.organizationServiceTemplateGroupList.push(row);
            };

            // 验证账套
            $scope.checkEnterpriseAccountSetSelect = function (row) {
                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.enterpriseAccountSetSelectError = null;
                    return;
                }


                if (!row.enterpriseAccountSetID) {
                    row.enterpriseAccountSetSelectError = $scope.resources.OrganizationMsgEnterpriseAccountSetRequired;
                } else {
                    row.enterpriseAccountSetSelectError = null;
                }
            };

            // 删除企业账套
            $scope.deleteAccountSet = function (row) {
                var index = jQuery.inArray(row, $scope.selectCompany.enterpriseAccountSetOrgList);
                $scope.selectCompany.enterpriseAccountSetOrgList.splice(index, 1);
            };

            // 删除服务
            $scope.deleteService = function (row) {
                var index = jQuery.inArray(row, $scope.selectCompany.organizationServiceTemplateGroupList);
                $scope.selectCompany.organizationServiceTemplateGroupList.splice(index, 1);
            };

            // 保存高级配置修改
            $scope.saveAdvancedConfiguration = function () {

                if (checkEnterpriseSetOrg() || checkTemplateList() || checkServiceTypeList()) {
                    return;
                }

                var branch = {
                    data: {
                        id: $scope.selectCompany.id
                    }
                };

                orgService.updateOrg($scope.selectCompany).success(function (data) {
                    if (data && !data.result) {
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    $scope.selectOrganization(branch);
                });
            };

            // 取消高级配置修改
            $scope.cancelAdvancedConfiguration = function () {
                $scope.selectCompany.enterpriseAccountSetOrgList = angular.copy($scope.backups.enterpriseAccountSetOrgList);
                $scope.selectCompany.organizationServiceTemplateGroupList = angular.copy($scope.backups.organizationServiceTemplateGroupList);
                $scope.selectCompany.isUpdate = false;
            };

            // 关于日志部分
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
            };

            // 添加机构
            $scope.addOrg = function () {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.isAdd = true;
                $scope.selectedOrg = null;
            };

            // 添加机构
            $scope.updateOrg = function () {
                $scope.isAdd = false;
                $scope.orgOperateType = constant.Operation.Edit;
                $scope.selectedOrg = $scope.selectCompany;
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectCompany && !$scope.isAdd) {
                        $scope.organizationId = $scope.selectCompany.id;
                    } else {
                        $scope.organizationId = null;
                    }

                    initOrg();
                    $scope.isOrgUpdate = false;
                }
            });

            // 选中服务更改时
            $scope.serviceTypeChange = function (service) {
                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {
                    var sameServiceTypeIDList = _.filter($scope.selectCompany.organizationServiceTemplateGroupList, function (num) {
                        return num.serviceTypeID === service.serviceTypeID;
                    });

                    if (sameServiceTypeIDList && sameServiceTypeIDList.length > 1) {
                        service.serviceTypeError = $scope.resources.ServiceExists;
                    } else {
                        service.serviceTypeError = null;
                    }
                } else {
                    service.serviceTypeError = null;
                }

                service.templateGroupList = _.find($scope.serviceList, function (num) {
                    return num.id === service.serviceTypeID
                }).templateGroupList;

                service.templateGroupID = '';
            };

            // 判断服务的选择是否有错误
            var checkServiceTypeList = function () {
                var hasError = false;
                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {

                    var serviceTypeIDList = [];

                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {
                        if (serviceTypeIDList.indexOf(row.serviceTypeID) > -1) {
                            row.serviceTypeError = $scope.resources.ServiceExists;
                            hasError = true;
                        } else {
                            row.serviceTypeError = null;
                        }

                        if (!row.templateGroupID) {
                            hasError = true;
                            row.selectedTemplateError = $scope.resources.OrganizationMsgTemplateRequired;
                        } else {
                            row.selectedTemplateError = null;
                        }

                        serviceTypeIDList.push(row.serviceTypeID);
                    });

                    // 有错误
                    return hasError;
                }

                // 没有错误
                return hasError;
            };

            var loadRootOrg = function () {
                orgService.getSingleOrg(constant.guid.empty).success(function (rootOrg) {
                    $scope.rootOrg = rootOrg;
                });
            };
            //加载用户权限list
            var loadUserRoleList = function (orgID) {
                roleService.getUserRoleList(orgID, '', '').success(function (data) {
                    // 构造用户信息
                    var roleStaticsList = [];

                    var userRoleShowList = [];
                    if (data && data.length > 0) {
                        data.forEach(function (row) {

                            var uniqRoleList = _.uniq(row.roleInfoList, function (item) { return item.name });
                            row.roleNameList = _.map(uniqRoleList, function (x) { return x.name; }).join(constant.comma);

                            //var roleNames = _.pluck(row.roleInfoList, 'name');
                            //row.roleNameList = roleNames.join(',');

                            if (!row.isAccessible) {
                                row.roleNameList = $translate.instant('UnAccessable');
                            }

                            row.hasEditPermission = $scope.hasEditPermission;

                            userRoleShowList.push({ id: row.id, userName: row.userName, roleNameList: row.roleNameList });
                            row.roleInfoList.forEach(function (role) {
                                var one = _.find(roleStaticsList, function (data) {
                                    return data.id === role.id;
                                });

                                if (one) {
                                    one.count++;
                                } else {
                                    role.count = 1;
                                    roleStaticsList.push(role);
                                }
                            });
                        });
                    }

                    $scope.roleStaticsList = roleStaticsList;

                    $scope.userRoleList = JSON.stringify(userRoleShowList);
                    $scope.userRoleGridOptions.data = data;
                    //用户数统计
                    $scope.userCount = data.length || 0;
                });
            };

            // 选中机构
            $scope.selectOrganization = function (branch) {

                var org = branch.data;
                $scope.output = "You selected: " + org.id;

                var suborgList = getSubOrgList(branch);
                $scope.selectedOrgID = org.id;

                // 选中事件
                // $scope.selectCompany = org;
                orgService.getSingleOrg(org.id).success(function (data) {
                    $scope.selectCompany = data;
                    $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                    //$log.debug("org.regionID: " + org.regionID);
                    $scope.selectCompany.suborgList = suborgList;
                    $scope.backups = {};
                    $scope.backups.enterpriseAccountSetOrgList = angular.copy($scope.selectCompany.enterpriseAccountSetOrgList);
                    $scope.backups.organizationServiceTemplateGroupList = angular.copy($scope.selectCompany.organizationServiceTemplateGroupList);

                    var orgAttributeList = _.filter(data.dimensionValueOrgList, function (attr) {
                        if (attr.id) {
                            return true;
                        } else {
                            return false;
                        }
                    });

                    var orgAttributeRowList = [];

                    if (orgAttributeList && orgAttributeList.length > 0) {

                        $scope.firstAttribute = orgAttributeList[0];

                        for (var i = 1; i < orgAttributeList.length; i = i + 2) {
                            var model = {
                                left: orgAttributeList[i],

                            };
                            if (i + 1 < orgAttributeList.length) {
                                model.right = orgAttributeList[i + 1];
                            }

                            orgAttributeRowList.push(model);
                        }
                    }

                    $scope.selectCompany.orgAttributeRowList = orgAttributeRowList;

                    //加载用户权限list
                    loadUserRoleList(org.id);

                });
            };

            $scope.resources = {
                EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
                ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
                EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
                OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
                OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
                ServiceExists: $translate.instant('ServiceExists'),
                DateMonthFormatError: $translate.instant('DateMonthFormatError')
            };

            // 验证开始时间
            $scope.checkStartDate = function (row) {


                // if (!row.effectiveDateStr) {
                //     row.startDateError = $scope.resources.EffectiveDateRequired;
                // } else {
                //     row.startDateError = null;
                // }

                if (row.effectiveDateStr && !window.PWC.checkMonth(row.effectiveDateStr)) {
                    row.startDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.startDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.startDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {

                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 验证结束时间
            $scope.checkEndDate = function (row) {

                //结束时间可为空，默认9999-12
                // if (!row.expiredDateStr) {
                //     row.endDateError = $scope.resources.ExpiredDateRequired;
                // } else {
                //     row.endDateError = null;
                // }

                if (row.expiredDateStr && !window.PWC.checkMonth(row.expiredDateStr)) {
                    row.endDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.endDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.endDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {
                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 加载机构树
            $scope.my_tree = tree = {};

            var loadorgTree = function () {

                $scope.orgList = [];
                $scope.doing_async = true;

                $scope.showOrgTree = false;

                orgService.getOrgListToJson(1).success(function (data) {
                    $scope.orgList = data;
                    $log.debug(data);
                    // 设置默认选中机构
                    if (data && data.length > 0) {

                        var selectOrg = data[0];
                        if ($scope.organizationId) {
                            selectOrg = findBranch($scope.organizationId, $scope.orgList);
                            if (!selectOrg) {
                                selectOrg = data[0];
                            }
                        }

                        $scope.selectOrganization(selectOrg);
                    }

                    $scope.doing_async = false;

                    return $timeout(function () {
                        $scope.my_tree.expand_level_function();
                        $scope.my_tree.select_branch(selectOrg);
                        $scope.showOrgTree = true;
                    }, 200);

                    return tree.expand_level_function();

                }).error(function (data) {

                    $log.debug(JSON.stringify(data));
                });
            };

            // 查找选中的分支
            var findBranch = function (orgid, orgTree) {
                if (orgTree && orgTree.length > 0) {

                    for (var i = 0; i < orgTree.length; i++) {
                        var row = orgTree[i];

                        // 查看当前节点
                        if (row.data.id === orgid) {
                            target = row;
                            return target;
                        }

                        // 查看子节点
                        var target = findBranch(orgid, row.children);
                        if (target) {
                            return target;
                        }
                    }

                    return null;
                } else {
                    return null;
                }
            };

            // Copy Array
            var copyArray = function (data) {
                var ret = [];
                data.forEach(function (row) {

                    ret.push(row);
                });

                return ret;
            };

            // 修改机构时，设置账套设置的值
            var setEnterpriseOrgRowList = function (enterpriseAccountSetData) {
                $scope.orgAccountList = [];
                if (!enterpriseAccountSetData.enterpriseAccountSetOrgList || enterpriseAccountSetData.enterpriseAccountSetOrgList.length === 0) {
                    return;
                }
                var enterpriseAccountSetList = copyArray($scope.enterpriseAccountSetList);

                var index = 1;
                $scope.OrgAccountRowIndex = index;
                enterpriseAccountSetData.enterpriseAccountSetOrgList.forEach(function (row) {

                    row.fromID = 'advancedSetFrom' + index;
                    row.toID = 'advancedSetTo' + index;

                    index++;
                    $scope.OrgAccountRowIndex = index;

                    $timeout(function () {
                        setDatepickerRow(row);
                    }, 100);
                });

            };

            var setDatepickerRow = function (rowData) {
                $("#" + rowData.fromID).datepicker({
                    minViewMode: 1,
                    autoclose: true,
                    language: region,
                    format: "yyyy-mm"
                });

                $("#" + rowData.toID).datepicker({
                    minViewMode: 1,
                    autoclose: true,
                    language: region,
                    format: "yyyy-mm"
                });

                $("#" + rowData.fromID).on('changeDate', function () {
                    var fromValue = $("#" + rowData.fromID).val();
                    var toValue = $("#" + rowData.toID).val();
                    if (fromValue) {
                        // 如果结束值为空，或者有效时间是一个时间段，则设置结束时间的开始时间
                        if (!toValue || validateDate(fromValue, toValue)) {
                            $("#" + rowData.toID).datepicker('setStartDate', fromValue);
                        }
                    }
                });

                // 默认的错误信息先设置为空
                rowData.startDateError = null;
                rowData.endDateError = null;
            };

            // 获取所有服务列表
            var getServiceList = function () {
                projectService.getServiceList().success(function (serviceListData) {
                    $scope.serviceList = serviceListData;
                });
            };

            // 验证是否为时间段
            var validateDate = function (from, to) {
                var fromDate = new Date(from + '-01');
                var toDate = new Date(to + '-01');
                toDate.setMonth(toDate.getMonth() + 1);
                toDate.setDate(toDate.getDate() - 1);

                if (fromDate <= toDate) {
                    return true;
                } else {
                    return false;
                }
            };

            // 验证账套修改
            var checkEnterpriseSetOrg = function () {

                var enterpriseSetList = [];
                if ($scope.selectCompany.enterpriseAccountSetOrgList && $scope.selectCompany.enterpriseAccountSetOrgList.length > 0) {
                    $scope.selectCompany.enterpriseAccountSetOrgList.forEach(function (row) {

                        $scope.checkEnterpriseAccountSetSelect(row);
                        $scope.checkStartDate(row);
                        $scope.checkEndDate(row);

                        if (row.enterpriseAccountSetID) {
                            enterpriseSetList.push(row);
                        }
                    });
                }

                $scope.selectCompany.enterpriseAccountSetOrgList = enterpriseSetList;

                var errorList = _.filter($scope.selectCompany.enterpriseAccountSetOrgList, function (num) {

                    return num.enterpriseAccountSetSelectError || num.startDateError || num.endDateError;
                });

                if (errorList && errorList.length > 0) {
                    return true;
                } else {
                    return false;
                }
            };

            // 验证模板列表
            var checkTemplateList = function () {
                var hasError = false;
                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {
                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {
                        $scope.checkTemplate(row);
                        if (row.selectedTemplateError) {
                            hasError = true;
                        }
                    });
                }

                return hasError;
            };

            // 验证模板方法
            $scope.checkTemplate = function (row) {
                if (!row.templateGroupID) {

                    row.selectedTemplateError = $scope.resources.OrganizationMsgTemplateRequired;

                } else {
                    row.selectedTemplateError = null;
                }
            };

            // 获取当前机构下的子机构
            var getSubOrgList = function (branch) {

                var orgList = [];

                if (branch.children && branch.children.length > 0) {
                    branch.children.forEach(function (row) {
                        orgList.push(row.data);
                        var tempList = getSubOrgList(row);
                        if (tempList && tempList.length > 0) {
                            orgList = _.union(orgList, tempList);
                        }
                    });
                }

                return orgList;
            };



            var showUserTab = function () {


                var generateData = function (count) {
                    var i;
                    var surnames = ['Smith', 'Johnson', 'Brown', 'Taylor', 'Anderson', 'Harris', 'Clark', 'Allen', 'Scott', 'Carter'];
                    var names = ['James', 'John', 'Robert', 'Christopher', 'George', 'Mary', 'Nancy', 'Sandra', 'Michelle', 'Betty'];
                    var gender = ['Male', 'Female'];
                    var items = [];

                    for (i = 0; i < 10; i++) {

                        var nameIndex = i;
                        var item = {
                            id: i + 1,
                            userName: names[nameIndex],
                            roleNameList: surnames[nameIndex],

                        };
                        items.push(item);
                    }
                    return items;
                };

                var generateData2 = function () {

                    //showUserTab();
                    return dataSource;
                };



                $scope.showRowLines = true;
                $scope.showBorders = false;
                $scope.showColumnLines = false;

                $scope.BUDataGridOptions = {
                    dataSource: 'userRoleList',
                    rowTemplate: $("#gridRow"),
                    bindingOptions: {
                        showBorders: 'showBorders',
                        showColumnLines: 'showColumnLines',
                        showRowLines: 'showRowLines',
                    },
                    selection: {
                        mode: "single"
                    },
                    columns: [{
                        dataField: "userName",
                        caption: $translate.instant('UserTitleName'),
                        width: '40%',
                    }, {
                        dataField: "roleNameList",
                        caption: $translate.instant('RoleDesc'),
                        width: '50%',
                    }, {
                        caption: $translate.instant('Operation'),
                        width: '10%',
                    }],

                    //,
                    //loadPanel: {
                    //    enabled: false
                    //},
                    //scrolling: {
                    //    mode: "virtual"
                    //},
                    //sorting: {
                    //    mode: "none"
                    //}
                };
            };

            var setUserRoleUIGridColumns = function () {
                //  $scope.uigridColumns.splice(1);


            };

            var initUserRoleUIGrid = function () {



                $scope.UIGridColumns = [{
                    field: 'userName',
                    name: $translate.instant('UserTitleName'),
                    width: '30%',
                    headerCellClass: 'right',
                    enableFiltering: false,
                    cellTemplate: '<div class="ui-grid-cell-contents right"><span title="{{row.entity.userName}}">{{row.entity.userName}}<span></div>'
                }];

                if ($scope.hasEditPermission) {

                    var colum = {
                        field: 'roleNameList',
                        name: $translate.instant('RoleDesc'),
                        width: '60%',
                        headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.roleNameList}}<span></div>'
                    };

                    $scope.UIGridColumns.push(colum);

                    colum = {
                        name: $translate.instant('Operation'),
                        width: '10%',
                        field: 'Operation',
                        headerCellClass: 'center',
                        enableFiltering: false,
                        cellTemplate: '<div class="project-manage-grid-operation ui-grid-cell-contents">' +
                            '<span ng-click="grid.appScope.updateUserRole(row.entity)" class="operate-span" role="button" tabindex="0" aria-hidden="false" style=""><i class="material-icons middle black-color">create</i></span>' +
                            '<span ng-click="grid.appScope.deleteUserRole(row.entity)" class="operate-span" role="button" tabindex="0" aria-hidden="false" style=""><i class="material-icons button-icons icon-delete">delete</i></span>' +
                            '</div>'
                    };
                    $scope.UIGridColumns.push(colum);

                } else {
                    var columns = {
                        field: 'roleNameList',
                        name: $translate.instant('RoleDesc'),
                        width: '70%',
                        headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.roleNameList}}<span></div>'
                    };
                    $scope.UIGridColumns.push(columns);
                }

                $scope.userRoleGridOptions = {
                    rowHeight: 30,
                    selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                    enableFullRowSelection: true,
                    enableRowSelection: true,
                    enableSorting: false,
                    enableFiltering: false,
                    enableColumnMenus: false,
                    enableRowHeaderSelection: false,
                    multiSelect: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    columnDefs: $scope.UIGridColumns,
                    onRegisterApi: function (gridApi) {
                        $scope.gridApi = gridApi;
                        $interval(function () {
                            $scope.gridApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                };
            };


            //如果添加了用户，则写入该机构下的库
            $scope.$watch('addUserIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectedKeyItems && $scope.selectedUserList.length > 0) {
                        // console.log(JSON.stringify($scope.selectedUserList));
                        addUserToOrg($scope.selectedUserList);
                    }
                }
            });

            //为当前机构添加用户
            var addUserToOrg = function (selectedUserArray) {

                var selectedArr = [];

                if (selectedUserArray && selectedUserArray.length > 0) {
                    for (var i = 0; i < selectedUserArray.length; i++) {
                        ////用户的角色列表
                        //var roleList = selectedUserArray[i].roleInfoList;

                        //去掉在当前机构下存在的用户,当前用户的权限可能已经改动过
                        var isUserExist = _.find($scope.userRoleGridOptions.data, function (num) {
                            return num.userID == selectedUserArray[i].userID;
                        });

                        if (isUserExist) {
                            continue;
                        }

                        var selectedObject = {
                            id: PWC.newGuid(),
                            userID: selectedUserArray[i].userID,
                            organizationID: $scope.selectedOrgID,
                            IsAccessible: true,
                            hasOriginalRole: true
                        };

                        selectedArr.push(selectedObject);
                    }
                }

                if (selectedArr.length > 0) {
                    userService.updateUserRoleForOrg(selectedArr).success(function (data) {
                        if (data) {
                            showSuccessMsg("SaveSuccess");
                            //重新加载用户list
                            loadUserRoleList($scope.selectedOrgID);
                        }
                    });
                } else {
                    showWarning('UserExists');
                }
            };

            //添加用户，弹框，call指令 add-exist-user-modal
            $scope.addUser = function () {
                var selectedKeyItem = [];
                $scope.userRoleGridOptions.data.forEach(function (row) {
                    selectedKeyItem.push(row.id);
                });
                $scope.addUserOperateType = constant.Operation.Add;
                $scope.addUserIsUpdate = false;
                $scope.selectedKeyItems = selectedKeyItem;
            };
            $scope.permissionPopover = {
                //content: $scope.permissionList,
                templateUrl: 'permissionPopoverTemplate.html',
                title: $translate.instant('TPermission')
            };

            //Jack
            $scope.showPermission = function (item) {

                var roleID = item.id;
                $scope.permissionList = [];
                var currentPermission = _.find($scope.allRolePermission, function (row) {
                    return row.roleID == roleID;
                });
                if (currentPermission && currentPermission.permissionList) {
                    $scope.permissionList = currentPermission.permissionList;
                    var copyData = angular.copy(currentPermission.permissionList);
                    copyData.forEach(function (item) {
                        var findParent = _.find(currentPermission.permissionList, function (num) {
                            return num.id === item.parentId;
                        });
                        if (!findParent) {
                            item.parentId = null;
                        }
                    });

                    $scope.permissionTreeViewData = copyData;// currentPermission.permissionList;
                    // console.log(JSON.stringify($scope.permissionTreeViewData));
                }
                // console.log(JSON.stringify(item));
            };




            var getAllRolePermission = function () {
                roleService.getAllRolePermission(constant.serviceType.VAT).success(function (data) {
                    if (data) {
                        $scope.allRolePermission = data;
                        //console.log('all permission: '+JSON.stringify(data));
                    }
                });
            };

            //$scope.showRoleInfo = function (data) {
            //    $scope.currentEmployee = data.model.employee;
            //    $scope.visiblePopup = true;
            //};


            var confirmWarningWindow = function (title, text) {
                var deferred = $q.defer();
                SweetAlert.swal({
                    title: title,
                    text: text,
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    allowOutsideClick: false,
                    confirmButtonText: $translate.instant('Confirm'),
                    cancelButtonText: $translate.instant('Cancel'),
                    closeOnConfirm: false,
                    closeOnCancel: true
                },
                    function (isConfirm) {
                        deferred.resolve(isConfirm);
                    });

                return deferred.promise;
            };


            //删除用户角色
            $scope.deleteUserRole = function (userModel) {

                var confirmToDelete = $translate.instant('ConfirmToDelete');

                confirmWarningWindow(confirmToDelete, '').then(function (data) {
                    if (data) {
                        var userOrgDto = {
                            userID: userModel.id,
                            OrgID: $scope.selectedOrgID
                        }
                        //$log.debug(JSON.stringify(userModel));
                        userService.deleteUserRoleForOrg(userOrgDto).success(function (data) {
                            showSuccessMsg("OrganizationStructureDeleteSuccess");
                            //重新加载用户list
                            loadUserRoleList($scope.selectedOrgID);

                        });
                    }
                });
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('userRolesIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    //重新加载用户list
                    loadUserRoleList($scope.selectedOrgID);
                }
            });

            //编辑用户角色
            $scope.updateUserRole = function (userRole) {
                $scope.userRoleOperateType = constant.Operation.Edit;
                $scope.selectedOrgID = $scope.selectedOrgID;
                $scope.selectedUserID = userRole.id;
                $scope.userRolesIsUpdate = false;
            };

            // 添加一行账套设置 (jack)
            $scope.newOrgAccountRow = function () {
                var index = $scope.OrgAccountRowIndex;
                var enterpriseAccountSetList = copyArray($scope.enterpriseAccountSetList);
                var d = new Date();
                var now = d.formatDateTime('yyyy-MM');

                var row = {
                    enterpriseAccountSetName: '',
                    effectiveDateStr: null,
                    expiredDateStr: null,
                    organizationID: $scope.selectedOrgID,
                    fromID: 'advancedSetFrom' + index,
                    toID: 'advancedSetTo' + index
                };

                $scope.OrgAccountRowIndex++;
                $scope.selectCompany.enterpriseAccountSetOrgList.push(row);
                $timeout(function () {
                    setDatepickerRow(row);
                }, 200);
            };


            $scope.getGridHeight = function () {
                return { height: $(".dx-viewport").height() + "px" };
            };

            //获取当前角色对应的权限列表
            var loadPermissionTree = function () {
                $scope.permissionTreeViewOptions = {
                    bindingOptions: {
                        dataSource: 'permissionTreeViewData',
                        expandAllEnabled: 'expandAll'
                    },
                    dataStructure: "plain",
                    selection: {
                        mode: "single"
                    },
                    loadPanel: {
                        enabled: true
                    },
                    scrolling: {
                        mode: "virtual"
                    },
                    parentIdExpr: "parentId",
                    keyExpr: "id",
                    displayExpr: 'name',
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,
                    showBorders: true,
                    selectAllText: $translate.instant('SelectAll'),
                    scrollDirection: 'vertical',  //Accepted Values: 'vertical' | 'horizontal' | 'both'
                    selectNodesRecursive: true,  //级联选择
                    //showCheckBoxesMode: 'selectAll', //Accepted Values: 'none' | 'normal' | 'selectAll'
                    noDataText: $translate.instant('NoDataText'),
                    onInitialized: function (e) {
                        $scope.permissionTreeViewInstance = e.component;
                        // $scope.widgetInstance.selectItem($scope.itemElement.id);
                    }
                };
            };

            var checkUserPermission = function () {

                var list = [];
                $scope.hasQueryPermission = false;
                $scope.hasAddPermission = false;
                $scope.hasEditPermission = false;

                $scope.hasUserQueryPermission = false;
                $scope.hasUserEditPermission = false;

                ////查看用户角色的权限
                //var tempUser = constant.adminPermission.infrastructure.userManage;
                //list.push(tempUser.queryCode);
                //list.push(tempUser.editCode);

                var temp = constant.adminPermission.infrastructure.organizationManage;
                list.push(temp.queryCode);
                list.push(temp.addCode);
                list.push(temp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasQueryPermission = data[temp.queryCode];
                    $scope.hasAddPermission = data[temp.addCode];
                    $scope.hasEditPermission = data[temp.editCode];

                    //$scope.hasUserQueryPermission = data[tempUser.queryCode];
                    //$scope.hasUserEditPermission = data[tempUser.editCode];

                    if ($scope.hasQueryPermission) {

                        initUserRoleUIGrid();
                        loadPermissionTree();
                        initOrg();
                        getAllRolePermission();

                    }

                });
            };


            (function initialize() {
                $scope.showRowLines = true;
                $log.debug('organizationManageController.ctor()...');
                //scope model
                $scope.title = $translate.instant('OrganizationManageTitle');
                $scope.orgList = [];
                $scope.checkedOrgsSet = {};
                $scope.set = [];
                $scope.maxTitleLength = 10;
                $scope.maxValueLength = 20;
                $scope.selectCompany = {};
                $scope.showAttributeDimensionID = 'orgmanage';

                $scope.searchText = '';

                $scope.isCanOrganizationIsActiveBtn = true;

                $scope.currentNavItem = 'page1';
                $scope.userRoleList = "[]";
                //showUserTab();

                checkUserPermission();
                $timeout(function () {

                    $scope.isLoadComplete = true;

                }, 500);
            })();
        }
    ]);
