﻿infrastructureModule
   .controller('OrganizationSubsidiaryViewController', ['$scope', '$log', 'SweetAlert', 'dimensionService', 'statisticAttributeService', 'regionService', '$translate', 'areaRegionService', 'uiGridTreeViewConstants', '$timeout', 'areaService', 'uiGridConstants', '$interval', 'orgService', '$q', '$state', '$filter', 'roleService',
        function ($scope, $log, SweetAlert, dimensionService, statisticAttributeService, regionService, $translate, areaRegionService, uiGridTreeViewConstants, $timeout, areaService, uiGridConstants, $interval, orgService, $q, $state, $filter, roleService) {
            'use strict';

            var orgGeneralInfoPopId = '#orgGeneralInfoPop';
            var unassisgnText = $translate.instant('UnAssignText');
            $scope.unassisgnText = unassisgnText;

            // 系统级别的纬度id列表
            var systemDimensionIdList = [
                constant.attributeId.businessUnitID,
                constant.attributeId.areaID,
                constant.attributeId.organizationStructureID,
                constant.attributeId.userID,
                constant.attributeId.industryID,
                constant.attributeId.rgSubChildrenID
            ];

            var template = {
                topNodeTemplate: $("#dimension-topNode").html(),  //最顶层节点
                nameNodeQuery: $("#dimension-org-node-name-query").html(),  //机构名称 
                nameNodeEdit: $("#dimension-org-node-name-edit").html(),  //机构名称 
                rowNode: $("#dimension-row-node").html() //普通行
            };

            //设置维度的名称和值，和类型
            var setParentDimension = function () {
                dimensionService.getDimensionById($scope.parentDimensionID).success(function (data) {
                    if (data) {
                        $scope.parentDimensionName = data.name;
                        $scope.parentDimensionType = data.dimensionType;
                    }
                });
            };

            //隐藏机构general info
            var hideOrgGeneralInfo = function () {
                $(orgGeneralInfoPopId).hide();
            };


            // 显示机构general info，并设置好位置
            var showOrgCard = function (popCard, row, topOffset, leftOffset) {

                popCard.css("display", "block");

                var top = row.offset().top + topOffset;
                if (top + popCard.height() > window.innerHeight) {
                    top = window.innerHeight - popCard.height() - topOffset;
                }

                popCard.css('top', top + 'px');

                var left = row.offset().left + leftOffset;
                if (left + popCard.width() > window.innerWidth) {
                    left = row.offset().left - popCard.width() - leftOffset;
                }

                popCard.css('left', left + 'px');

                popCard.show();

                $(document).one('click', function () {
                    hideOrgGeneralInfo();
                });
            };

            //添加事业部,机构层级，自定义维度的值等等
            $scope.addDimensionValue = function () {
                if ($scope.parentDimensionType == constant.dimensionType.BusinessUnit) {
                    $scope.orgOperateBusinessType = constant.Operation.Add;
                    $scope.businessUnitID = null;
                    $scope.isBusinessUpdate = false;
                }
                if ($scope.parentDimensionType == constant.dimensionType.OrganizationStructure) {
                    $scope.orgOperateOrgStructureType = constant.Operation.Add;
                    $scope.selectedOrgStructureID = null;
                    $scope.isOrgStructureUpdate = false;
                }
                else if ($scope.parentDimensionType == constant.dimensionType.SelfDimension) {
                    $scope.dimensionValueOperateType = constant.Operation.Add;
                    $scope.dimensionId = $scope.parentDimensionID;
                    $scope.dimensionName = $scope.parentDimensionName;
                    $scope.isDimensionValueUpdate = false;
                    $scope.selectedDimensionValueID = null;
                }
            };

            $scope.AddOrg = function () {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.selectedOrg = null;
                $scope.isOrgUpdate = false;
                $scope.organization = {

                };
            };

            $scope.EditOrg = function (orgID) {
                $scope.orgOperateType = constant.Operation.Edit;
                //$scope.selectedOrg = orgID;
                $scope.isOrgUpdate = false;
                $scope.selectedOrg = {
                    id: orgID
                };
            };

            //点击机构名称，显示详细信息
            $scope.showOrgGenerateInfo = function (row) {
                //  $scope.isRenderCompletedGeneralInfo = false;
                $scope.orgIdGeneralInfo = row.entity.orgID;

                var orgGeneralInfoPopup = $(orgGeneralInfoPopId);
                var rowId = $('#' + row.entity.orgID);
                showOrgCard(orgGeneralInfoPopup, rowId, 30, 50);
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    notifyTopPage();
                }
            });

            //自定义显示属性更新后，刷新当前页面的orgchart
            $scope.$watch('isAttributeUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    populateUIGridColumns();
                }
            });

            // 添加或者编辑事业部成功之后，刷新当前页面的数据
            $scope.$watch('isBusinessUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                }
            });

            //修改机构成功之后 通知父层去更新机构数的统计
            var notifyTopPage = function () {
                $scope.$emit("hasOrgUpdated", { isupdated: true });
            };

            //所属行业弹框,也是通用模板
            var getCommonCard = function (dimensionValueID, dimensionValue, attributeName, attributeId) {

                populateUIGridColumns();

                //参数，维度值的ID，如事业部1，事业部2 ，然后是顶层事业部，如事业部
                orgService.getOrgCustomDashbord(dimensionValueID, $scope.parentDimensionID, attributeId).success(function (data) {
                    if (data) {

                        console.log('data:');
                        console.log(JSON.stringify(data));

                        data.orgDtoList.forEach(function (row) {
                            if (row.level != null) {
                                row.$$treeLevel = parseInt(row.level);
                            }
                        });

                        $scope.orgCustomList = data.orgCustomDtoList;
                        $scope.orgList = data.orgDtoList;

                        for (var i = 0; i < $scope.orgList.length; i++) {
                            var row = $scope.orgList[i];

                            if ($scope.attributeList && $scope.attributeList.length > 0) {

                                for (var j = 0; j < $scope.attributeList.length; j++) {
                                    if (systemDimensionIdList.indexOf($scope.attributeList[j].attributeId) === -1) {
                                        var targetVaule = _.find($scope.orgCustomList, function (data) {
                                            return data.orgID === row.orgID && data.dimensionId === $scope.attributeList[j].belongDimensionId;
                                        });

                                        if (targetVaule) {
                                            row["selfDimension" + j] = targetVaule.dimensionValueName;
                                        } else {
                                            row["selfDimension" + j] = '';
                                        }
                                    }
                                }
                            }

                        };

                        $scope.dimensionValue = dimensionValue;
                        $scope.attributeName = attributeName;
                        $scope.commonUIGridList.data = $scope.orgList;
                        $scope.commonCountDataSource = data.orgCountList;
                        console.log(JSON.stringify($scope.orgList));
                        console.log("cusomer:" + JSON.stringify(data.orgCustomDtoList));
                        console.log("111:" + JSON.stringify($scope.attributeList));
                    }
                });
            };

            //将角色列表换成逗号分隔
            var formatRoleList = function (roleInfoList) {
                var newList = "";
                roleInfoList.forEach(function (row) {
                    if (row) {
                        newList += row.name + constant.comma;
                    }
                });
                if (newList.length > 0) {
                    newList = newList.substr(0, newList.length - 1);
                }

                return newList;
            };

            //用户卡片弹框
            var getUserStatisCard = function (dimensionValueID, dimensionValue, attributeName, attributeId) {

                $scope.userBUDimensionValueID = dimensionValueID;
                $scope.dimensionValue = dimensionValue;
                $scope.attributeName = attributeName;


                //用户下面多个角色，多少个机构
                roleService.getDimensionUserRoleList($scope.parentDimensionID, dimensionValueID).success(function (data) {
                    if (data) {
                        for (var i = 0; i < data.length; i++) {
                            var row = data[i];
                            data[i].userID = row.userID;
                            data[i].userName = row.userName;
                            data[i].roleInfo = formatRoleList(row.roleList);
                            data[i].orgCount = row && row.orgList && row.orgList.length;
                        }
                        //用户数据绑定
                        $scope.userDatagridDataSource = data;
                    }

                });
                //角色统计，角色下面多少个用户
                roleService.getDimensionRoleUserList($scope.parentDimensionID, dimensionValueID).success(function (data) {
                    if (data) {
                        for (var i = 0; i < data.length; i++) {
                            var row = data[i];
                            data[i].count = row && row.userList && row.userList.length;
                            data[i].name = row.roleName;
                        }

                        $scope.roleCountDataSource = data;
                    }
                });
            };

            var ReplaceObj = {
                //顶部节点
                topNodeName: '{{#topNodeName#}}',
                //事业部名称
                dimensionValue: '{{#dimensionValue#}}',
                dimensionValueID: '{{#dimensionValueID#}}',
                //高亮部分统计
                //hightNodeCount: '{{#dimensionValueCount#}}', //比如 '100'
                //hightNodeName: '{{#attributeName#}}',   //比如'分公司'
                //普通维度统计
                attributeId: '{{#attributeId#}}',
                attributeName: '{{#attributeName#}}',  //维度名字，如用户数，覆盖区域，所属行业等
                attributeValueCount: '{{#attributeValueCount#}}',      //对于维度的统计
                attributeType: '{{#attributeType#}}',             //维度的类型区分值，如1:事业部，2:分公司
                firstAttrName: '{{#firstAttr}}',
                secondAttrName: '{{#secondAttr}}',
                firstAttrTitle: '{{#firstAttrTitle}}',
                secondAttrTitle: '{{#secondAttrTitle}}'
            };

            //构造Echart模板，并且初始化数据
            $scope.populateChartDatasource = function (parentOrgID, expandedList) {
                $scope.renderOrgChart({});
                console.log('expandedOrgList', expandedList);
                $scope.pLevel = 0;
                orgService.getOrgDashboard($scope.parentDimensionID, parentOrgID, expandedList).success(function (data) {
                    if (data !== undefined && data !== null && data.length > 0) {

                        var topNodeName = '集团'; //template.topNodeTemplate.replace(ReplaceObj.topNodeName, $scope.parentDimensionName);

                        var datascource = {
                            'id': 'topid',
                            'name': topNodeName,
                            'pLevel': $scope.pLevel,
                            'children': [],
                            'relationship': '111'
                        };

                        data.forEach(function (row) {

                            var newNode = createNewNode(row);
                            datascource.children.push(newNode);

                            if (row.children !== null && row.children.length > 0) {
                                $scope.pLevel = $scope.pLevel + 1;
                                createNodeRecursion(row.children, newNode);
                            }
                        });

                        //生成orgchart
                        $scope.renderOrgChart(datascource);
                    }
                });
            };

            var createNodeRecursion = function (childrenList, parentNode) {

                if (childrenList.length == 0) return;

                childrenList.forEach(function (row) {
                    var newNode = createNewNode(row);
                    parentNode.children.push(newNode);

                    if (row.children !== null && row.children.length > 0) {
                        $scope.pLevel = $scope.pLevel + 1;
                        createNodeRecursion(row.children, newNode);
                    }

                });
            };

            //创建orgchart节点
            var createNewNode = function (row) {

                var templateNameNode = template.nameNodeQuery;
                if ($scope.hasEditPermission) {
                    templateNameNode = template.nameNodeEdit;
                }

                var temp = [];
                var relationship = '110';
                if (row.hasChildren !== undefined && row.hasChildren) {
                    relationship = '111';
                }

                var node = {
                    'id': row.dimensionValueID,
                    'pLevel': $scope.pLevel,
                    'name': templateNameNode.replaceToEnd(ReplaceObj.dimensionValue, row.dimensionValue)
                        .replaceToEnd(ReplaceObj.dimensionValueID, row.dimensionValueID)
                        .replaceToEnd(ReplaceObj.dimensionValueID, row.dimensionValueID)
                        .replaceToEnd(ReplaceObj.firstAttrName, row.firstAttrName === null ? ' 未指定 &nbsp;' : $filter('limitString')(row.firstAttrName, 10))
                        .replaceToEnd(ReplaceObj.secondAttrName, row.secondAttrName === null ? ' 未指定 &nbsp;' : $filter('limitString')(row.secondAttrName, 10))
                        .replaceToEnd(ReplaceObj.firstAttrTitle, row.firstAttrName === null ? ' 未指定 &nbsp;' : row.firstAttrName)
                        .replaceToEnd(ReplaceObj.secondAttrTitle, row.secondAttrName === null ? ' 未指定 &nbsp;' : row.secondAttrName),

                    'title': (function () {

                        row.orgDtoList.forEach(function (item, index) {

                            temp += template.rowNode.replaceToEnd(ReplaceObj.attributeName, item.attributeName)
                                    .replaceToEnd(ReplaceObj.attributeValueCount, item.attributeValueCount)
                                    .replaceToEnd(ReplaceObj.dimensionValueID, row.dimensionValueID)
                                    .replaceToEnd(ReplaceObj.dimensionValue, row.dimensionValue)
                                   .replaceToEnd(ReplaceObj.attributeId, item.attributeId)
                                   .replaceToEnd(ReplaceObj.attributeType, item.attributeType);
                        });
                        return temp;

                    })(),
                    'children': [],
                    'relationship': relationship
                };

                //特殊处理，如果没有子机构，只显示本身即可
                if (row.hasChildren === undefined || !row.hasChildren) {
                    node.title = '';
                }

                return node;
            };

            //编辑自定义显示属性
            $scope.showCustomAttriute = function () {

                $scope.attributeOperateType = constant.Operation.Edit;
                $scope.showAttributeDimensionID = $scope.parentDimensionID;;
                $scope.isAttributeUpdate = false;
            };

            //自定义显示属性更新后，刷新当前页面的orgchart
            $scope.$watch('isAttributeUpdate', function (newValue, oldValue) {
                if (newValue) {
                    initOrgChartData();
                    populateUIGridColumns();
                }
            });

            //通用的ui grid 模板
            var commonUIGridInit = function () {
                $scope.uigridColumns = [{
                    field: 'orgName',
                    name: $translate.instant('OrganizationName'),
                    cellTemplate: '<div id="{{row.entity.orgID}}" ng-click="grid.appScope.showOrgGenerateInfo(row)" ng-class="{true: \'text-align-left\', false: \'text-align-left-padding\'}[row.entity.level==' + constant.level.First + ']"><span title="{{row.entity.orgName}}" >{{row.entity.orgName==null||row.entity.orgName==""?"' + unassisgnText + '":row.entity.orgName}}</span></div>'
                }];

                $scope.commonUIGridList = {
                    enableRowSelection: true,
                    enableSelectAll: false,
                    rowHeight: 30,
                    enableRowHeaderSelection: false,
                    modifierKeysToMultiSelect: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,

                    enableColumnResizing: true,
                    enableSorting: true,
                    enableColumnMenus: false,
                    enableFiltering: false,
                    showTreeExpandNoChildren: false,
                    enableFullRowSelection: true, //是否点击行任意位置后选中,默认为false
                    multiSelect: false, // 是否可以选择多个,默认为true; 
                    columnDefs: $scope.uigridColumns,

                    onRegisterApi: function (gridApi) {

                        $scope.gridApi = gridApi;

                        $scope.gridSelectCount = $scope.gridApi.selection.getSelectedRows().length;

                        // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                        $interval(function () {
                            $scope.gridApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);

                    }
                };

            };


            //添加过滤下拉列表
            var InitFilterList = function () {
                //初始化选择器为空
                $scope.filter = {};
                $scope.filter.selected = [];

                var datasource = constant.taxpayerNumberFilter.dataSource;

                datasource.forEach(function (row) {
                    row.value = $translate.instant(row.value);
                });
                $scope.taxPayerFilterList = datasource;
            };


            //筛选的时候，ng-check event will be triggered
            $scope.stateChanged = function ($event, data) {
                $scope.filter.selected = [];
                var checkbox = $event.target;
                if (checkbox.checked && $scope.filter.selected.indexOf(data.key) < 0) {
                    $scope.filter.selected.push(data.key);
                }

                orgDashboardFilterChanged();
            };

            var orgDashboardFilterChanged = function () {

                $('#orgName-search').find('input').val('')

                var selectedList = $scope.filter.selected;
                if (selectedList.length == 0) return;

                var selectedID = $scope.filter.selected[0] || constant.taxpayerNumberFilter.key_0;
                $scope.orgDashboardFilteredID = selectedID;

                var oldData = [];

                switch (selectedID) {
                    //所有对应状态,取默认值
                    case constant.taxpayerNumberFilter.key_0:  //all data
                        $scope.populateChartDatasource(0);
                        break;
                        //have taxpayerNumber
                    case constant.taxpayerNumberFilter.key_1:
                        $scope.populateChartDatasource(1);
                        break;
                    case constant.taxpayerNumberFilter.key_2:
                        $scope.populateChartDatasource(2);
                        break;
                }
            };


            var InitDXDataGrid = function () {
                loadUserDatagrid();
            };


            //构造用户datagrid
            var loadUserDatagrid = function () {

                $scope.userdatagridOptions = {
                    bindingOptions: {
                        dataSource: 'userDatagridDataSource'
                    },
                    selection: {
                        mode: "single"
                    },
                    columns: [
                          {
                              dataField: "userName",
                              caption: $translate.instant('UserDesc'),
                              width: "30%",
                              cellTemplate: function (container, options) {
                                  try {
                                      $('<a>' + options.value + '</a>')
                                          .attr('href', '#/userDetail/' + options.row.data.userID)
                                           .appendTo(container);
                                  }
                                  catch (e) {
                                      $log.error(e);
                                  }
                              }
                          },
                        {
                            dataField: "roleInfo",
                            caption: $translate.instant('Role'),
                            width: "50%"
                        },
                        {
                            dataField: "orgCount",
                            caption: $translate.instant('OrganizationCount'),
                            alignment: 'center',
                            width: "20%"

                        },
                    ],
                    loadPanel: {
                        enabled: false
                    },
                    scrolling: {
                        mode: "virtual"
                    },
                    noDataText: $translate.instant('NoDataText'),
                    showColumnLines: false,
                    showRowLines: false,
                    allowColumnResizing: true,
                    rowAlternationEnabled: true,
                    showBorders: false,
                    sorting: {
                        mode: "none"
                    }
                };
            };


            //根据自定义维度设置显示的卡片的列
            var populateUIGridColumns = function () {
                //获取维度值数据
                statisticAttributeService.getByParentDimensionID($scope.parentDimensionID).success(function (result) {
                    if (result) {

                        $scope.attributeList = result;
                        var column = {
                        };
                        $scope.uigridColumns.splice(1);

                        var j = 0;
                        result.forEach(function (attr) {
                            if (attr.attributeType == constant.attributeType.BusinessUnit) {
                                column = {
                                    field: 'businessUnitName',
                                    name: attr.attributeName,
                                    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.businessUnitName}}">{{row.entity.businessUnitName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.OrganizationStructure) {
                                column = {
                                    type: 'string',
                                    field: 'structureName',
                                    name: attr.attributeName,
                                    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.structureName}}">{{row.entity.structureName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.Industry) {
                                column = {
                                    type: 'string',
                                    field: 'industryName',
                                    name: attr.attributeName,
                                    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.industryName}}">{{row.entity.industryName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                                //else if (attr.attributeType == constant.attributeType.User) {
                                //    column = {
                                //        type: 'string',
                                //        field: 'industryName',
                                //        name: attr.attributeName,
                                //        cellTemplate: '<div class="text-align-left"><span title="{{row.entity.businessUnitName}}">{{row.entity.businessUnitName}}</span></div>'
                                //    };
                                //    $scope.uigridColumns.push(column);
                                //}
                            else if (attr.attributeType == constant.attributeType.Area) {
                                column = {
                                    type: 'string',
                                    field: 'areaName',
                                    name: attr.attributeName,
                                    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.areaName}}">{{row.entity.areaName}}</span></div>'
                                };
                                $scope.uigridColumns.push(column);
                            }
                            else if (attr.attributeType == constant.attributeType.SelfDimension) {
                                //column = {
                                //    type: 'string',
                                //    field: 'dimensionValueName',
                                //    name: attr.attributeName,
                                //    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.dimensionValueName}}">{{row.entity.dimensionValueName}}</span></div>'
                                //};
                                var column = {
                                    field: 'selfDimension' + j,
                                    name: attr.attributeName,
                                    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.selfDimension' + j + '}}">{{row.entity.selfDimension' + j + '}}</span></div>'
                                };

                                $scope.uigridColumns.push(column);
                            }

                            j++;
                        });
                    }
                });

            };

            var initUIGrid = function () {
                commonUIGridInit();

            };

            var initOrgChartData = function () {
                $scope.orgDashboardFilteredID = constant.taxpayerNumberFilter.key_0;
                InitFilterList();
                $scope.populateChartDatasource('');
            };

            //权限check
            var checkUserPermission = function () {

                var list = [];
                $scope.hasQueryPermission = false;
                $scope.hasEditPermission = false;
                $scope.hasAddPermission = false;
                $scope.hasAttributeQueryPermission = false;

                var temp = constant.adminPermission.infrastructure.organizationManage;
                list.push(temp.queryCode);
                list.push(temp.addCode);
                list.push(temp.editCode);

                //自定义显示属性的权限
                var tempAttr = constant.adminPermission.infrastructure.customAttribute;
                list.push(tempAttr.queryCode);


                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasQueryPermission = data[temp.queryCode];
                    $scope.hasEditPermission = data[temp.editCode];
                    $scope.hasAddPermission = data[temp.addCode];

                    $scope.hasAttributeQueryPermission = data[tempAttr.queryCode];

                    if ($scope.hasQueryPermission) {
                        initOrgChartData();
                        getOrgList();
                    }
                });
            };

            var getOrgList = function () {
                orgService.getOrgListLevel().success(function (orgList) {
                    if (orgList) {

                        var orgNameList = _.pluck(orgList, 'name');
                        $("#orgName-search").dxAutocomplete({
                            dataSource: orgNameList,
                            placeholder: "请输入机构名",
                            showClearButton: true,
                            onContentReady: function (e) {
                                //var btn = $("<button class='fa fa-cogs'></button>"); 
                                //e.element.find(".dx-texteditor-buttons-container").append(btn);
                            },
                            onValueChanged: function (data) {
                                var org = _.find(orgList, function (item) { return item.name == data.value; });
                                if (org && org.id) {
                                    $scope.populateChartDatasource('@@Current@@' + org.id);
                                } else if (data.value == '') {
                                    $scope.populateChartDatasource('');
                                }
                            }
                        });
                    }
                });
            };

            (function initialize() {
                $log.debug('OrganizationSubsidaryViewController.ctor()...');
                $log.debug('$state.params.dimensionId:' + $state.params.dimensionId);
                $scope.dimensionId = $state.params.dimensionId === null ? 'c61a5bd6-a996-4952-9869-d053995237e7' : $state.params.dimensionId;

                var parentDimensionID = $state.params.dimensionId || $scope.dimensionId;
                $scope.parentDimensionID = parentDimensionID;
                $scope.showAttributeDimensionID = $scope.parentDimensionID;

                $scope.orgID = '';
                $scope.createNewNode = createNewNode;
                $scope.template = template;
                $scope.ReplaceObj = ReplaceObj;
                $scope.showOrgCard = showOrgCard;
                setParentDimension();
                InitDXDataGrid();
                initUIGrid();

                checkUserPermission();

                $scope.getCommonCard = getCommonCard;
                $scope.getUserStatisCard = getUserStatisCard;
            })();
        }
   ]);