﻿commonModule.
controller('addExistOrganizationModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', '$filter', 'SweetAlert', 'orgService', 'userService',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, $filter, SweetAlert, orgService, userService) {
        $scope.gridInstance = null;
        var modalSelector = '#addOrgModal';

        var showWarning = function (resultMsg) {

            var errMsg = $translate.instant(resultMsg);
            SweetAlert.warning(errMsg);
        };

        var showSuccessMsg = function (resultMsg) {

            var errMsg = $translate.instant(resultMsg);
            SweetAlert.success(errMsg);
        };

        var showModal = function () {
            
            $scope.originalList = angular.copy($scope.selectedKeyItems);
            $scope.selectedOrgList = [];
            getOrgList();
            $(modalSelector).modal("show");
        };
        $scope.$watch('operateType', function (newValue, oldValue) {
            if (newValue) {

                if (newValue == constant.Operation.Add) {
                    showModal();
                } else if (newValue == constant.Operation.Edit) {

                }
            }
        });

        $(".addOrgModal").on("hidden.bs.modal", function () {
            $scope.operateType = null;
            $scope.DataGridSource=[];
        });

        $scope.closeModal = function () {
            $scope.operateType = null;
            $scope.DataGridSource=[];
        };

        $scope.Save = function ()
        {
            //返回机构列表
            //console.log(JSON.stringify($scope.selectedOrgList));
            $scope.operateType = null;
            $scope.isUpdate = true;
            $scope.DataGridSource=[];
            $(modalSelector).modal("hide");
        };

        var setSelectItems=function(selectedKeyItems)
        {
            //设置选中
            $timeout(function () {
                $scope.gridInstance.clearSelection();
                if (selectedKeyItems && selectedKeyItems.length > 0) {
                    $scope.gridInstance.selectRows(selectedKeyItems, true);
                }
            }, 100); 
        };

        var getOrgList = function () {
            orgService.getOrgListLevel().success(function (data) {
                if (data) {
                    $scope.DataGridSource = data;

                    setSelectItems($scope.selectedKeyItems);
                }
            });
        };

        var loadDatagrid = function () {
            $scope.orgDataGridOptions = {
                bindingOptions: {
                    dataSource: 'DataGridSource'
                }, 
                columns: [
                        {
                            dataField: "name",
                            caption: $translate.instant('OrganizationName'),
                            width:200
                        },
                        {
                            dataField: "businessUnitName",
                            caption: $translate.instant('BusinessUnit')
                        },
                        {
                            dataField: "areaName",
                            caption: $translate.instant('AreaTitleName'),
                            width:100
                        },
                        {
                            dataField: "industryName",
                            caption: $translate.instant('PIndustry')
                        }
                ],

                loadPanel: {
                    enabled: true
                },
                scrolling: {
                    mode: "virtual"
                },
                keyExpr: "id",
                parentIdExpr: "parentId",
                selection: {
                    mode: "multiple",
                    showCheckBoxesMode: "always",
                    allowSelectAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                autoExpandAll: true,
             
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                showBorders: true,
                //sorting: {
                //    mode: "none"
                //},
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width:518,
                    visible: true
                },
                onInitialized: function (e) {
                    $scope.gridInstance = e.component;
                },
                onSelectionChanged: function (e) {
                    //整个集合 List
                    var rowList = e.selectedRowsData;
                    $scope.selectedOrgList = rowList; 
                    //只有orgID List
                    var keyList = e.selectedRowKeys;
                    $scope.selectedKeyItems = keyList;

                },
                onRowPrepared: function (e) {
                    if (e && e.data) {
                        if ($scope.originalList.indexOf(e.data.id) > -1)
                        {
                            e.rowElement.addClass("dx-state-disabled");
                        }
                    }
                },
                onContentReady: function (e, container)
                {
                    //e.element.find('.dx-selection .dx-checkbox-checked').addClass('dx-state-disabled');
                    //e.element.find('.dx-selection').addClass('dx-state-disabled');
                    //e.element.find('.dx-selection .dx-checkbox-checked').addClass('dx-state-disabled');

                    //var $checkBox = $('.dx-header-row .dx-checkbox').first();
                    //$checkBox.on('dxclick', function (e) {
                    //    var isChecked = $checkBox.dxCheckBox('instance').option('value');
                    //    if (!isChecked)
                    //    {    //追加原始角色选中
                    //        if ($scope.originalList && $scope.originalList.length > 0)
                    //        {
                    //            setSelectItems($scope.originalList);
                    //        }
                    //    }
                    //});
                }
            };

        };

        (function initialize() {
            $log.debug('addExistOrganizationModalController.ctor()...');
        
            loadDatagrid();
           // showModal();
        })();
    }
]);
