﻿// Model select tree view, select multiple models with checkboxes
commonModule.directive('modelMultiSelector', ['$log', '$translate',
    function ($log, $translate) {
        'use strict';
        $log.debug('modelMultiSelector.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/model-multi-selector/model-multi-selector.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                modelDataSource: '=*',
                isShow: '=',
                selectedModelIds: '=',
                title: '=',
                selectorOptions: '=?',
                selectorApi: '=?' // In: onSelectorClose, onSelectorConfirm; Out: getGridInstance
            },
            link: function (scope, element) {
                scope.columnDefs = [{
                    visible: false,
                    caption: $translate.instant('ModelCode'),
                    dataField: 'code'
                }, {
                    caption: $translate.instant('ModelName'),                    
                    dataField: 'name'
                }, {
                    caption: $translate.instant('ModelDescription'),
                    width: '20%',
                    dataField: 'description'
                }, {
                    caption: $translate.instant('ModelFeature'),
                    dataField: 'featureName'
                }, {
                    caption: $translate.instant('ModelType'),
                    dataField: 'modelTypeName'
                }, {
                    caption: $translate.instant('ModelOrganization'),
                    dataField: 'organizationName'
                }, {
                    visible: false,
                    dataField: 'id',
                    isIdentity: true
                }, {
                    visible: false,
                    dataField: 'parentId',
                    isParentKey: true
                }];
            }
        };
    }
]);