/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AdminAppNavController', ['$scope', '$rootScope', '$log', 'loginContext', 'enums', '$state',
function ($scope, $rootScope, $log, loginContext, enums, $state) {
    'use strict';
    $log.debug('AdminAppNavController.ctor()...');

    $scope.companyName = loginContext.projectCustomerName;

    $scope.toggleMenu = function () {
        $rootScope.$broadcast(enums.adminEvent.layoutChanged);
    };

    $scope.gotoAdminHomePage = function ($event) {
        var element = $event.target;
        if (element.hasClass('sidebar-toggler')) {
            return;
        } else {
            $state.go('adminHomePage');
        }
    };
}
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('adminAppNav', ['$log',
    function ($log) {
        'use strict';

        $log.debug('adminAppNav.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/admin-app-nav/admin-app-nav.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AdminAppNavController'
        };
    }
]);
frameworkModule.
controller('AppDocumentTreeViewController', ['$scope', '$rootScope', '$attrs', 'documentHierarchyService',
    function ($scope, $rootScope, $attrs, documentHierarchyService) {

        $scope.enableSelect = $attrs.enableSelect;
        $scope.isCollapse = $attrs.isCollapse || false;
        documentHierarchyService.getDocumentHierarchy($attrs.documentType).success(function (documentHierarchy) {
            $scope.documentHierarchy = documentHierarchy;
            $scope.$emit('to-parent', $scope.documentHierarchy);
        });

        documentHierarchyService.getDocumentList($attrs.documentType).success(function (documentList) {
            $rootScope.documentList = documentList; //uses in material-list
        });


        $scope.selectDocument = function (document, parent, clickwhere) {
            $scope.documentClick({ document: document, parent: parent, clickwhere: clickwhere });
        }
    }
]);
// appDocumentTreeView
// Document tree view
frameworkModule.directive('appDocumentTreeView', ['$log',
    function ($log) {
        'use strict';

        $log.debug('treeView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-document-tree-view/app-document-tree-view.html' + '?_=' + Math.random(),
            replace: true,
            scope: { documentClick: '&'},
            //"@" binding is for passing strings. These strings support {{}} expressions for interpolated values.
            //"=" binding is for two-way model binding. The model in parent scope is linked to the model in the directive's isolated scope.
            //"&" binding is for passing a method into your directive's scope so that it can be called within your directive.
            controller: 'AppDocumentTreeViewController',
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppFilterHeaderController', ['$scope', '$log',
function ($scope, $log) {
        'use strict';
        $log.debug('AppFilterHeaderController.ctor()...');
         
        $scope.scrollTop= function(){
            $('html,body').animate({scrollTop: '0px'}, 800);
        }
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appFilterHeader', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appFilterHeader.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-filter-header/app-filter-header.html' + '?_=' + Math.random(),
            replace: true,
            transclude: true,
            scope: {},
            controller: 'AppFilterHeaderController',
            link: function (scope, elm, attrs)
            {
                scope.version = attrs.version;
            }
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppFooterController', ['$scope', '$log',
function ($scope, $log) {
        'use strict';
        $log.debug('AppFooterController.ctor()...');
         
        $scope.scrollTop= function(){
            $('html,body').animate({scrollTop: '0px'}, 800);
        }
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appFooter', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appFooter.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-footer/app-footer.html' + '?_=' + Math.random(),
            replace: true,
            transclude: true,
            scope: {},
            controller: 'AppFooterController',
            link: function (scope, elm, attrs)
            {
                scope.version = attrs.version;
            }
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppMessageBoxController', ['$scope', '$log',
function ($scope, $log) {
        'use strict';
        $log.debug('AppNavController.ctor()...');          

        var mlist = [];
        $scope.size = 0;

        var addMessage = function (Title, Message, Content, CssClass) {
            mlist.push({ message: Message , title: Title ,content: Content , cssClass: CssClass });
            $scope.messageList = mlist;
            $scope.size = mlist.length;
        };

        

        // Just test code

        (function initialize() {
            

            // Reference the auto-generated proxy for the hub.
            var chat = $.connection.messageBoxHub;
            // Create a function that the hub can call back to display messages.

            chat.client.addNewMessageToPage = function (title, message, cssClass) {

                //Add the message to the page.
                var content = message;

                if(message.length > 20){
                    message = message.substring(0, 19) + '...';
                    cssClass += ' cursorpointer';
                }

                $('.cursorpointer').popover({ placement: "right", container: 'body' });

                addMessage(title, message, content, cssClass);
                $scope.$apply();
            };

            $.connection.hub.start().done(function () {              
                // Call the Send method on the hub.
                chat.server.send('hello', 'test Info', 'alert-info');
            });


           

        })();
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appMessageBox', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appMessageBox.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-message-box/app-message-box.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppMessageBoxController'
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppModalController', ['$scope', '$log', '$rootScope', '$translate', '$timeout', 'commonWebService', 'loginContext', 'dashboardService', '$interval',
    function ($scope, $log, $rootScope, $translate, $timeout, commonWebService, loginContext, dashboardService, $interval) {
        'use strict';
        $log.debug('AppModalController.ctor()...');

        $scope.init = function () {
            $scope.verifyIsSame = true;
            $scope.oldNewIsSame = false;
            $scope.isSubmited = false;
            $scope.operationStatus = 0;
            $scope.operationFailInfo = "";

            $scope.oldpassword = '';
            $scope.newpassword = '';
            $scope.newpassword_verify = '';

            $scope.disableUpdate = false;
        };

        $scope.init();

        $scope.changePassword = function () {
            var num = 0;
            var number = 0;
            var letter = 0;
            var bigLetter = 0;
            var chars = 0;

            $scope.isSubmited = true;

            if ($scope.form.$invalid) {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('FollowTips');

                return;
            }

            if ($scope.oldpassword === '' || $scope.newpassword === '' || $scope.newpassword_verify === '') {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('AnyPasswordCanNotEmpty');
                return;
            }

            if ($scope.newpassword === $scope.oldpassword) {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('PasswordNotChanged');

                return;
            }

            if ($scope.newpassword !== $scope.newpassword_verify) {
                $scope.operationStatus = -1;
                $scope.operationFailInfo = $translate.instant('ConfirmTheSameInfo');

                return;
            }

            if ($scope.newpassword !== '') {
                if ($scope.newpassword.length < 6) {
                    $scope.operationStatus = -1;
                    $scope.operationFailInfo = '密码长度必须大于等于6位！';
                    return;
                }
                var reg = new RegExp('^(?![0-9]+$)(?![a-zA-Z]+$)[a-zA-Z0-9]{6,20}');
                if (!reg.test($scope.newpassword)) {
                    $scope.operationStatus = -1;
                    $scope.operationFailInfo = '密码格式不正确，必须为数字和字母组合！';
                    return;
                }
            }

            $scope.disableUpdate = true;
            var passwordList = { oldPassword: $scope.oldpassword, newPassword: $scope.newpassword };
            commonWebService.changePassword(passwordList).success(function (returnData) {
                if (returnData.result) {
                    $scope.operationStatus = 1;
                    $timeout(function () {
                        $("#changePasswordModal").modal("hide");
                    }, 3000);
                }
                else {
                    $scope.operationStatus = -1;
                    $scope.operationFailInfo = $translate.instant('Msg' + returnData.resultMsg);
                    $scope.disableUpdate = false;
                }
            });

            //Hide Error Message
            $scope.operationStatus = 0;

        };

        $rootScope.$on('event:showChangePasswordModal', function (e, d) {
            $log.debug("event:showChangePasswordModal from:" + d);

            $("#changePasswordModal").modal("show");
        });

        $rootScope.$on('event:comfirmRemove', function (e, d) {
            $log.debug("event:comfirmRemove id:" + d);

            $("#comfirmRemove").data('id', d);

            $("#comfirmRemove").modal("show");
        });

        $rootScope.$on('event:addChart', function (e, d) {
            $log.debug("event:addChart id:" + d);
            $("#addChart").modal("show");
        });

        $scope.comfirmClick = function () {
            var id = $("#comfirmRemove").data('id');
            $scope.$emit('event:comfirmRemoveResult', id);
        };

        //the success callback of getSystemChartList from dashbaord service at ln 101
        var renderTreeMenu = function (systemchartDic) {
            if (typeof (systemchartDic) === "undefined") {
                return;
            }
            var systemchartList = [];
            for (var key in systemchartDic) {
                if (systemchartDic.haOwnProperty(key)) {
                    for (var val in systemchartDic[key]) {
                        if (systemchartDic[key].haOwnProperty(val)) {
                            var chartDto = systemchartDic[key][val];
                            if (!angular.isFunction(chartDto)) {
                                systemchartList.push(chartDto);
                            }
                        }
                    }
                }
            };

            $scope.systemchartDic = systemchartDic;
            $scope.systemchartList4filter = systemchartList;
            $scope.systemchartList = systemchartList;

            $(document).on('click', '.tree-toggle', function () {
                $(this).parent().children('ul.tree').toggle(200);
            });

            $scope.chartName = "自定义仪表盘";
            $scope.chartDescription = "你可以添加新图表，通过拖拽来改变图表放置的位置，也可以删除不需要的图表。<br/>你可以在添加图表功能中选择数据源，系统会为你添加所选择图表在你的仪表盘中。<br/>你可以在编辑图表功能中修改分析维度以及图表样式。";
            $scope.imgUrl = "../../../app-resources/images/addchart/u6.png";
            $scope.systemchartId = "000000";
            $scope.showAddButton = false;
        };

        $scope.initSystemChart = function () {
            $log.debug('AppModalController.initSystemChart()...');
            dashboardService.getSystemChartList().success(renderTreeMenu);
        };

        $scope.showDetail = function (item) {
            if ($scope.noClick) {
                return false;
            }
            $scope.chartName = item.systemChartName;
            $scope.chartDescription = item.description;
            $scope.imgUrl = item.imgUrl;
            $scope.systemchartId = item.systemChartID;
            $scope.showAddButton = true;
        };

        var getUserchartId = function (data) {
            $log.debug('user chart id:' + data);
            $scope.$emit('event:addUserChart', data);
        }

        $scope.confirmAdd = function () {
            dashboardService.addUserChart($scope.systemchartId).success(getUserchartId);
        };


        $scope.showStyle = { display: 'block' };
        $scope.hideStyle = { display: 'none' };

        (function initialize() {
            $log.debug('AppModalController.initialize()...');

            $("#changePasswordModal").on('show.bs.modal', function () {
                $log.debug('The modal is about to be shown.');

                $scope.init();
            });

            //$scope.initSystemChart();

            $('#filter').bind('focus', function () {
                $(this).val('');/*清除数据*/
                var time = $interval(function () {
                    var filter_str = $('#filter').val();

                    var filterArray = [];
                    angular.forEach($scope.systemchartList4filter, function (item) {
                        if (item.systemChartName.indexOf(filter_str) >= 0) {
                            filterArray.push(item);
                        }
                    });

                    $scope.noClick = false;
                    if (filterArray.length == 0) {
                        filterArray.push({ "systemChartName": "NoSearchContent" });
                        $scope.noClick = true;
                    }

                    $scope.queryResult = filterArray;
                    if (filter_str.length > 0) {
                        $scope.showSearch = true;
                    }
                    else {
                        $scope.showSearch = false;
                    }

                }, 300);/*每300毫秒秒执行一次搜索，time是停止本方法的参数*/
                $(this).bind('blur', function () {
                    $interval.cancel(time); /*停止setInterval*/
                });
            });
        })();
    }]);
/// <reference path="app-modal.ctrl.js" />
  
frameworkModule.filter('searchFilter', [function () {

    return function (originalArray, query) {
        if (!angular.isUndefined(originalArray) && !angular.isUndefined(query) && query.length > 0) {
            var tempClients = [];

            angular.forEach(originalArray, function (item) {
                if (item.systemChartName.indexOf(query) >= 0) {
                    tempClients.push(item);
                }
            }); 
            return tempClients;

        } else {
            return originalArray;
        }
    };
}]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appModal', ['$log',
    function ($log)
    {
        'use strict';

        $log.debug('appModal.ctor()...');

        return {
            restrict: 'E',
            require: "appModal",
            templateUrl: '/app/framework/app-modal/app-modal.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                passwordVerify: '='
            },
            controller: 'AppModalController'            
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppNavBarController', ['$scope', '$log', '$cookies', '$filter', 'loginContext',
function ($scope, $log, $cookies, $filter, loginContext)
{
    'use strict';

    var shownKey = 'shownChangePasswordOf' + loginContext.passwordHash;

    $log.debug('AppNavController.ctor()...');

    $scope.username = loginContext.userName;
    $scope.isExternalUser = loginContext.isExternalUser;

    $scope.showChangePassword = function ()
    {
        $scope.$emit('event:showChangePasswordModal', 'click');
    }

    var todayIsShowed = $cookies.get(shownKey);

    if (loginContext.needChangePassword & !todayIsShowed)
    {
        $scope.$emit('event:showChangePasswordModal', 'auto');


        $cookies.put(shownKey, true);
    }
}
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appNavBar', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNavBar.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav-bar/app-nav-bar.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavBarController'
        };
    }
]);
frameworkModule.controller('AppNavContainer', ['$scope', '$log', '$state',
    function ($scope, $log, $state) {
        'use strict';
        $log.debug('AppNavContainer.ctor()...');

        (function initialize() {
            $log.debug('AppNavContainer.initialize()...');

            $scope.$state = $state;
        }());
    }]);
frameworkModule.directive('appNavContainer', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNavContainer.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav-container/app-nav-container.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavContainer'
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppNavTabController', ['$scope', '$rootScope', '$log', 'enums', 'appTabManager', 'appRoute', '$timeout', 
function ($scope, $rootScope, $log, enums, appTabManager, appRoute, $timeout)
{
        'use strict';
        $log.debug('AppNavTabController.ctor()...');

        var triggeredbyUser = false;
        // select the specified tab from UI or code
        var selectTab = function (tab) {
            $log.debug('AppNavTabController.selectTab(): ' + JSON.stringify({
                tabId: tab.tabId,
                tabName: tab.tabName
            }));

            if ($scope.selectedTab !== tab) {
                appRoute.navigateFromTab(tab, triggeredbyUser);
                triggeredbyUser = false
                $scope.selectedTab = tab;
                appTabManager.selectOpenedTab(tab);
            }           
        };

        // click the specified tab from UI
        var clickTab = function (tab) {
            $log.debug('AppNavTabController.clickTab(): ' + JSON.stringify({
                tabId: tab.tabId,
                tabName: tab.tabName
            }));

            triggeredbyUser = true;

           
        };

        var navigate = function (tabType, eventData) {
            $timeout(function () {
                appRoute.navigate(tabType, eventData);
            }, 0);
        };

        (function initialize() {

            $log.debug('AppNavTabController.initialize()...');

            // properties
            $scope.selectedTab = null;
            $scope.tabs = appTabManager.tabs;

            // methods
            $scope.selectTab = selectTab;
            $scope.clickTab = clickTab;
            $scope.closeTab = function (index) {
                $timeout(function () {
                    appTabManager.closeTabByIndex(index);

                    appRoute.navigateFromTab($scope.tabs[0], triggeredbyUser);
                    triggeredbyUser = false
                    $scope.selectedTab = $scope.tabs[0];
                    appTabManager.selectOpenedTab($scope.tabs[0]);
                }, 0);
            };
            
            // register events
            $rootScope.$on('event:editChart', function (e, d)
            {
                navigate(enums.tabType.chartEdit,
                new appRoute.chartSettingEventData({
                    needActivate: true,
                    chartId: d
                }));
                $scope.selectedTab = null;
            });

            // register events
            $rootScope.$on('event:closeCurrentTab', function ()
            {
                appTabManager.closeCurrentTab();

                appRoute.navigateFromTab($scope.tabs[0], triggeredbyUser);
                triggeredbyUser = false
                $scope.selectedTab = $scope.tabs[0];
                appTabManager.selectOpenedTab($scope.tabs[0]);
            });

            // always load worklist as primary tab at the very beginning

            
            navigate(enums.tabType.dashboard, 
                new appRoute.comonEventData({
                    needActivate: true
                }));
            

            // register events
            $scope.$on('$stateChangeStart',
                function (event, toState, toParams)
                {
                    // transitionTo() promise will be rejected with 
                    // a 'transition prevented' error
                   
                    if (toState == null) {
                        return;
                    }

                    var url = toState.url;

                    var paramList = Object.keys(toParams);

                    _.forEach(paramList, function (item)
                    {
                        url = url.replace("{" + item + "}", toParams[item]);
                    });
                    
                    if (typeof (toState.name) !== 'undefined')
                    {
                       

                        $log.debug("state name:" + toState.name);

                        navigate(enums.tabType.commonUrl,
                        new appRoute.comonEventData({
                            needActivate: true,
                            stateName:toState.name,
                            url: url,
                            param: toParams.param
                        }));
                    }
                });

        }());
    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appNavTab', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNavBar.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav-tab/app-nav-tab.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavTabController'
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AppNavController', ['$rootScope', '$scope', '$log', '$state' ,'loginContext', 'application', 'userService', '$translate', 'vatSessionService', '$interval', 'workflowService',
    function ($rootScope, $scope, $log, $state ,loginContext, application, userService, $translate, vatSessionService, $interval, workflowService) {
        'use strict';
        $log.debug('AppNavController.ctor()...');

        $scope.companyName = loginContext.projectCustomerName;
        $scope.loginUserName = loginContext.userName;
        $scope.tpUrl = loginContext.tpUrl;
        $scope.hasUnreadMsg = true;
        $scope.msgNum = 0;
        $scope.showSubMenu = true;
        $scope.linkAdmin = false;
        $scope.specialUser = $scope.loginUserName.toLowerCase();

        $scope.hasQuerySummaryDashboardCode = false;

        var interval = $interval(function () {
            var data = vatSessionService.userPermission;

            if (data.isAdmin == undefined) return;

            if (data.isAdmin || (data.navigationUrlList && data.navigationUrlList.length > 0)) {
                $scope.linkAdmin = true;
            }
            $interval.cancel(interval);

            $scope.hasQuerySummaryDashboardCode = window.PWC.isHavePermission(constant.vatPermission.dataAnalysis.dashboard.querySummaryDashboardCode, data);
        }, 500);

        //userService.getUserPermission(loginContext.userName).success(function (data) {
        //    if (data) {
        //        if (data.isAdmin || (data.navigationUrlList && data.navigationUrlList.length > 0)) {
        //            $rootScope.linkAdmin = true;
        //        }

        //        $scope.hasQuerySummaryDashboardCode = window.PWC.isHavePermission(constant.vatPermission.dashboard.querySummaryDashboardCode, data)
        //    }
        //});
        $rootScope.$on('notification-read', function () {
            $scope.msgNum--;
        });
        
       var getNotificationInfo = function () {
            $scope.notificationCriteriaX = {
                isFirstTimeLoading: false,
                filterType: "MAIN",
                serviceType: 2,
                mainFilter: "UNREAD",
                singleNode: null,
                singleTask: null,
                multipleNode: null,
                multipleTask: null,
                multipleStatus: null,
                multipleDueDate: null,
                multiplePriority: null,
                multipleType: null,
                searchKeyword: ""
            };

            workflowService.getPushNotifications($scope.notificationCriteriaX).success(function (notifications) {
                if (notifications != null && notifications.notificationList != null)
                    $scope.msgNum = notifications.notificationList.length;
            });
        };

        $scope.setDashboardFlag = function () {
            vatSessionService.urlFromAnalyze = false;
            return true;
        };

        $scope.toggleSubMenu = function (showsub) {
            $scope.showSubMenu = !$scope.showSubMenu;
            //$scope.$emit(application.events.showSubMenu, {direction:'up', show:$scope.showSubMenu});
        };

        $scope.showChangePassword = function () {
            $("#changePasswordModal").modal('show');
            $('.user-menu').css('display', 'none');
        }
        $scope.toggleUserMenu = function (event) {
            if (event.target.parentElement.className === 'user-info' || event.target.parentElement.className === 'ng-binding') {
                $('.user-menu').toggle();
            }
            event.stopPropagation();
        };

        var initSubHeader = function () {
            var enterSubHeader = false;
            $('[hover-show]').hover(function () {
                var className = $(this).attr('hover-show');
                $('.nav-sub-container').hide();
                $('.nav-sub-container.' + className).show();
            }, function () {
                setTimeout(function () { //等待 nav-sub-container hover 设置上对应的值
                    if (enterSubHeader) {
                        var className = $(this).attr('hover-show');
                        $('.nav-sub-container.' + className).hide();
                    }
                }, 200);
            });

            $('.nav-sub-container').hover(function () {
                enterSubHeader = true;
            }, function () {
                enterSubHeader = false;
                $('.nav-sub-container').hide();
            });


            
        };

        //设置 菜单选中状态
        var initState = function(){
            $($('.nav-container .nav-element-left a')[0]).addClass('active');

            $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {                
                $log.debug("$stateChangeStart: toState="+toState.name);

                $('.nav-container .nav-element-left a').removeClass('active');
                $($('.nav-container .nav-element-left a')[getMenuIndex(toState.name)]).addClass('active');
            });
        };

        var getMenuIndex = function(name){
            switch(name){
                case 'GlobalSearch': return 0;
                case 'summary': return 0;
                case 'summaryDashboard': return 3;
                case 'RiskPanel': return 3;
                case 'DataSummary': return 3;
                default: return 2;
            };       
        };

        $scope.search = function(){
            PWC.simulateProgress();
            $state.go('GlobalSearch');
        };


        $(document).click(function (event) {
            $('.user-menu').css('display', 'none');
            event.stopPropagation();
        });

        (function initialize() {
            initSubHeader();
            initState();
            getNotificationInfo();
        })();

    }
]);
// appNavBar
// navigation bar for application
frameworkModule.directive('appNav', ['$log',
    function ($log) {
        'use strict';

        $log.debug('appNav.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-nav/app-nav.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'AppNavController',
            link: function ($scope, $element, $attr) {
                $element.find('.nav-element-left a').click(function () {
                    $('.nav-element-left a').removeClass('active');
                    $(this).addClass('active');
                });

                $scope.callIframe = function () {

                    $("#dfiframe").contents().find("a:first").click();
                };
            }
        };
    }
]);
frameworkModule.controller('appOverviewController', ['$rootScope', '$scope', '$timeout', '$q', '$log', '$translate', '$state', '$interval',
    'uiGridConstants', 'projectService', 'vatSessionService', 'orgService', 'serviceTypeService', 'userService', 'loginContext', 'enums',
    'citSessionService', 'region', 'SweetAlert', 'productService', 'localStorageService', 'assetsManageSessionService','serviceLogService',
    'ackUibModal', 'Upload', 'apiInterceptor',
    function ($rootScope, $scope, $timeout, $q, $log, $translate, $state, $interval, uiGridConstants, projectService, vatSessionService,
        orgService, serviceTypeService, userService, loginContext, enums, citSessionService, region, SweetAlert, productService,
        localStorageService, assetsManageSessionService, serviceLogService, ackUibModal, Upload, apiInterceptor) {
        'use strict';
        $log.debug('appOverviewController.ctor()...');
        var uploadUrl = apiInterceptor.webApiHostUrl + '/product/NewFile';
        var resumable = true;
        $scope.chunkSize = 100000;
        $scope.conditionChange = false;
        var token = $('input[name="__RequestVerificationToken"]').val();
        //$scope.randomDemoData = {
        //    projectId:null,
        //    taxAmount: 0,
        //    prepadidTaxAmount: 0,
        //    taxRate: 0
        //};

        //**********************************************************************************************
        $scope.dateFormat = $translate.instant('dateFormat4Year');
        //always select a month before current month: update the year if the current month is Jan.(1)
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth();
        //$scope.selectedDate = new Date(year, month - 1, 1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.selectedStartDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.serviceTypeId = $scope.servicetypeid.toString();
        $scope.ongoingNum = 0;
        $scope.notBeginNum = 0;
        $scope.completedNum = 0;
        //*************************************************************************************************
        $scope.randomCounter = 0;
        $scope.allResults = [];
        $scope.checkedOrgs = {};
        $scope.orgList = [];
        $scope.orderYear = true;
        $scope.orderName = true;
        $scope.orderStatus = true;
        $scope.orderType = true;
        $scope.isFirst = true;
        $scope.haveVatPermission = false;


        $scope.currentSelectedMonth = vatSessionService.month;
        $scope.currentSelectedYear = vatSessionService.year;

        var thisData = {
            userPermission: {}
        };

        userService.getUserByName(loginContext.userName).success(function (userData) {
            vatSessionService.logUser = userData;
        });

        $scope.doWorkflowSort = function (sortstr) {
            $scope.randomCounter++;

            $scope.sortString = sortstr + "_" + $scope.randomCounter;

        };

        //设置项目状态Title
        function setLayoutStatusTitle(statusIds) {

            var currentMonth = vatSessionService.month;
            var statusId;

            //(p.projectStatusList !== null && p.projectStatusList[1] !== undefined) ? setLayoutStatusTitle(p.projectStatusList[1]) : $scope.translateProjectStatus(p.haveCreateProject)
            if (statusIds === null || (statusIds !== null && statusIds[currentMonth] === undefined))
                statusId = 0;
            else {
                statusId = statusIds[currentMonth];
            }
            var status = "../../../app-resources/images/overview/";
            if (region === 'zh-CN') {
                status += 'zh-CN';
            }
            else {
                status += 'en-US';
            }

            // $log.debug("setLayoutStatusTitle");
            // $scope.statusTitle = $translate.instant('ProjectStatusTitle');
            switch (statusId) {
                case constant.ProjectStatusEnum.UnStarted:
                    status += "/01.png"; //$translate.instant('ProjectStatusUnStarted');
                    break;
                case constant.ProjectStatusEnum.Imported:
                    status += "/02.png"; // $translate.instant('ProjectStatusImported');
                    break;
                case constant.ProjectStatusEnum.AccountMapSubmitted:
                    status += "/03.png";// $translate.instant('ProjectStatusAcccountMapSubmitted');
                    break;
                case constant.ProjectStatusEnum.Generated:
                    status += "/04.png";// $translate.instant('ProjectStatusGenerated');
                    break;
                case constant.ProjectStatusEnum.ReportSubmitted:
                    status += "/05.png"; //$translate.instant('ProjectStatusReportSubmitted');
                    break;
                case constant.ProjectStatusEnum.ReportApproved:
                    status += "/07.png"; //$translate.instant('ProjectStatusReportApproved');
                    break;
                case constant.ProjectStatusEnum.ReportRejected:
                    status += "/06.png"; //$translate.instant('ProjectStatusReportRejected');
                    break;
                case constant.ProjectStatusEnum.Completed:
                    status += "/08.png";// $translate.instant('ProejctStatusCompleted');
                    break;
                default:
                    status += "/01.png";
            }

            return status;
        }

        function setLayoutStatusTitleForCIT(statusIds) {

            var currentMonth = vatSessionService.month;
            var statusId;

            //(p.projectStatusList !== null && p.projectStatusList[1] !== undefined) ? setLayoutStatusTitle(p.projectStatusList[1]) : $scope.translateProjectStatus(p.haveCreateProject)
            if (statusIds === null || (statusIds !== null && statusIds.length === 0))
                statusId = 0;
            else {
                statusId = statusIds[Object.keys(statusIds)[Object.keys(statusIds).length - 1]]
                // statusId = statusIds[currentMonth];
            }
            var status = "../../../app-resources/images/overview/";
            if (region === 'zh-CN') {
                status += 'zh-CN';
            }
            else {
                status += 'en-US';
            }

            // $log.debug("setLayoutStatusTitle");
            // $scope.statusTitle = $translate.instant('ProjectStatusTitle');
            switch (statusId) {
                case constant.ProjectStatusEnum.UnStarted:
                    status += "/01.png"; //$translate.instant('ProjectStatusUnStarted');
                    break;
                case constant.ProjectStatusEnum.Imported:
                    status += "/02.png"; // $translate.instant('ProjectStatusImported');
                    break;
                case constant.ProjectStatusEnum.AccountMapSubmitted:
                    status += "/03.png";// $translate.instant('ProjectStatusAcccountMapSubmitted');
                    break;
                case constant.ProjectStatusEnum.Generated:
                    status += "/04.png";// $translate.instant('ProjectStatusGenerated');
                    break;
                case constant.ProjectStatusEnum.ReportSubmitted:
                    status += "/05.png"; //$translate.instant('ProjectStatusReportSubmitted');
                    break;
                case constant.ProjectStatusEnum.ReportApproved:
                    status += "/07.png"; //$translate.instant('ProjectStatusReportApproved');
                    break;
                case constant.ProjectStatusEnum.ReportRejected:
                    status += "/06.png"; //$translate.instant('ProjectStatusReportRejected');
                    break;
                case constant.ProjectStatusEnum.Completed:
                    status += "/08.png";// $translate.instant('ProejctStatusCompleted');
                    break;
                default:
                    status += "/01.png";
            }

            return status;
        }

        function initListGrid() {
            var listColumns = [
            { caption: $translate.instant('SequenceNo'), dataField: "index", width: 100, },
            //{ caption: $translate.instant('SapDate'), dataField: "sapDate", dataType: "date", format: "yyyy-MM-dd", },
            //{ caption: $translate.instant('ProjectNameCol'), dataField: "name", },
            { caption: $translate.instant('ProjectCompanyCol'), dataField: "organizationName", },
            { caption: $translate.instant('PIndustry'), dataField: "industryName", },
            //{
            //    caption: $translate.instant('SapProductType'), dataField: "sapProductType",
            //    calculateCellValue: function (rowData) {
            //        return rowData.sapProductType ? convertProductTypeToStr(rowData.sapProductType) : null;
            //    },
            //},
            { caption: $translate.instant('ProjectYearCol'), dataField: "year", width: 100, },
            { caption: $translate.instant('ProjectServiceCol'), dataField: "serviceTypeName", },
            { caption: $translate.instant('ProjectStatus'), dataField: "projectStatusDisplay", },
           // {
           //     caption: $translate.instant('TotalBuildAmount'), dataField: "totalAmount",
           //     format: { type: 'fixedPoint', precision: 2 },
           // },
            ];
            $scope.deferStatus = true;
            $scope.gridListOptions = {
                columns: listColumns,
                bindingOptions: {
                    "dataSource": "queryResults"
                },
                loadPanel: {
                    enabled: true
                },
                //scrolling: {
                //    mode: "virtual"
                //},  
                hoverStateEnabled: true,
                paging: { pageSize: 20 },
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                selection: { mode: "single" },
                onRowClick: function (e) {
                    $scope.goToService(e.data);
                }
            }
        };

        // TODO: REAL Translation for Industry and Region
        var initIndustryName = function (industryID, industryName) {
            var industryKey = '';
            switch (industryID) {
                case '0':
                    industryKey = 'GeneralIndustry';
                    break;
                case '1':
                    industryKey = 'IndustryIndustry';
                    break;
                case '10':
                    industryKey = 'AssetManagement';
                    break;
                case '13':
                    industryKey = 'MobileManufacturingIndustry';
                    break;
                case '14':
                    industryKey = 'FinancialServiceIndustry';
                    break;
                case '20':
                    industryKey = 'ManufacturingIndustry';
                    break;
                case '23':
                    industryKey = 'EstateIndustry';
                    break;
                default:
                    break;
            }

            if (!_.isEmpty(industryKey)) {
                industryName = $translate.instant(industryKey);
            }

            return industryName;
        };

        var initRegionName = function (regionID, regionName) {
            var regionKey = '';
            switch (regionID) {
                case '310000':
                case '310100':
                    regionKey = 'Shanghai';
                    break;
                case '110000':
                case '110100':
                    regionKey = 'Beijing';
                    break;
                case '440300':
                    regionKey = 'Shenzhen';
                    break;
                default:
                    break;
            }

            if (!_.isEmpty(regionKey)) {
                regionName = $translate.instant(regionKey);
            }

            return regionName;
        };

        $scope.initCitDataProcessMockData = function () {
            var task = function (id, status, name, tasklevel, parentId, hasButton, seqNo) {
                this.id = id;
                this.name = _.isEmpty(name) ? $translate.instant(id) : name;
                this.status = status;
                this.text = $translate.instant(status);
                this.tasklevel = tasklevel;
                this.parentId = parentId;
                this.hasButton = hasButton;
                this.ngClassCol = '';
                this.seqNo = seqNo;
            };

            var result = [];
            result.push(new task(1, constant.DataProccessStatus.ToUpdate, 'DataProcessDataName_UpdateTB', 1, 0, true, 1));
            result.push(new task(2, constant.DataProccessStatus.Unstarted, 'DataProcessDataName_GenerateReport', 1, 0, false, 2));
            result.push(new task(3, constant.DataProccessStatus.ToUpdate, 'DataProcessDataName_UpdateReportConfig', 2, 2, true, 3));
            result.push(new task(4, constant.DataProccessStatus.ToUpdate, 'DataProcessDataName_FinanceReport', 2, 2, true, 4));
            result.push(new task(5, constant.DataProccessStatus.Unstarted, 'DataProcessDataName_CITQuarterly', 2, 2, false, 5));
            result.push(new task(6, constant.DataProccessStatus.Completed,'DataProcessDataName_CITFirstQuarterly', 3, 5, true, 6));
            result.push(new task(7, constant.DataProccessStatus.Unstarted,'DataProcessDataName_CITSecondQuarterly', 3, 5, true, 6));
            result.push(new task(8, constant.DataProccessStatus.NoData, 'DataProcessDataName_CITThirdQuarterly', 3, 5, true, 6));
            result.push(new task(9, constant.DataProccessStatus.NoData, 'DataProcessDataName_CITForthQuarterly', 3, 5, true, 6));
            result.push(new task(10, constant.DataProccessStatus.Unstarted, 'DataProcessDataName_YearWorkPaper', 2, 2, true, 7));
            result.push(new task(11, constant.DataProccessStatus.Unstarted, 'DataProcessDataName_AnnualSettlement', 2, 2, true, 8));
            result.push(new task(12, constant.DataProccessStatus.Completed, 'DataProcessDataName_ModelAnalysis', 1, 0, true, 9));
            return result;
        }


        $scope.initProjectList = function (orgID, serviceID, projectYear) {
            $scope.currentView = 'cardView';
            if (!orgID) {
                orgID = '';
            }
            if (!serviceID) {
                serviceID = '';
            }
            if (!projectYear) {
                projectYear = null;
            }

            projectService.getAllProjectList(orgID, serviceID, projectYear).success(function (projectListData) {
                if (projectListData && projectListData.length > 0) {
                    var index = 1;
                    $timeout(function () {
                        projectListData.forEach(function (p) {
                            //if (thisDataService.isHaveOrganizationPermission(p.organizationID)) {
                            if (PWC.isHavePermissionForOrg(p.organizationID, vatSessionService.userPermission))
                                // && $scope.haveVatPermission)
                                {
                                $scope.allResults.push({
                                    index: index++,
                                    id: p.id,
                                    name: p.name,
                                    year: p.year,
                                    code: p.code,
                                    clientCode: p.clientCode,
                                    isActive: p.isActive,
                                    createTime: p.createTime,
                                    updateTime: p.updateTime,
                                    regionID: p.regionID,
                                    industryID: p.industryID,
                                    ruleType: p.ruleType,
                                    organizationID: p.organizationID,
                                    dbName: p.dbName,
                                    serviceTypeID: p.serviceTypeID,
                                    region: p.region,

                                    haveCreateProject: p.haveCreateProject,
                                    yearDisplay: $scope.getYearDisplay(p),
                                    projectStatusDisplay: $scope.translateProjectStatus(p.haveCreateProject),
                                    serviceIcon: getServiceIcon(p.serviceTypeID),
                                    color: getColor(p.serviceTypeID),
                                    organizationName: p.organizationName,
                                    serviceTypeName: getServiceTypeName(p.serviceTypeID),
                                    industryName: initIndustryName(p.industryID, p.industryName), //p.industryName,
                                    enterpriseAccountSetID: p.enterpriseAccountSetID,
                                    templateGroupID: p.templateGroupID,
                                    startPeriod: p.startPeriod,
                                    endPeriod: p.endPeriod,
                                    projectStatusList: p.projectStatusList, //Dictionary<int,int>类型，存放当前项目每个期间的状态的。第一个int:期间，第二个int:状态
                                    importSubStatus: null, //当前项目，当前期间的子状态（是否导入Tb，序时账等等）     
                                    workflow: null, //当前项目workflow数据
                                    regionName: initRegionName(p.regionID, p.regionName), //p.regionName,
                                    finalStatus: setLayoutStatusTitle(null) //(p.projectStatusList !== null && p.projectStatusList[1] !== undefined) ? setLayoutStatusTitle(p.projectStatusList[1]) : $scope.translateProjectStatus(p.haveCreateProject)
                                    , taxAmount: 0
                                    , prepadidTaxAmount: 0
                                    , taxRate: 0
                                    , periodDate: getPeriodDate(p.serviceTypeID)
                                    , modelAbnormal: false
                                    , riskWarning: false
                                    , reportAbnormal: false,
                                    citDataProcessMockData: $scope.initCitDataProcessMockData()
                                });

                            }
                        });

                        vatSessionService.projects = _.clone($scope.allResults);
                        $scope.queryResults = _.clone($scope.allResults);
                        $scope.gridListOptions.bindingOptions = { "dataSource": "queryResults" };
                        //$scope.query();
                        goQueryState();
                    }, 300);
                } else {
                    vatSessionService.projects = [];
                    $scope.queryResults = [];
                    $scope.gridListOptions.bindingOptions = [];
                }
            });
        };

        $scope.smartSearch = function (isReset) {
            if (isReset) {
                $scope.searchKeyword = "";
            }
            vatSessionService.queryDto.searchKeyword = $scope.searchKeyword;
            if ($scope.serviceTypeId !== '12') {
                $scope.query();
            }
        };

        $scope.translateProjectStatus = function (isCreate) {
            if (isCreate) {
                return $translate.instant('OnGoing');
            } else {
                return $translate.instant('NotBegin');
            }
        }

        $scope.getYearDisplay = function (p) {
            if (p.serviceTypeID === enums.serviceType.VAT || p.serviceTypeID === enums.serviceType.AssetsManage) {
                return p.year + "." + p.startPeriod + "-" + p.year + "." + p.endPeriod;
            } else {
                return p.year;
            }
        }

        var getColor = function (serType) {
            var color = "#e0301e";
            switch (serType) {
                case enums.serviceType.VAT:
                    color = "#e0301e";
                    break;
                case enums.serviceType.FDD:
                    color = "#d04a02";
                    break;
                case enums.serviceType.CIT:
                    color = "#a32020";
                    break;
                case enums.serviceType.TaxAudit:
                    color = "#602320";
                    break;
                case enums.serviceType.RPT:
                    color = "#d93954";
                    break;
            }
            return color;
        };

        var getServiceIcon = function (serType) {
            var type = "fa fa-diamond";
            switch (serType) {
                case enums.serviceType.VAT:
                    type = "fa fa-diamond";
                    break;
                case enums.serviceType.FDD:
                    type = "fa fa-credit-card";
                    break;
                case enums.serviceType.CIT:
                    type = "fa fa-building";
                    break;
                case enums.serviceType.TaxAudit:
                    type = "fa fa-money";
                    break;
                case enums.serviceType.RPT:
                    type = "fa fa-globe";
                    break;
            }
            return type;
        };

        var getServiceTypeName = function (serType) {
            var rtn;
            switch (serType) {
                case enums.serviceType.VAT:
                    rtn = $translate.instant("VATType");
                    break;
                case enums.serviceType.CIT:
                    rtn = $translate.instant("CITType");
                    break;
                default:
                    rtn = $translate.instant("VATType");
                    break;
        }
            return rtn;
        };

        var getPeriodDate = function (serType) {
            var periodDate;
            if (serType === enums.serviceType.CIT) {
                periodDate = $scope.currentSelectedYear + "";
            }
            else {
                periodDate = $scope.currentSelectedYear + "." + $scope.currentSelectedMonth;
            }
            return periodDate;
        };

        $scope.query = function () {
            if (!$scope.allResults) return;
            var temp = $scope.allResults;

            if ($scope.checkedOrgs && _.keys($scope.checkedOrgs).length > 0) {
                temp = _.filter(temp, function (i) {
                    return _.contains(_.values($scope.checkedOrgs), i.organizationName);
                });
            }
            //if ($scope.checkedYears && $scope.checkedYears.length > 0) {
            //    temp = _.filter(temp, function (i) { return _.contains(_.pluck($scope.checkedYears, 'name'), i.year) })
            //}
            if ($scope.serviceTypeId) {
                temp = _.filter(temp, function (i) {
                    return $scope.serviceTypeId == i.serviceTypeID;
                });
            }
            if (vatSessionService.year) {
                if ($scope.serviceTypeId === enums.serviceType.VAT) {
                    temp = _.filter(temp, function (i) {
                        if (i.startPeriod <= vatSessionService.month && i.endPeriod >= vatSessionService.month && i.year == vatSessionService.year) {
                            return i;
                        }
                    });
                }
                else if ($scope.serviceTypeId === enums.serviceType.CIT) {
                    temp = _.filter(temp, function (i) {
                        return vatSessionService.year == i.year;
                    });
                }
            }
            if ($scope.checkedRegions && $scope.checkedRegions.length > 0) {
                temp = _.filter(temp, function (i) {
                    return _.contains(_.pluck($scope.checkedRegions, 'name'), i.region);
                });
            }
            if ($scope.checkedStatus && $scope.checkedStatus.length > 0) {
                temp = _.filter(temp, function (i) {
                    return _.contains(_.pluck($scope.checkedStatus, 'name'), i.status);
                });
            }
            if ($scope.searchKeyword !== undefined && $scope.searchKeyword.length > 0) {
                temp = _.filter(temp, function (i) {
                    return (i.name.toUpperCase().indexOf($scope.searchKeyword.toUpperCase()) > -1 || i.organizationName.toUpperCase().indexOf($scope.searchKeyword.toUpperCase()) > -1);
                    // return $scope.selectedService.id == i.serviceTypeID
                })
            }

            var demoData = $scope.demoDataWithStateSaved(temp);
            var counter = 0;
            var setWarningToTrue = false;

            temp.forEach(function (project) {

                setWarningToTrue = false;
                project.finalStatus = (project.serviceTypeID === enums.serviceType.VAT) ? setLayoutStatusTitle(project.projectStatusList) : setLayoutStatusTitleForCIT(project.projectStatusList);
                project.periodDate = (project.serviceTypeID === enums.serviceType.VAT) ? ($scope.currentSelectedYear + "." + $scope.currentSelectedMonth) : ($scope.currentSelectedYear + "");

                var oneDemoData = _.find(demoData, function (one) { return one.id === project.id });

                if (project.serviceTypeID === enums.serviceType.VAT) {
                    if (project.projectStatusList !== null && project.projectStatusList[vatSessionService.month] !== undefined && project.projectStatusList[vatSessionService.month] !== 10 && oneDemoData!==undefined) {
                        project.taxAmount = oneDemoData.taxAmount;
                        project.prepadidTaxAmount = oneDemoData.prepadidTaxAmount;
                        project.taxRate = oneDemoData.taxRate;
                        project.hasWarning = oneDemoData.hasWarning;

                    }

                    // START: For --->> Edmond Meng, CIT Demo
                    if (project.serviceTypeID === enums.serviceType.VAT && project.id === "8d8b13e7-07e1-4d84-8984-7b86e8ec6137" && project.code === "Demo111" && project.periodDate === '2017.1') {
                        project.taxAmount = "38669.27";
                        project.prepadidTaxAmount = "53866925.13";
                        project.taxRate = 15;
                        project.hasWarning = true;
                    }
                    // END: For --->> Edmond Meng, CIT Demo
                }
                else {
                    if (project.projectStatusList !== null && (Object.keys(project.projectStatusList).length > 0 && project.projectStatusList[Object.keys(project.projectStatusList)[Object.keys(project.projectStatusList).length - 1]] !== 10) && oneDemoData!==undefined) {
                        project.taxAmount = oneDemoData.taxAmount;
                        project.prepadidTaxAmount = oneDemoData.prepadidTaxAmount;
                        project.taxRate = oneDemoData.taxRate;
                        project.hasWarning = oneDemoData.hasWarning;

                    }
                    // START: For --->> Edmond Meng, CIT Demo
                    if (project.serviceTypeID !== enums.serviceType.VAT && project.id === "8d8b13e7-07e1-4d84-8984-7b86e8ec6137" && project.code === "Demo111") {
                        var status = "../../../app-resources/images/overview/";
                        if (region === 'zh-CN') {
                            status += 'zh-CN';
                        }
                        else {
                            status += 'en-US';
                        }
                        status += '/04.png';
                        project.finalStatus = status;
                        project.taxAmount = "38669.27";
                        project.prepadidTaxAmount = "53866925.13";
                        project.taxRate = 15;
                        project.hasWarning = true;
                    }
                    // END: For --->> Edmond Meng, CIT Demo
                }

                counter++;
            });


            $scope.queryResults = temp;
            $scope.gridListOptions.data = $scope.queryResults;
            $scope.projectMsg = $translate.instant('ProjectResultMsg').formatObj({ "ProjectNum": $scope.queryResults.length });

            var notBeginTemp = _.filter(temp, function (i) {
                if (i.serviceTypeID === enums.serviceType.VAT)
                    return ((i.projectStatusList === null || (i.projectStatusList !== null && i.projectStatusList[vatSessionService.month] === undefined) || (i.projectStatusList !== null && i.projectStatusList[vatSessionService.month] === 10)));

                else
                    return ((i.projectStatusList === null || (i.projectStatusList !== null && Object.keys(i.projectStatusList).length === 0) || i.projectStatusList[Object.keys(i.projectStatusList)[Object.keys(i.projectStatusList).length - 1]] === 10));
            });

            if (notBeginTemp) {
                $scope.notBeginNum = notBeginTemp.length;
            }
            var completedTemp = _.filter(temp, function (i) {
                if (i.serviceTypeID === enums.serviceType.VAT) {
                    if (i.projectStatusList && i.projectStatusList[vatSessionService.month] != null) {
                        return i.projectStatusList[vatSessionService.month] === 100;
                    }
                }
                else {
                    if (i.projectStatusList && i.projectStatusList.length > 0) {
                        return i.projectStatusList[Object.keys(i.projectStatusList)[Object.keys(i.projectStatusList).length - 1]] === 100;
                    }
                }
            });
            if (completedTemp) {
                $scope.completedNum = completedTemp.length;
            }
            $scope.ongoingNum = $scope.queryResults.length - $scope.notBeginNum - $scope.completedNum;
        };

        $scope.demoDataWithStateSaved = function (temp) {

            var demoData = [];
            var data;

            var demoDataComposedByLocalStorage = $scope.serviceTypeId + "_" + vatSessionService.year + "_" + vatSessionService.month;

            data = localStorageService.get(demoDataComposedByLocalStorage);

            if (data === null || data.length === 0) {
                var counter = 0;
                var everyXnumberToSetTrue = 3;
                var dData;

                // Set State:
                temp.forEach(function (item) {
                    dData = new Object();
                    //generate random data
                    dData.id = item.id;
                    dData.taxAmount = randomXToY(10000, 99999999, 2);
                    dData.prepadidTaxAmount = randomXToY(10000, 99999999, 2);
                    dData.taxRate = randomXToY(1, 35, 0);
                    dData.hasWarning = false;

                    if (counter >= everyXnumberToSetTrue && (counter % everyXnumberToSetTrue === 0))
                        dData.hasWarning = true;

                    demoData.push(dData);
                    counter++;

                });


                localStorageService.set(demoDataComposedByLocalStorage, demoData);


            }
            else {
                // Get from State:
                demoData = localStorageService.get(demoDataComposedByLocalStorage);
            }

            return demoData;
        };

        $scope.fileSort = function (sortstr) {
            if ($scope.queryResults.length > 0) {
                if (sortstr == 'year') {
                    if ($scope.orderYear) {
                        $scope.orderYear = false;
                        var list = _.sortBy($scope.queryResults, 'year');
                        $scope.queryResults = list;
                    } else {
                        $scope.orderYear = true;
                        var list = _.sortBy($scope.queryResults, 'year');
                        $scope.queryResults = list.reverse();
                    }
                }
                if (sortstr == 'name') {
                    if ($scope.orderName) {
                        $scope.orderName = false;
                        var list = _.sortBy($scope.queryResults, 'name');
                        $scope.queryResults = list;
                    } else {
                        $scope.orderName = true;
                        var list = _.sortBy($scope.queryResults, 'name');
                        $scope.queryResults = list.reverse();
                    }
                }
                if (sortstr == 'status') {
                    if ($scope.orderStatus) {
                        $scope.orderStatus = false;
                        var list = _.sortBy($scope.queryResults, 'haveCreateProject');
                        $scope.queryResults = list;
                    } else {
                        $scope.orderStatus = true;
                        var list = _.sortBy($scope.queryResults, 'haveCreateProject');
                        $scope.queryResults = list.reverse();
                    }
                }
                if (sortstr == 'type') {
                    if ($scope.orderType) {
                        $scope.orderType = false;
                        var list = _.sortBy($scope.queryResults, 'serviceTypeID');
                        $scope.queryResults = list;
                    } else {
                        $scope.orderType = true;
                        var list = _.sortBy($scope.queryResults, 'serviceTypeID');
                        $scope.queryResults = list.reverse();
                    }
                }
            }
        }

       $scope.goToService = function (project) {
                   if (!project.clicked) {
                       project.clicked = true;
                       $log.debug('goToService()...');
                       serviceLogService.addEnterProjectLog(loginContext.displayUserName, 'Enter project (id: ' + project.id + ', serviceType: ' + project.serviceTypeID + ')').then(function () {
                           if (project.serviceTypeID === enums.serviceType.AssetsManage) {
                               $state.go('assetsManage.importData.productItem');
                               assetsManageSessionService.product.fSetCode = project.fSetCode;
                               assetsManageSessionService.product.productIDs = project.productIDs;
                               assetsManageSessionService.project.organizationName = project.fSetName;
                               assetsManageSessionService.project.id = project.id;
                               assetsManageSessionService.project.serviceTypeID = project.serviceTypeID;
                               //window.location.href = '/#/assetsManage/importData/productItem';
                           }
                           else if (project.serviceTypeID === enums.serviceType.VAT) {
                               if (project.haveCreateProject) {
                                   if (_.isUndefined(project.projectStatusList[vatSessionService.month])) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                                       projectService.setProjectStatus(project.dbName, vatSessionService.month, constant.ProjectStatusEnum.UnStarted)
                                           .success(function (or) {
                                               if (or.result) {
                                                   //添加完成后，在vatSessionService.project中添加新加入的数据
                                                   project.projectStatusList[vatSessionService.month] = constant.ProjectStatusEnum.UnStarted;
                                                   vatSessionService.project = project;
                                                   goRightPath(project);
                                               }
                                           });
                                   }
                                   else {
                                       vatSessionService.project = citSessionService.project = project;
                                       goRightPath(project);
                                   }
                               } else {
                                   projectService.addProject(project).success(function (rsp) {
                                       if (rsp && rsp.result) {
                                           project.haveCreateProject = true;
                                           project.dbName = rsp.dbname;
                                           project.id = rsp.projectID;

                                           if (_.isNull(project.projectStatusList)) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                                               projectService.setProjectStatus(project.dbName, vatSessionService.month, constant.ProjectStatusEnum.UnStarted)
                                                   .success(function (or) {
                                                       if (or.result) {
                                                           projectService.getProjectAllStatus(project.dbName).success(function (org) {
                                                               //添加完成后，在vatSessionService.project中添加新加入的数据
                                                               project.projectStatusList = org;
                                                               projectService.getProjectStatus(project.dbName, project.id, vatSessionService.month)
                                                                   .success(function (or1) {
                                                                       if (or1.result) {
                                                                           project.importSubStatus = or1.data.importSubStatus;
                                                                           vatSessionService.project = project;
                                                                           goRightPath(project);
                                                                       }
                                                                   });
                                                           })
                                                       }
                                                   });
                                           }
                                           else {
                                               vatSessionService.project = project;
                                               goRightPath(project);
                                           }
                                       }
                                       else {
                                           SweetAlert.error($translate.instant('AddProjectFail'));
                                       }
                                   });
                               }
                           }
                           else { // project.serviceTypeID === enums.serviceType.CIT
                               if (project.haveCreateProject) {
                                   if (_.isUndefined(project.projectStatusList[enums.wholeYearPeriod.import])) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                                       projectService.setProjectStatus(project.dbName, enums.wholeYearPeriod.import, constant.ProjectStatusEnum.UnStarted)
                                           .success(function (or) {
                                               if (or.result) {
                                                   //添加完成后，在vatSessionService.project中添加新加入的数据
                                                   project.projectStatusList[enums.wholeYearPeriod.import] = constant.ProjectStatusEnum.UnStarted;
                                                   vatSessionService.project = citSessionService.project = project;
                                                   citSessionService.year = $scope.currentSelectedYear;
                                                   goRightPath(project);
                                               }
                                           });
                                   }
                                   else {
                                       vatSessionService.project = citSessionService.project = project;
                                       citSessionService.year = $scope.currentSelectedYear;
                                       goRightPath(project);
                                   }
                               } else {
                                   projectService.addProject(project).success(function (rsp) {
                                       if (rsp && rsp.result) {
                                           project.haveCreateProject = true;
                                           project.dbName = rsp.dbname;
                                           project.id = rsp.projectID;

                                           if (_.isNull(project.projectStatusList)) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                                               projectService.setProjectStatus(project.dbName, enums.wholeYearPeriod.import, constant.ProjectStatusEnum.UnStarted)
                                                   .success(function (or) {
                                                       if (or.result) {
                                                           projectService.getProjectAllStatus(project.dbName).success(function (org) {
                                                               //添加完成后，在vatSessionService.project中添加新加入的数据
                                                               project.projectStatusList = org;
                                                               projectService.getProjectStatus(project.dbName, project.id, enums.wholeYearPeriod.import)
                                                                   .success(function (or1) {
                                                                       if (or1.result) {
                                                                           project.importSubStatus = or1.data.importSubStatus;
                                                                           vatSessionService.project = citSessionService.project = project;
                                                                           citSessionService.year = $scope.currentSelectedYear;
                                                                           goRightPath(project);
                                                                       }
                                                                   });
                                                           })
                                                       }
                                                   });
                                           }
                                           else {
                                               vatSessionService.project = citSessionService.project = project;
                                               citSessionService.year = $scope.currentSelectedYear;
                                               goRightPath(project);
                                           }
                                       }
                                       else {
                                           SweetAlert.error($translate.instant('AddProjectFail'));
                                       }
                                   });
                               }
                           }

                           $timeout(function () {
                               project.clicked = false;
                           }, 1000);
                       });
                   }
               };


        $scope.toggleExpand = function (item) {
            item.expand = !item.expand;
        };

        var goRightPath = function (project) {
            // TODO: CIT 权限
            if (project.serviceTypeID === enums.serviceType.CIT) {
                $state.go('cit.importData.balanceSheet');
            }
            else {
            var menuList = [
                    constant.vatPermission.dataImport.balanceSheet.queryCode,
                    constant.vatPermission.dataImport.journalEntry.queryCode,
                    constant.vatPermission.dataImport.erpImport.queryCode,
                    constant.vatPermission.dataImport.outputInvoice.queryCode,
                    constant.vatPermission.dataImport.inputInvoice.queryCode,
                    constant.vatPermission.dataImport.customInvoice.queryCode,
                    constant.vatPermission.dataImport.voucherMapping.queryCode,
                    constant.vatPermission.dataImport.invoiceMapping.queryCode,
                    constant.vatPermission.dataImport.auditAdjust.queryCode,

                    constant.vatPermission.dataPreview.balanceSheet.queryCode,
                    constant.vatPermission.dataPreview.accountVoucher.queryCode,
                    constant.vatPermission.dataPreview.customInvoice.queryCode,
                    constant.vatPermission.dataPreview.outputInvoice.queryCode,
                    constant.vatPermission.dataPreview.inputInvoice.queryCode,

                    constant.vatPermission.dataManage.accountMappingCode,
                    constant.vatPermission.dataManage.goodsMappingCode,
                    constant.vatPermission.dataManage.caculateDataCode,
                    constant.vatPermission.dataManage.unbilledInvoiceCode,

                    constant.vatPermission.reportView.bsplCode,
                    constant.vatPermission.reportView.taxReturnCode,

                    constant.vatPermission.dataAnalysis.modelAnalysisCode,
                    constant.vatPermission.dataAnalysis.dashboard.dashboardCode,
                    //constant.vatPermission.dataAnalysis.vatTaxDifferenceCode,
            ];

            $scope.$root.checkUserOrganizationPermissionList(menuList).success(function (data) {
                if (data) {
                    if (data[constant.vatPermission.dataImport.balanceSheet.queryCode]) {
                        $state.go('vat.importData.balanceSheet');
                    } else if (data[constant.vatPermission.dataImport.journalEntry.queryCode]) {
                        $state.go('vat.importData.journalEntry');
                    } else if (data[constant.vatPermission.dataImport.erpImport.queryCode]) {
                        $state.go('vat.importData.erpData');
                    } else if (data[constant.vatPermission.dataImport.auditAdjust.queryCode]) {
                        $state.go('vat.importData.auditAdjust');
                    } else if (data[constant.vatPermission.dataImport.outputInvoice.queryCode]) {
                        $state.go('vat.importData.outputInvoice');
                    } else if (data[constant.vatPermission.dataImport.inputInvoice.queryCode]) {
                        $state.go('vat.importData.inputInvoice');
                    } else if (data[constant.vatPermission.dataImport.customInvoice.queryCode]) {
                        $state.go('vat.importData.customInvoice');
                    } else if (data[constant.vatPermission.dataImport.voucherMapping.queryCode]) {
                        $state.go('vat.importData.voucherMapping');
                    } else if (data[constant.vatPermission.dataImport.invoiceMapping.queryCode]) {
                        $state.go('vat.importData.invoiceMapping');
                    } else if (data[constant.vatPermission.dataPreview.balanceSheet.queryCode]) {
                        $state.go('vat.previewData.balanceSheet');
                    } else if (data[constant.vatPermission.dataPreview.accountVoucher.queryCode]) {
                        $state.go('vat.previewData.accountVoucher');
                    } else if (data[constant.vatPermission.dataPreview.inputInvoice.queryCode]) {
                        $state.go('vat.previewData.inputInvoice');
                    } else if (data[constant.vatPermission.dataPreview.outputInvoice.queryCode]) {
                        $state.go('vat.previewData.outputInvoice');
                    } else if (data[constant.vatPermission.dataPreview.customInvoice.queryCode]) {
                        $state.go('vat.previewData.customInvoice');
                    } else if (data[constant.vatPermission.dataManage.accountMappingCode]) {
                        $state.go('vat.reductionData.accountMapping');
                    } else if (data[constant.vatPermission.dataManage.goodsMappingCode]) {
                        $state.go('vat.reductionData.goodsMapping');
                    } else if (data[constant.vatPermission.dataManage.caculateDataCode]) {
                        $state.go('vat.reductionData.caculateData');
                    } else if (data[constant.vatPermission.dataManage.unbilledInvoiceCode]) {
                        $state.go('vat.reductionData.unbilledInvoice');
                    } else if (data[constant.vatPermission.reportView.bsplCode] || data[constant.vatPermission.reportView.taxReturnCode]) {
                        $state.go('vat.generateReport');
                    } else if (data[constant.vatPermission.dataAnalysis.modelAnalysisCode]) {
                        $state.go('vat.analyzeLayout.analyzeReport');
                    } else if (data[constant.vatPermission.dataAnalysis.dashboard.dashboardCode]) {
                        $state.go('analyzeOrganizeDashboard');
                    }
                    //else if (data[constant.vatPermission.dataAnalysis.vatTaxDifferenceCode]) {
                    //    $state.go('vat.analyzeLayout.vatTaxDifference');
                    //}
                }
            });
        }
        }

        $scope.toggleItemSub = function (item, parent) {

            // orgDisplay.showBusy();
            if (item.isChecked) {
                if (!item.dimensionId) {
                    $scope.checkedOrgs[item.id] = item.name;
                } else {
                    item.subOrgs.forEach(function (org) {
                        $scope.checkedOrgs[org.id] = org.name;
                        org.isChecked = true;
                    });
                }
            } else {

                if (!item.dimensionId) {
                    delete $scope.checkedOrgs[item.id];
                } else {
                    item.subOrgs.forEach(function (org) {
                        org.isChecked = false;
                        delete $scope.checkedOrgs[org.id];
                    });
                }
            }

            $scope.checkedIds = _.keys($scope.checkedOrgs);
            vatSessionService.queryDto.checkedOrgs = $scope.checkedOrgs;
            if ($scope.serviceTypeId !== enums.serviceType.AssetsManage) {
                $scope.query();
            }
            // orgDisplay.hideBusy();
        };

        $scope.toggleItemSubSpan = function (item) {
            if (item.isChecked) {
                item.isChecked = false;
            } else {
                item.isChecked = true;
            }
            $scope.toggleItemSub(item, null);
        };

        $scope.toggleView = function (clickedView) {
            if (clickedView == $scope.currentView) return;
            $scope.currentView = clickedView;
        };

        var thisDataService = {
            isHaveOrganizationPermission: function (orgID) {

                var permission = thisData.userPermission;
                var isShow = false;

                if (permission) {

                    if (permission.isSuperAdmin || permission.isADUser) {
                        isShow = true;
                    } else {

                        // 查找机构
                        var findOrg = _.find(permission.organizationPermissionList, function (num) {

                            return num.id === orgID;
                        });

                        if (findOrg && findOrg.permissionList && findOrg.permissionList.length > 0) {

                            // 查看具体权限
                            isShow = true;
                        }

                    }
                }

                return isShow;
            },
        };

        var initDatePickers = function () {
            if ($scope.serviceTypeId === enums.serviceType.CIT) {
                $scope.systemTitle = $translate.instant('CIT');
                $scope.viewMode = 2;
                $scope.dateFormat = $translate.instant('dateFormat4Year');
            }
            if ($scope.serviceTypeId === enums.serviceType.VAT) {
                $scope.systemTitle = $translate.instant('VATTitle');
                $scope.viewMode = 1;
                $scope.dateFormat = $translate.instant('dateFormat4YearMonth');
            }
            if ($scope.serviceTypeId === enums.serviceType.AssetsManage) {
                $scope.systemTitle = $translate.instant('AssetTitle');
                $scope.viewMode = 1;
                $scope.dateFormat = $translate.instant('dateFormat4YearMonth');
            }

            var ele1 = $("#overviewDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            }).on('changeDate', function (e) {
                $scope.changeDate(e);
            });
            ele1.datepicker("setDate", $scope.selectedDate);

         
        };

        $scope.changeStartDate = function (e) {
            if (e&&e.date) {
                var tempYear = e.date.getFullYear();
                var tempMonth = e.date.getMonth() + 1;
                $scope.currentSelectedStartMonth = tempMonth;
                $scope.currentSelectedStartYear = tempYear;
            }
        };

        $scope.changeDate = function (e) {
            if (e && e.date) {
                var isDateUpdated = false;
                var tempYear = e.date.getFullYear();
                var tempMonth = e.date.getMonth() + 1;

                if (tempYear !== vatSessionService.year || tempMonth !== vatSessionService.month) {
                    isDateUpdated = true;
                }

                vatSessionService.year = tempYear;
                vatSessionService.month = tempMonth;
                $scope.currentSelectedMonth = tempMonth;
                $scope.currentSelectedYear = tempYear;

                if (isDateUpdated) {
                    //$scope.$apply(function () {
                    //    $scope.conditionChange = !$scope.conditionChange;
                    //});

                    $timeout(function () {
                        $scope.conditionChange = !$scope.conditionChange;
                    });
                }
                if ($scope.serviceTypeId !== enums.serviceType.AssetsManage) {
                    $scope.query();
                }
            }
        };

        var orgDisplay = {

            orgList: [],
            grayColorD9: '#d9d9d9',
            currentIdcol: '',
            currentNamecol: 'orgName',
            activeColor: 'black',
            activeBackgroundColor: '#fbf8f5',
            whiteColor: 'white',
            main: function () {

                $scope.dimensionOrgShow = function (idcol, namecol) {

                    orgDisplay.showBusy();

                    vatSessionService.queryDto.fieldId = idcol;
                    vatSessionService.queryDto.filedName = namecol;

                    orgDisplay.currentIdcol = idcol;
                    orgDisplay.currentNamecol = namecol;

                    $('.operate-icon').css('background-color', orgDisplay.whiteColor);
                    $('.operate-icon i').css('color', orgDisplay.grayColorD9);


                    $scope.checkedOrgs = {};
                    //$scope.query();

                    var orgData = [];
                    if (idcol) {
                        orgData = orgDisplay.otherShow(idcol, namecol);
                    } else {
                        orgData = orgDisplay.orgShow();
                    }

                    $('.' + namecol).css('color', orgDisplay.activeColor);

                    $('.' + namecol).parent().css('background-color', orgDisplay.activeBackgroundColor);

                    $timeout(function () {
                        orgDisplay.hideBusy();

                        if ($scope.isFirst) {
                            $scope.setTreeChecked(orgData);
                            $scope.isFirst = false;
                        }

                        $scope.orgData = orgData;
                    }, 50);
                };

                orgDisplay.getOrgData();
            },

            getOrgData: function () {
                orgService.getOrgListLevel().success(function (data) {

                    if (!data) {
                        data = [];
                    }

                    var result = [];

                    //如果是资产管理，则只获取资产管理类型的组织机构
                    if ($scope.serviceTypeId === enums.serviceType.AssetsManage) {
                        result = _.filter(data, function (item) {
                            return item.industryID == '10';
                        });
                    }
                    else {
                        for (var i = 0; i < data.length; i++) {
                            var item = data[i];

                            if (thisDataService.isHaveOrganizationPermission(item.id)) {
                                result.push(item);
                            }
                        }
                    }

                    orgDisplay.orgList = result;

                    //$scope.dimensionOrgShow('', 'orgName');
                    $scope.dimensionOrgShow(vatSessionService.queryDto.fieldId, vatSessionService.queryDto.filedName);
                });

                // orgDisplay.orgList = testOrgList;
            },

            orgShow: function () {
                var showList = angular.copy(orgDisplay.orgList);

                // 构造父子节点

                for (var i = 0; i < showList.length; i++) {
                    var item = showList[i];
                    if (item.parentId === null) {
                        continue;
                    }

                    var parentNode = _.find(showList, function (num) {
                        return num.id === item.parentId
                    });

                    if (parentNode) {
                        continue;
                    }

                    item.parentId = orgDisplay.getParentID(item, orgDisplay.orgList, showList);
                }

                var idList = _.pluck(showList, 'id');


                var topNodeList = _.filter(showList, function (org) {
                    return idList.indexOf(org.parentId) === -1;
                });

                var orgList = [];
                topNodeList.forEach(function (org) {
                    var item = {
                        id: org.id,
                        name: org.name
                    };

                    var tempList = orgDisplay.getSubOrgDropDownList(org, showList);

                    item.subOrgs = tempList;
                    // 构造子节点
                    orgList.push(item);

                    // orgList = _.union(orgList, tempList);
                });

                return orgList;

            },

            // 获取父节点
            getParentID: function (current, allList, orgDtoList) {
                if (current.parentId === null) {
                    return null;
                }

                var findParent = _.find(allList, function (num) {
                    return num.id === current.parentId;
                });

                if (!findParent) {
                    return null;
                }

                var parent = _.find(orgDtoList, function (num) {
                    return num.id === findParent.id;
                });

                if (parent != null) {
                    return parent.id;
                } else {
                    return orgDisplay.getParentID(findParent, allList, orgDtoList);
                }
            },
            getSubOrgDropDownList: function (current, showList) {
                var sublist = _.filter(showList, function (row) {
                    return row.parentId === current.id;
                });

                var list = [];
                if (!sublist || sublist.length === 0) {
                    return list;
                }

                sublist.forEach(function (row) {
                    var item = {
                        id: row.id,
                        name: row.name,
                        parentId: current.id,
                        expanded: true,
                    };

                    var tempList = orgDisplay.getSubOrgDropDownList(row, showList);
                    item.subOrgs = tempList;

                    list.push(item);

                });

                return list;
            },

            otherShow: function (idcol, namecol) {
                var showList = angular.copy(orgDisplay.orgList);
                var otherList = orgDisplay.getMap(showList, idcol, namecol);

                var list = [];
                otherList.forEach(function (other) {

                    var item = other;

                    item.dimensionId = idcol;

                    item.subOrgs = _.filter(showList, function (t) {

                        return t[idcol] === other.id;
                    });

                    list.push(item);
                });


                return list;
            },
            getMap: function (data, idCol, nameCol) {
                if (data && data.length > 0) {
                    var idList = _.uniq(_.pluck(data, idCol));
                    var list = [];

                    idList.forEach(function (row) {
                        if (row) {
                            var findOne = _.find(data, function (o) {
                                return o[idCol] === row;
                            });

                            if (findOne && findOne[nameCol]) {
                                list.push({
                                    id: row,
                                    name: findOne[nameCol],
                                    selected: true,
                                });
                            }
                        }
                    });

                    return list;
                } else {
                    return [];
                }
            },

            showBusy: function () {
                $('#busy-indicator-container').show();
            },

            hideBusy: function () {
                $('#busy-indicator-container').hide();
            }

        };

        $scope.setTreeChecked = function (dataList) {
            if (dataList && dataList.length > 0 && _.keys(vatSessionService.queryDto.checkedOrgs).length > 0) {
                dataList.forEach(function (v) {
                    if (vatSessionService.queryDto.checkedOrgs[v.id]) {
                        v.isChecked = true;
                    }
                    if (v.subOrgs && v.subOrgs.length > 0) {
                        $scope.setTreeChecked(v.subOrgs);
                    }
                });
            }
        }

        var goQueryState = function () {
            $scope.searchKeyword = vatSessionService.queryDto.searchKeyword;
            $scope.checkedOrgs = vatSessionService.queryDto.checkedOrgs;
            if ($scope.serviceTypeId !== enums.serviceType.AssetsManage) {
                $scope.query();
            }
        };

        //function to get random number upto m
        function randomXToY(minVal, maxVal, floatVal) {
            var randVal = minVal + (Math.random() * (maxVal - minVal));
            return typeof floatVal == 'undefined' ? Math.round(randVal) : randVal.toFixed(floatVal);
        }

        /**********************************资产配置*************************************/
        //初始化产品列表
        function initProductListGrid() {
            var listColumns = [
                    { caption: '年份', dataField: 'fYear' },
                    { caption: '产品标识', dataField: "fSetID" },
                    { caption: '产品编号', dataField: "fSetCode" },
                    { caption: '产品描述（名称）', dataField: "fSetName" },
                    { caption: '财务主管', dataField: "fManager" },
                    { caption: '启用年份', dataField: "fStartYear" },
                    { caption: '启用月份', dataField: "fStartMonth" },
                    { caption: '所属机构', dataField: "accountDepartment" }
            ];
            $scope.gridListOptions = {
                showBorders: true,
                columns: listColumns,
                bindingOptions: {
                    "dataSource": "productListQueryResult"
                },
                loadPanel: {
                    enabled: true
                },
                hoverStateEnabled: true,
                paging: { pageSize: 20 },
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                selection: { mode: "single" },
                onRowClick: function (e) {
                    $scope.goToService(e.data);
                },
                onContentReady: function (e) {
                    $scope.productListGridInstance = e.component;
                }
            }
        };

        $scope.initProductList = function () {
            productService.getProductList().success(function (data) {
                $scope.productListQueryResult = data;
                $scope.totolCount = data.length;
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                    v.serviceTypeID = enums.serviceType.AssetsManage;
                });

            });
        };

        //重新设置产品列表grid
        $scope.updateProductList = function () {
            $scope.updateStatus = true;
        };

        $scope.addNewProduct = function () {
            $scope.modalService.newProductModal.open();
        };

        $scope.product = {
            fYear: "",
            fSetId: "",
            fSetName: "",
            fManager: ""
        };

        $scope.modalService = {
            newProductModal: {
                open: function () {
                    $scope.product = {
                        fYear: "",
                        fSetId: "",
                        fSetName: "",
                        fManager: ""
                    };

                    var treeView;
                    var syncTreeViewSelection = function (treeView) {
                        if (!treeView) return;

                        if (!$scope.treeBoxValue) {
                            treeView.unselectAll();
                            return;
                        }

                        $scope.treeBoxValue.forEach(function (key) {
                            treeView.selectItem(key);
                        });
                    };

                    $scope.treeBoxValue = [""];
                    $scope.treeDataSource = [];
                    $scope.treeBoxNameValue = [""];
                    productService.getProductList().success(function (data) {
                        data.forEach(function (v) {
                            if (!v.productIDs) {
                                var item = new Object;
                                item.name = v.fSetName;
                                item.content = { id: v.fSetCode, guid: v.id};
                                $scope.treeDataSource.push(item);
                            }
                        });
                    });

                    $scope.treeBoxOptions = {
                        bindingOptions: {
                            value: 'treeBoxNameValue'
                        },
                        valueExpr: "ID",
                        displayExpr: "name",
                        placeholder: "选择...",
                        showClearButton: false,
                        dataSource: $scope.treeDataSource,
                        onValueChanged: function () {
                            syncTreeViewSelection(treeView);
                        },
                        treeView: {
                            dataSource: $scope.treeDataSource,
                            dataStructure: "plain",
                            keyExpr: "ID",
                            parentIdExpr: "categoryId",
                            displayExpr: "name",
                            selectByClick: true,
                            selectNodesRecursive: false,
                            showCheckBoxesMode: "normal",
                            bindingOptions: {
                                selectionMode: "selectionMode"
                            },
                            onContentReady: function (e) {
                                treeView = e.component;
                                syncTreeViewSelection(treeView);
                            },
                            onItemSelectionChanged: function (args) {
                                var keyValue = args.component.getSelectedNodesKeys();
                                if (keyValue.length===0) {
                                    keyValue = [""];
                                }
                                var value = [""];
                                var nodes = args.component.getNodes();
                                var newValue = [""];
                                var nameValue = [""];
                                keyValue.forEach(function (v) {
                                    var findResult = _.find(nodes, function (node) {
                                        return node.key === v;
                                    });
                                    if (findResult) {
                                        newValue.push(findResult.itemData.content.guid);
                                        value.push(findResult.itemData.content.id);
                                        nameValue.push(findResult.itemData.name);
                                    }
                                });
                                $scope.treeBoxValue = keyValue;
                                $scope.newNewtreeBoxValue = value;
                                $scope.newTreeBoxValue = newValue;
                                var tempArray = nameValue.length===1?nameValue:nameValue.shift();
                                $scope.treeBoxNameValue = nameValue;
                            }
                        }
                    };

                    $timeout(function () {
                        var ele2 = $("#productStartDate");
                        ele2.datepicker({
                            startDate: $scope.startDate,
                            endDate: $scope.endDate,
                            language: region,
                            viewMode: $scope.viewMode,
                            minViewMode: $scope.viewMode,
                            autoclose: true, //选中之后自动隐藏日期选择框
                            clearBtn: true, //清除按钮
                            todayBtn: false, //今日按钮
                            format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
                        }).on('changeDate', function (e) {
                            $scope.changeStartDate(e);
                        });
                        ele2.datepicker("setDate", $scope.selectedStartDate);
                    }, 100);

                    $scope.newProductModalInstance = ackUibModal($scope, 'addNewProduct.html', 'addNewProduct', '.app-overview ', 'static')
                    $scope.newProductModalInstance.open();
                },
                save: function (result) {
                    $scope.saveProduct();
                    $scope.newProductModalInstance.close();
                },
                cancel: function () {
                    $scope.newProductModalInstance.cancel();
                }
            }
        };

        $scope.changeWithZeroNumber = function (sourceNumber) {
            if (sourceNumber.length > 1) {
                if (sourceNumber < 10) {
                    return sourceNumber.replace(/0/g, '');
                }
                else {
                    return sourceNumber;
                }
            }
            else {
                return sourceNumber;
            }
        };

        $scope.saveProduct = function () {
            //$scope.product.fSetCode = $scope.treeBoxValue.toString();
            $scope.product.fStartYear = $scope.currentSelectedStartYear;
            $scope.product.fStartMonth = $scope.changeWithZeroNumber($scope.currentSelectedStartMonth);
            $scope.product.productIDs = $scope.newTreeBoxValue.toString();

            //调用service插入数据库
            productService.addNewProduct($scope.product).success(function () {
                $scope.initProductList();
            })
        };
        var successCount = 0;
        var doUploadProductFileName = function (file) {
            if (file) {
                var arr = file.name.split('.');
                if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                    SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                    return;
                }
                //$scope.initJournalEntryList = [];
                //$scope.gridOptionsJournalEntry.data = [];
                successCount = 0;
                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file
                        },
                        resumeChunkSize: resumable ? $scope.chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadJournalEntrySuccess);
                }
            }
        };

        //上传成功后执行函数
        var uploadJournalEntrySuccess = function (resp) {
            console.log(resp);
            successCount++;
            if (successCount === 1) {
                $scope.tempFileName = resp.data;
                //初始化到excel文件的第一个sheet
                getUploadFileContent(0);
            }
        };

        var getUploadFileContent = function () {
            if (_.isString($scope.tempFileName)) {
                productService.getFileContent($scope.tempFileName, 0, 0).success(function (data) {

                    //将导入文件的sheet赋值到数组
                    $scope.sheetData = data;
                    //加入index序号
                    var index = 1;
                    data.dataList.forEach(function (v) {
                        v.index = index++;
                    });

                    //先将完整数据深拷贝存放到变量中
                    $scope.sheetData.excelSheetAllData = angular.copy(data.dataList);
                    var number = 1;
                    $scope.sheetData.excelSheetAllData.forEach(function (v) {
                        v.index = number++;
                    });
                    //将导入文件的sheet赋值到数组
                    //只赋值data的前500条到sheetData的dataList中，防止数据量太大渲染的时候卡死浏览器
                    $scope.sheetData.dataList = data.dataList.slice(0, 500);

                    if (data & data.result === false) {
                        SweetAlert.warning(data.resultMsg);
                        return;
                    }

                    //upload data to DB
                    saveProductDataToDatabase();
                });
            }
        };

        var saveProductDataToDatabase = function () {
            //将需要导入的数据组装到list中
            var importProductList = [];
            var startRowNum = 3;
            for (var i = startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
                var productInfo = {
                    'Index': $scope.sheetData.dataList[i].index,
                    'FYear': $scope.sheetData.dataList[i][0],
                    'FSETID': $scope.sheetData.dataList[i][1],
                    'FSETCODE': $scope.sheetData.dataList[i][2],
                    'FSETNAME': $scope.sheetData.dataList[i][3],
                    'FMANAGER': $scope.sheetData.dataList[i][4],
                    'FSTARTYEAR': $scope.sheetData.dataList[i][5],
                    'FSTARTMONTH': $scope.changeWithZeroNumber($scope.sheetData.dataList[i][6]),
                    'FMONTH': $scope.changeWithZeroNumber($scope.sheetData.dataList[i][7]),
                    'ACCOUNTDEPARTMENT': $scope.sheetData.dataList[i][8]
                };
                importProductList.push(productInfo);
            }

            productService.importProductData(importProductList).success(function () {
                //logDto.UpdateState = $translate.instant('ImportSuccess');
                //vatOperationLogService.addOperationLog(logDto);
                //vatCommonService.importSetProjectStatus(projectDbName, curPeriod
                //                                       , constant.DictionaryDictKey.WFImportJournalEntry
                //                                       , enums.FinishStatusEnum.Finished);
                //vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                //$log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                SweetAlert.success($translate.instant('ImportSuccess'));
                $scope.initProductList();
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                //logDto.UpdateState = $translate.instant('ImportFail');
                //vatOperationLogService.addOperationLog(logDto);
            });
        };

        /**********************************资产配置*************************************/
        (function initialize() {
            if ($scope.serviceTypeId !== enums.serviceType.AssetsManage) {
                initListGrid();
            }
            initDatePickers();
            $scope.updateStatus = false;

            userService.getUserPermission(loginContext.userName).success(function (userPermission) {
                thisData.userPermission = userPermission;
                userPermission.permissionList.forEach(function (p) {
                    if (p.code.startWith('02')) {
                        $scope.haveVatPermission = true;
                        return;
                    }
                });
                vatSessionService.userPermission = userPermission;
                orgDisplay.main();
                if ($scope.serviceTypeId === enums.serviceType.AssetsManage) {
                    $scope.projectMsg = $translate.instant('ProjectResultMsg').formatObj({ "ProjectNum": 66 });
                    initProductListGrid();
                    $scope.initProductList();
                    $scope.toggleView('listView');
                }
                else {
                    $scope.initProjectList();
                }
            });

            $scope.$watch('productFileName', function (newValue, oldValue) {
                if (newValue && newValue !== oldValue) {
                    doUploadProductFileName(newValue);
                }
            });
        })();
    }
]);

frameworkModule.factory('assetsManageSessionService', ['$log', function ($log) {
    'use strict';
    $log.debug('assetsManageSessionService.ctor()...');

    var date = new Date();
    var month = date.getMonth();
    var projectyear = 2017;
    if (month <= 0) {
        month = 1;
    }
    var logUser = {
        ID: "66933E7B-DA75-4B2E-B7D6-AB65DCA20D50",
        UserName: "Admin",
    };

    var reset = function () {
        var date = new Date();
        var m = date.getMonth();
        if (m <= 0) {
            m = 1;
        }
        this.month = m;
    };

    return {
        month: 6,
        year: projectyear,
        project: {
            year: projectyear,
            projectStatusList: [30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30],
            importSubStatus: 1,
            dbName: 'AssetsManage',
            id: '99999',
            name: '阳光证券有限公司增值税申报项目',
            organizationName: '阳光证券有限公司增值税申报项目'
        },
        projects: [],
        dataChanged: false,
        logUser: logUser,
        reset: reset,
        product: {
            fSetCode: '11111111111111111111',
            productIDs:'xxxxxxxxxxxxxxxxxxxx'
        }
    }


}]);


frameworkModule.factory("demoDataService", function ($window, $rootScope) {
    'use strict';
    return {
        setData: function (val) {
            $window.localStorage && $window.localStorage.setItem('overview-demo-data', val);
            return this;
        },
        getData: function () {
            return $window.localStorage && $window.localStorage.getItem('overview-demo-data');
        }
    };
});

frameworkModule.directive('appOverview', ['$log', 'region', 'enums',
    function ($log, region, enums) {
        'use strict';

        $log.debug('appOverview.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-overview/app-overview.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                servicetypeid : '='
            },
            controller: 'appOverviewController',
            link: function ($scope, $element, $attr) {
                var ele = $(".datepicker");
                ele.datepicker({
                    startDate: $scope.startDate,
                    endDate: $scope.endDate,
                    language: region,
                    viewMode: 1,
                    minViewMode: 1,
                    autoclose: true,//选中之后自动隐藏日期选择框
                    clearBtn: false,//清除按钮
                    todayBtn: false,//今日按钮
                    format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
                }).on('changeDate', function (e) {
                    $scope.changeDate(e);
                });
                ele.datepicker("setDate", $scope.selectedDate);
                $scope.elePicker = ele;


            
            }
        };
    }
]);
/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('appSideBarController', ['$scope', '$log', 'menuService', '$window', 'loginContext', 'userService', '$timeout',
    function ($scope, $log, menuService, $window, loginContext, userService, $timeout) {
        'use strict';
        $log.debug('appSideBarController.ctor()...');

        userService.getUserPermission(loginContext.userName).success(function (data) {

            $timeout(function () {
                menuService.getMenusForDisplay(1).success(function (menuData) {

                    $scope.menuData = menuData;
                    if ($scope.specialUser === 'simon') {
                        $scope.menuData[2].subMenus[0].isVisible = false;
                        $scope.menuData[2].subMenus[1].isVisible = false;
                        $scope.menuData[2].subMenus[3].isVisible = false;
                        $scope.menuData[2].subMenus[4].isVisible = false;
                        $scope.menuData[2].subMenus[5].isVisible = false;
                    }
                    $window.location.href = '#/adminHomePage';
                });
            }, 500);
            
        });


        var getMenuItem = function (row, isAdmin, navigationUrlList) {
            if (!row.isVisible) {
                return null;
            }
            if (row.subMenus && row.subMenus.length > 0) {

                // 基础数据维护菜单特殊处理
                if (row.id === constant.BasicDataManageMenuID) {

                    if (!isAdmin) {
                        var subMenus = _.find(row.subMenus, function (num) {
                            return navigationUrlList.indexOf(num.navigationUrl) > -1;
                        });

                        if (subMenus && navigationUrlList.indexOf(row.navigationUrl) === -1) {

                            // 设置基础数据菜单 默认url地址

                            if (navigationUrlList.indexOf(constant.basicDataUrl.businessUnit) > -1) {
                                row.navigationUrl = constant.basicDataUrl.businessUnit;
                            } else if (navigationUrlList.indexOf(constant.basicDataUrl.regionManage) > -1) {
                                row.navigationUrl = constant.basicDataUrl.regionManage;
                            } else if (navigationUrlList.indexOf(constant.basicDataUrl.enterpriseAccountManage) > -1) {
                                row.navigationUrl = constant.basicDataUrl.enterpriseAccountManage;
                            } else if (navigationUrlList.indexOf(constant.basicDataUrl.customerListManage) > -1) {
                                row.navigationUrl = constant.basicDataUrl.customerListManage;
                            }
                        }

                    }

                    row.subMenus = [];

                } else {
                    var menuList = [];
                    row.subMenus.forEach(function (menu) {
                        var temp = getMenuItem(menu, isAdmin, navigationUrlList);
                        if (temp) {
                            menuList.push(temp);
                        }
                    });

                    row.subMenus = menuList;

                }
            }

            // 系统管理就没有地址
            if (!row.navigationUrl && row.subMenus && row.subMenus.length > 0) {
                return row;
            }

            if (isAdmin || (navigationUrlList && navigationUrlList.indexOf(row.navigationUrl) > -1)) {
                return row;
            }
            return null;
        };

        //var apiToken = $cookieStore.get("AtmsApiToken");
        //$scope.loginUser = apiToken.user_name;

        $scope.loginUser = loginContext.userName;
        $scope.specialUser = $scope.loginUser.toLowerCase();

        $scope.logout = function () {
            $window.location.href = '/Account/Logout';
        };

        $scope.convertTo2BitNumber = function (number) {
            var str = "" + number;
            var pad = "00";
            return pad.substring(0, pad.length - str.length) + str;
        };

        (function initialize() {
            $log.debug('appSideBarController.initialize()...');

        })();
    }
]);

// appNavBar
// navigation bar for application
frameworkModule.directive('appSideBar', ['$log',
    function ($log) {
        'use strict';

        $log.debug('sidebar.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-side-bar/app-side-bar.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'appSideBarController',
            link: function (scope, element, attr) {

                scope.isMenuClosed = false;
                var superiorMenuActiveClass = 'superior-menu-active';
                //Top Toggler
                var handleSidebarToggler = function () {
                    var body = $('body');

                    // handle sidebar show/hide
                    body.on('click', '.sidebar-toggler', function () {

                        var sidebarMenuSubs = $('#sidebar .nav-second-level, #sidebar .nav-third-level');
                        var sidebarPageClass = 'page-sidebar-minified';
                        //collapse("toggle")
                        $("#sidebar-area .dropdown-collapse").parent("li").children("ul").css('height', '');

                        $(".sidebar-search", $('.page-sidebar')).removeClass("open");
                        if (body.hasClass("sidebar-closed")) {
                            body.removeClass("sidebar-closed");
                            scope.isMenuClosed = false;

                            //代码意图:控制右侧 page-wrapper 宽度以适应菜单栏的变化
                            $("div.admin-wrapper > div.page-wrapper").removeClass(sidebarPageClass);

                            sidebarMenuSubs.addClass('collapse');

                            if ($.cookie) {
                                $.cookie('sidebar-closed', '0');
                            }

                        } else {
                            body.addClass("sidebar-closed");
                            scope.isMenuClosed = true;
                            $("div.admin-wrapper > div.page-wrapper").addClass(sidebarPageClass);

                            if ($.cookie) {
                                $.cookie('sidebar-closed', '1');
                            }
                        }
                        $(window).trigger('resize');
                    });
                };

                //IE Checker
                var isIE = function () {
                    var undef,
                        v = 3,
                        div = document.createElement("div"),
                        all = div.getElementsByTagName("i");
                    while (
                        div.innerHTML = "<!--[if gt IE " + (++v) + "]><i></i><![endif]-->",
                        all[0]
                    ) {
                        return v > 4 ? v : undef;
                    }
                };

                //side menu toggle (init)
                if (isIE() <= 9) {
                    $('#sidebar').find("li.active").has("ul").children("ul").collapse("show");
                    $('#sidebar').find("li").not(".active").has("ul").children("ul").collapse("hide");
                } else {
                    $('#sidebar').find("li.active").has("ul").children("ul").addClass("collapse in");
                    $('#sidebar').find("li").not(".active").has("ul").children("ul").addClass("collapse");
                }

                //side menu toggle (setting)
                $("body").on("click", "#sidebar-area .dropdown-collapse,#sidebar-area a", function () {
                    var currentClass = $(this).attr('class');
                    var len = $(this).siblings('ul').children('li').length;
                    $("#sidebar-area a").removeClass("active");

                    if (currentClass.indexOf('active') >= 0) {
                        $(this).removeClass('active');
                    } else {
                        $(this).addClass('active');
                    }
                    if (len > 0) {
                        $(this).removeClass('active');
                    }

                    $(this).parent("li").children("ul").collapse("toggle");
                    $(this).children(".fa.arrow").toggleClass('active-arrow');
                });

                $("body").on({
                    click: function () {
                        $(this).children(".logout").children("div").toggle();
                    }
                }, ".profile-name");

                handleSidebarToggler();

                var width = (window.innerWidth > 0) ? window.innerWidth : screen.width;

                if ($.cookie && $.cookie('sidebar-closed') === '1' && !$('body').hasClass("sidebar-closed") && width >= 768) {
                    $('body').addClass("sidebar-closed");
                }

                var url = window.location;
                var element = $('ul.nav a').filter(function () {
                    return this.href === url;
                }).addClass('active').parent().parent().addClass('in').parent();
                if (element.is('li')) {
                    element.addClass('active');
                }

                scope.showChangePassword = function () {
                    $("#changePasswordModal").modal('show');
                }
            }
        };
    }
]);
frameworkModule.controller('appSummaryController', ['$scope', '$log', '$state', '$translate', 'region', 'projectService', 'vatSessionService',
    'enums', 'citSessionService', 'vatReportService', 'tempStorageService', 'SweetAlert',
function ($scope, $log, $state, $translate, region, projectService, vatSessionService, enums, citSessionService, vatReportService, tempStorageService,
    SweetAlert) {

        // For Edmond: Dashboard Demo
        vatSessionService.querySummayDashboardModel = {
            year: 2017,
            period: 1
        };

        $scope.goToRiskPanel = function () {
            window.location = '/#/RiskPanel';
        }

        $scope.initCitDataProcessMockData = function () {
            var task = function (id, status, name, tasklevel, parentId, hasButton, seqNo) {
                this.id = id;
                this.name = _.isEmpty(name) ? $translate.instant(id) : name;
                this.status = status;
                this.text = $translate.instant(status);
                this.tasklevel = tasklevel;
                this.parentId = parentId;
                this.hasButton = hasButton;
                this.ngClassCol = '';
                this.seqNo = seqNo;
            };

            var result = [];
            result.push(new task(1, constant.DataProccessStatus.ToUpdate, $translate.instant('DataProcessDataName_UpdateTB'), 1, 0, true, 1));
            result.push(new task(2, constant.DataProccessStatus.Unstarted, $translate.instant('DataProcessDataName_GenerateReport'), 1, 0, false, 2));
            result.push(new task(3, constant.DataProccessStatus.ToUpdate, $translate.instant('DataProcessDataName_FinanceReport'), 2, 2, true, 3));
            result.push(new task(4, constant.DataProccessStatus.Unstarted, $translate.instant('DataProcessDataName_CITQuarterly'), 2, 2, false, 4));
            result.push(new task(5, constant.DataProccessStatus.Completed, $translate.instant('DataProcessDataName_CITFirstQuarterly'), 3, 4, true, 5));
            result.push(new task(6, constant.DataProccessStatus.Unstarted, $translate.instant('DataProcessDataName_CITSecondQuarterly'), 3, 4, true, 5));
            result.push(new task(7, constant.DataProccessStatus.NoData, $translate.instant('DataProcessDataName_CITThirdQuarterly'), 3, 4, true, 5));
            result.push(new task(8, constant.DataProccessStatus.NoData, $translate.instant('DataProcessDataName_CITForthQuarterly'), 3, 4, true, 5));
            result.push(new task(9, constant.DataProccessStatus.Unstarted, $translate.instant('DataProcessDataName_YearWorkPaper'), 2, 2, true, 6));
            result.push(new task(10, constant.DataProccessStatus.Unstarted, $translate.instant('DataProcessDataName_AnnualSettlement'), 2, 2, true, 7));
            result.push(new task(11, constant.DataProccessStatus.Completed, $translate.instant('DataProcessDataName_ModelAnalysis'), 1, 0, true, 8));
            return result;
        };

        $scope.dashboardOptions = {
            widgetButtons: false,
            widgetDefinitions: [
                {
                    name: 'ToDoList',
                    title: 'ToDoList',
                    directive: 'app-todo-list',
                    dataAttrName: 'items',
                    dataModelType: 'TodoListDataModel',
                    dataModelOptions: {
                    },
                    settingsModalOptions: {
                        templateUrl: "/app/dashboard/app-todo-list/config/config.html",
                        controller: "appTodoListConfigController",
                        backdrop: false
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("Todo list config resolved!");
                        $.extend(true, widget, result);
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("Todo list config have been dismissed: ", reason);
                    },
                    enableVerticalResize: false,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-4 col-lg-4',
                        height: '210px'
                    }
                },
                {
                    name: 'IndexAnalysis',
                    title: 'IndexAnalysis',
                    directive: 'app-index-analysis',
                    dataAttrName: 'chartConfig',
                    dataModelType: 'ChartConfigDataModel',
                    dataModelOptions: {
                        chartConfig: {}
                    },
                    settingsModalOptions: {
                        templateUrl: "app/dashboard/app-index-analysis/app-index-analysis-config.html",
                        controller: "appIndexAnalysisConfigController",
                        backdrop: false,
                        windowClass: 'index-analysis-config-modal'
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("Index analysis chart config resolved!");
                        $.extend(true, widget, result);
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("Index analysis chart config have been dismissed: ", reason);
                    },
                    titleAttr: 'chartConfig.name',
                    enableVerticalResize: false,
                    openConfigWhenAdding: true,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-12 col-lg-12',
                    }
                },
                {
                    name: 'TaxSummaryDashboard',
                    title: 'DashboardOTSubtotal',
                    directive: 'tax-summary-dashboard',
                    dataAttrName: 'tax-summary-dashboard',
                    dataModelOptions: {
                        name: "tax-summary-dashboard option data"
                    },
                    settingsModalOptions: {
                        templateUrl: "app/common/controls/tax-summary-dashboard/config/config.html",
                        controller: "taxSummaryDashboardConfigController",
                        backdrop: false
                    },
                    enableVerticalResize: false,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-12 col-lg-12',
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("TaxSummaryDashboard config resolved!");
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("TaxSummaryDashboard config have been dismissed: ", reason);
                    }
                },
                {
                    name: 'TaxAmountDashboard',
                    title: 'TaxAmountDashboard',
                    directive: 'tax-amount-dashboard',
                    dataAttrName: 'tax-amount-dashboard',
                    dataModelOptions: {
                        name: "taxAmountDashboard"
                    },
                    settingsModalOptions: {
                        templateUrl: "app/common/controls/tax-amount-dashboard/config/config.html",
                        controller: "taxAmountDashboardConfigController",
                        backdrop: false
                    },
                    enableVerticalResize: false,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-4 col-lg-4',
                        height: '210px'
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("TaxAmountDashboard config resolved!");
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("TaxAmountDashboard config have been dismissed: ", reason);
                    }
                },
                {
                    name: 'TaxAnnualAmountDashboard',
                    title: 'TaxAnnualAmountDashboard',
                    directive: 'tax-annual-amount-dashboard',
                    dataAttrName: 'tax-annual-amount-dashboard',
                    dataModelOptions: {
                        name: "taxAnnualAmountDashboard"
                    },
                    enableVerticalResize: false,
                    hideWidgetSettings: true,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-4 col-lg-4',
                        height: '210px'
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("TaxAnnualAmountDashboard config resolved!");
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("TaxAnnualAmountDashboard config have been dismissed: ", reason);
                    }
                },
                {
                    name: 'DashboardTaxRiskAlert',
                    title: 'MenuRiskAlert',
                    directive: 'dashboard-tax-risk-alert',
                    dataAttrName: 'dashboard-tax-risk-alert',
                    dataModelOptions: {
                        name: "dashboardTaxRiskAlert option data"
                    },
                    enableVerticalResize: false,
                    hideWidgetSettings: true,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-12 col-lg-12',
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("DashboardTaxRiskAlert config resolved!");
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("DashboardTaxRiskAlert config have been dismissed: ", reason);
                    }
                },
                {
                    name: 'DashboardTaxCashFlowAnalysis',
                    title: 'TaxCashFlowAnalysis',
                    directive: 'dashboard-tax-cash-flow-analysis',
                    dataAttrName: 'dashboard-tax-cash-flow-analysis',
                    dataModelOptions: {
                        name: "dashboardTaxCashFlowAnalysis option data"
                    },
                    settingsModalOptions: {
                        templateUrl: "/app/dashboard/tax-cash-flow-analysis/config/config.html",
                        controller: "dashboardTaxCashFlowAnalysisConfigController",
                        backdrop: false,
                        size: "dashboard-tax-cash-flow-analysis-config"
                    },
                    enableVerticalResize: false,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-12 col-lg-12',
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("DashboardTaxCashFlowAnalysis config resolved!");
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("DashboardTaxCashFlowAnalysis config have been dismissed: ", reason);
                    }
                },
                {
                    name: 'DashboardDeferredTaxAnalysis',
                    title: 'DeferredTaxAnalysis',
                    directive: 'dashboard-deferred-tax-analysis',
                    dataAttrName: 'chartConfig',
                    dataModelType: 'ChartConfigDataModel',
                    dataModelOptions: {
                        chartConfig: {}
                    },
                    settingsModalOptions: {
                        templateUrl: "/app/dashboard/deferred-tax-analysis/config/config.html",
                        controller: "dashboardDeferredTaxAnalysisConfigController",
                        backdrop: false,
                        size: "dashboard-deferred-tax-analysis-config"
                    },
                    enableVerticalResize: false,
                    openConfigWhenAdding: true,
                    size: {
                        widthClass: 'col-xs-12 col-sm-12 col-md-12 col-lg-12',
                    },
                    onSettingsClose: function (result, widget) {
                        $log.debug("DashboardDeferredTaxAnalysis config resolved!");
                        $.extend(true, widget, result);
                    },
                    onSettingsDismiss: function (reason, scope) {
                        $log.debug("DashboardDeferredTaxAnalysis config have been dismissed: ", reason);
                    }
                }
            ],
            defaultWidgets: [
                {
                    name: 'TaxAnnualAmountDashboard'
                },
                {
                    name: 'TaxAmountDashboard'
                },
                {
                    name: 'ToDoList'
                },
                {
                    name: 'TaxSummaryDashboard'
                }
            ],
            storage: {
                getItem: function (key) {
                    return tempStorageService.getTempStorage('admin', 'dashboard,' + key).then(function (rslt) {
                        return rslt && rslt.data;
                    });
                },
                setItem: function (key, value) {
                    return tempStorageService.setTempStorage('admin', 'dashboard,' + key, value);
                },
                removeItem: function (key) {
                    return tempStorageService.removeTempStorage('admin', 'dashboard,' + key);
                }
            },
            storageId: 'atmsDashboard',
            explicitSave: true
        };

        var projects = [];
        //点击区域的箭头图标，进入 YP_Demo机构 CIT项目的数据分析界面
        //http://cnshaappuwv023:30000/#/cit/analyzeReport/citModelAnalysis
        $scope.goCITAnalysis = function () {
            var project = _.findWhere(projects, {
                serviceTypeID: enums.serviceType.CIT,
                id: "8d8b13e7-07e1-4d84-8984-7b86e8ec6137"
            });
            if (project) {
                if (project.haveCreateProject) {
                    vatSessionService.project = project;
                    //写死1月份
                    vatSessionService.month = 1;
                    if (_.isUndefined(project.projectStatusList[vatSessionService.month])) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                        projectService.setProjectStatus(project.dbName, vatSessionService.month, constant.ProjectStatusEnum.UnStarted)
                                .success(function (or) {
                                    if (or.result) {
                                        //添加完成后，在vatSessionService.project中添加新加入的数据
                                        project.projectStatusList[vatSessionService.month] = constant.ProjectStatusEnum.UnStarted;
                                        vatSessionService.project = project;
                                        if (project.serviceTypeID === enums.serviceType.CIT) {
                                            citSessionService.project = project;
                                            $state.go('cit.analyzeReport.citModelAnalysis');
                                        }
                                        else {
                                            //！！请把goRightPath()放在最内层的callback中，否则会在当前service没有执行完毕前就跳转到vat-layout.ctrl.js,
                                            //从而造成一些bug
                                            //  goRightPath();
                                        }
                                    }
                                });
                    }
                    else {
                       
                        if (project.serviceTypeID === enums.serviceType.CIT) {
                            citSessionService.project = project;
                            $state.go('cit.analyzeReport.citModelAnalysis');
                        }
                        else {
                            // goRightPath();
                        }
                    }
                }
            }

        };
        $scope.getYPDemoProjects = function () {
            //YP_Demo机构(2017) project 
            var index = 0;
            projectService.getProjectByID("8d8b13e7-07e1-4d84-8984-7b86e8ec6137").success(function (ps) {
                if (ps && ps.length > 0) {
                    ps.forEach(function (p) {
                        projects.push({
                            index: index++,
                            id: p.id,
                            name: p.name,
                            year: p.year,
                            code: p.code,
                            clientCode: p.clientCode,
                            isActive: p.isActive,
                            createTime: p.createTime,
                            updateTime: p.updateTime,
                            regionID: p.regionID,
                            industryID: p.industryID,
                            ruleType: p.ruleType,
                            organizationID: p.organizationID,
                            dbName: p.dbName,
                            serviceTypeID: p.serviceTypeID,
                            region: p.region,

                            haveCreateProject: p.haveCreateProject,
                            //yearDisplay: $scope.getYearDisplay(p),
                            // projectStatusDisplay: $scope.translateProjectStatus(p.haveCreateProject),
                            //serviceIcon: $scope.getServiceIcon(p.serviceTypeID),
                            //color: $scope.getColor(p.serviceTypeID),
                            organizationName: p.organizationName,
                            serviceTypeName: p.serviceTypeID === enums.serviceType.VAT ? "增值税" : "企业所得税",
                            industryName: p.industryName,
                            enterpriseAccountSetID: p.enterpriseAccountSetID,
                            templateGroupID: p.templateGroupID,
                            startPeriod: p.startPeriod,
                            endPeriod: p.endPeriod,
                            projectStatusList: p.projectStatusList, //Dictionary<int,int>类型，存放当前项目每个期间的状态的。第一个int:期间，第二个int:状态
                            importSubStatus: null, //当前项目，当前期间的子状态（是否导入Tb，序时账等等）     
                            workflow: null, //当前项目workflow数据
                            regionName: p.regionName,
                            //finalStatus: setLayoutStatusTitle(null), //(p.projectStatusList !== null && p.projectStatusList[1] !== undefined) ? setLayoutStatusTitle(p.projectStatusList[1]) : $scope.translateProjectStatus(p.haveCreateProject)
                            taxAmount: 0,
                            prepadidTaxAmount: 0,
                            taxRate: 0,
                            periodDate: (p.serviceTypeID === enums.serviceType.VAT) ? ($scope.currentSelectedYear + "." + $scope.currentSelectedMonth) : ($scope.currentSelectedYear + ""),
                            modelAbnormal: false,
                            riskWarning: false,
                            reportAbnormal: false,
                            citDataProcessMockData: $scope.initCitDataProcessMockData()
                        });
                    });
                }
            }).error(function () {
                SweetAlert.error('', $translate.instant("CommonFail"));
            });
        };
       // 点击机构的， 报表感叹号， 进入 YP_Demo机构 VAT项目的1月的纳税申报表附表一界面
        // http://cnshaappuwv023:30000/#/vat/generateReport/reportView?
        //id=0f221d2e-3a85-4d99-9bfa-8480fb97473b
        //&templateid=305158ab-4d07-4e10-bd14-560b3e30a53d
        //&name=%E6%9C%AC%E6%9C%9F%E9%94%80%E5%94%AE%E6%83%85%E5%86%B5%E6%98%8E%E7%BB%86(%E9%99%84%E8%A1%A8%E4%B8%80)
        //&templatecode=VAT001
        $scope.goVATSpecialReport = function () {
            var project = _.findWhere(projects, {
                serviceTypeID: enums.serviceType.VAT,
                id: "8d8b13e7-07e1-4d84-8984-7b86e8ec6137"
            });
            if (project) {
                if (project.haveCreateProject) {
                    //写死1月份
                    vatSessionService.month = 1;
                    vatSessionService.project = project;
                    //获取最新Vat001的report
                    vatReportService.getTemplate(project.id, vatSessionService.month).success(function (response) {
                        //  console.log(response);
                        if(response.result){
                            var reportData = _.findWhere(response.data, { templateCode: "VAT001"});
                            var param = {
                                id: reportData.id,
                                templateid: reportData.templateID,
                                name: reportData.templateName,
                                templatecode: reportData.templateCode
                            };
                            if (_.isUndefined(project.projectStatusList[vatSessionService.month])) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                                projectService.setProjectStatus(project.dbName, vatSessionService.month, constant.ProjectStatusEnum.UnStarted)
                                        .success(function (or) {
                                            if (or.result) {
                                                //添加完成后，在vatSessionService.project中添加新加入的数据
                                                project.projectStatusList[vatSessionService.month] = constant.ProjectStatusEnum.UnStarted;
                                                vatSessionService.project = project;
                                                $state.go('vat.generateReport.reportView',param);
                                            }
                                        });
                            }
                            else {
                                vatSessionService.project = project;
                                //$state.go('vat.generateReport.reportView', param);
                                $state.go('vat.generateReport.reportView',
                                    {
                                        id: reportData.id,
                                        templateid: reportData.templateID,
                                        name: reportData.templateName,
                                        templatecode: reportData.templateCode
                                    });
                            }
                        }
                        else {
                            SweetAlert.error('', $translate.instant("CommonFail"));
                        }
                      
                    }).error(function () {
                        SweetAlert.error('', $translate.instant("CommonFail"));
                    });
                   
                }
            }
        };
    }
]);
frameworkModule.directive('appSummary', ['$log', '$state', 'region', 'enums',
    function ($log, $state, region, enums) {
        'use strict';

        $log.debug('appOverview.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/framework/app-summary/app-summary.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'appSummaryController',
            link: function ($scope, $element, $attr) {
                //$axure.utils.getTransparentGifPath = function () { return '~/resources/transparent.gif'; };
                //$axure.utils.getOtherPath = function () { return '~/resources/Other.html'; };
                //$axure.utils.getReloadPath = function () { return '~/resources/reload.html'; };
                //unbind event before bind event
                //$('#u326,#u331,#u968').off();
                $scope.u113TabClk = function (visiable, hide0, hide1, removeClassArray) {

                    $('#' + visiable).css({ 'display': 'block', 'visibility': 'visible' });
                    $('#' + hide0).css({ 'display': 'none', 'visibility': 'hidden', 'position': 'absolute' });
                    $('#' + hide1).css({ 'display': 'none', 'visibility': 'hidden', 'position': 'absolute' });
                    $('#' + removeClassArray[0]).addClass('u113_tab-content_click');
                    for (var i = 1; i < removeClassArray.length; i++) {
                        $('#' + removeClassArray[i]).removeClass('u113_tab-content_click');
                    }
                };
                
                $scope.innerTabClk = function (visiables, hides) {
                    var visiableArray = visiables.split(',');
                    visiableArray.forEach(function (visiable) {
                        $('#' + visiable).css({ 'display': 'block', 'visibility': 'visible' });
                    });
                    for (var i = 0; i < hides.length; i++) {
                        $('#' + hides[i]).css({ 'display': 'none', 'visibility': 'hidden' });
                    }

                };
                $scope.showOrHide = function (ele) {
                    var display = $('#' + ele).is(':visible');
                    if (display) {
                        $('#' + ele).css({ 'display': 'none', 'visibility': 'hidden' });
                    } else {
                        $('#' + ele).css({ 'display': 'block', 'visibility': 'visible' });
                    }
                };

                $scope.show = function (ele) {
                    $('#' + ele).css({ 'display': 'block', 'visibility': 'visible' });
                };
                $scope.hide = function (ele) {
                    $('#' + ele).css({ 'display': 'none', 'visibility': 'hidden' });
                };

                $scope.goTaxRisk = function () {
                    $state.go('RiskPanel');
                };

                $scope.getYPDemoProjects();

            }
        };
    }
]);
frameworkModule
    .factory('TodoListDataModel', ['WidgetDataModel', 'region', function (WidgetDataModel, region) {
        function TodoListDataModel() {
        }

        var getDate = function (days) {
            var today = new Date();
            today.setHours(0);
            today.setMinutes(0);
            today.setSeconds(0);
            today.setMilliseconds(0);

            if (_.isNumber(days)) {
                today.setDate(today.getDate() + days);
            }

            return today;
        };

        TodoListDataModel.prototype = Object.create(WidgetDataModel.prototype);
        TodoListDataModel.prototype.init = function () {
            var dataModelOptions = this.dataModelOptions;

            // TODO: Dashboard Demo for Edmond
            this.items = region === 'zh-CN'
                ? [{ content: "[事项提醒]xx银行股份有限公司总行 稽查结果处理", deadline: getDate(25) },
                { content: "[事项提醒]xx银行股份有限公司总行 稽查结果告知", deadline: getDate(20) },
                { content: "[事项提醒]xx银行股份有限公司总行 税务检查实施", deadline: getDate(10) },
                { content: "[事项提醒]xx银行股份有限公司总行 税务检查通知", deadline: getDate(5) }]
                : [{ content: "[Overdue Reminder]Company E 2017-8 Import TrailBalance", deadline: getDate() },
                { content: "[Overdue Reminder]Company E 2017-8 Import Financial Data", deadline: getDate() },
                { content: "[Review Reminder]Company A VAT Tax Return 2017-8 is rejected", deadline: getDate(-1) },
                { content: "[Exception Alert]Company B 2017-8 Exception In Import Voucher", deadline: getDate(-5) }];

            this.updateScope(this.items);
        };

        TodoListDataModel.prototype.destroy = function () {
            WidgetDataModel.prototype.destroy.call(this);
        };

        return TodoListDataModel;
    }])
    .factory('ChartConfigDataModel', ['WidgetDataModel', function (WidgetDataModel) {
        function ChartConfigDataModel() {
        }

        ChartConfigDataModel.prototype = Object.create(WidgetDataModel.prototype);
        ChartConfigDataModel.prototype.init = function () {
            var dataModelOptions = this.dataModelOptions;
            this.chartConfig = (dataModelOptions && dataModelOptions.chartConfig) ? dataModelOptions.chartConfig : {};
            this.updateScope(this.chartConfig);
        };

        ChartConfigDataModel.prototype.destroy = function () {
            WidgetDataModel.prototype.destroy.call(this);
        };

        return ChartConfigDataModel;
    }]);
/// <reference path="../app.js" />
/// <reference path="../../Scripts/underscore.js" />

// Responsible for application route from tab and menu
frameworkModule.factory('appRoute', ['$log', 'enums', '$window', '$location', 'appTabManager', '$route', 
    function ($log, enums, $window, $location, appTabManager, $route) {
        'use strict';
        $log.debug('appRoute.ctor()...');

        var hasValue = function (value) {
            return !_.isUndefined(value) && !_.isNull(value) && (value !== '');
        };

        //
        // constructors of event data
        //
        var comonEventData = function (eventData)
        {
            this.needActivate = typeof (eventData) === "undefined" ? true : eventData.needActivate;
            if (eventData != null) {
                this.param = eventData.param || null;
                this.url = eventData.url || null;
                this.stateName = eventData.stateName || null;
            }
           
        };

        var chartSettingEventData = function (eventData)
        {
            this.needActivate = typeof (eventData) === "undefined" ? true : eventData.needActivate;
            if (eventData != null) {
                this.param = eventData.param || null;
                this.url = eventData.url || null;
                this.chartId = eventData.chartId || null;
            }
        };

        var setLocationPathToRouteUrl = function (routeUrl, isNew) {
            if (!hasValue(isNew)) {
                // when navigate from tab we need update the path
                $location.path(routeUrl).search('isNew', null);
            } else {
                // when navigate from tab we need update the path
                $location.path(routeUrl).search('isNew', isNew);
            }

            $log.debug('$locatoin.path: ' + $location.path());
        };


        /// <summary>
        /// contains tabType and eventData information for current route of the navigate is called each time
        /// you can pass param by eventData for route and check appRoute.current.eventData.Param
        /// </summary>
        var currentRoute = {
            // Indicate whether current route is internal navigation or navigation from UI.
            isInternal: false,
            tabType: null,
            eventData: null,
            // set the data for internal navigation
            set: function (tabType, eventData) {
                currentRoute.isInternal = true;
                currentRoute.tabType = tabType;
                currentRoute.eventData = eventData;
            },
            // reset the data for navigation from UI
            reset: function () {
                currentRoute.isInternal = false;
                currentRoute.tabType = null;
                currentRoute.eventData = null;
            }
        };

        var navigateFromTab = function (tab, triggeredbyUser) {
            /// <summary>
            /// navigate from specified tab, this method should only be called when tab clicked on UI
            /// </summary>
            /// <param name="tab">the clicked tab</param>

            $log.debug('appRoute.navigateFromTab(): ' + (tab ? JSON.stringify(tab.tabName) : 'null'));

            if (!tab) {
                return;
            }

            if (triggeredbyUser) {
                currentRoute.reset();
            }

            // when navigate from tab we need update the path
            setLocationPathToRouteUrl(tab.url, tab.isNew);


        };

        // add new tab or active the tab if the tab is already opened
        var loadTab = function (tabType, eventData, onTabLoaded) {
            if (tabType === enums.tabType.main) {
                appTabManager.loadMainTab(eventData, onTabLoaded);
            }
            else if (tabType === enums.tabType.dashboard)
            {
                appTabManager.loadDashboardTab(eventData, onTabLoaded);
            }
            else if (tabType === enums.tabType.chartEdit)
            {
                appTabManager.loadChartEditTab(eventData, onTabLoaded);
            }
            else if (tabType === enums.tabType.commonUrl)
            {
                appTabManager.loadCommonUrlTab(eventData, onTabLoaded);
            }
            else
            {
                $log.error(tabType + ' is not supported!');
            }
        };
        var routeEvents = {
            navigated: 'app-route-navigated'
        };
        var navigate = function (tabType, eventData) {
            currentRoute.set(tabType, eventData);

            loadTab(tabType, eventData, function (tab, eventData) {
                $log.debug('appRoute.onTabLoaded(): ' + tab.tabName);

                // set active for current tab
                tab.active = eventData.needActivate;

                if (tab.url !== '/') {
                    setLocationPathToRouteUrl(tab.url, tab.isNew);

                    if ($route.current) {
                        $route.current.scope.$broadcast(routeEvents.navigated);
                    }
                } else {
                    appTabManager.closeTab(tab.tabId);
                }
            });
        };


      

        (function initialize() {
            $log.debug('appRoute.initialize()...');
        })();

        // public properties and methods of appRoute
        return {
            navigateFromTab: navigateFromTab,
            navigate: navigate,
            comonEventData: comonEventData,
            chartSettingEventData: chartSettingEventData,
            current: currentRoute,
            routeEvents: routeEvents
        };
    }
]);
// appTabManager is responsible for loading or closing tabs 
frameworkModule.factory('appTabManager', ['$log', 'enums', '$filter', 'constants', '$translate', '$rootScope', '$timeout', '$window', '$stickyState', 'risDialog',
    function ($log, enums, $filter, constants, $translate, $rootScope, $timeout, $window, $stickyState, risDialog) {
        'use strict';
        $log.debug('appTabManager.ctor()...');

        var broadcastTabsChangedEvent = function () {
            // use $timeout to wait for the DOM get updated completed!
            $timeout(function () {
                $rootScope.$broadcast('appTabManager:tabsChanged');
            }, 300);
        };

        /// <summary>
        ///  tab collection on application nav bar
        /// </summary>
        var tabs = [];

        var meetTabCeiling = function () {
            if (tabs.length >= constants.tabCeiling) {
                risDialog({
                    id: 'simpleDialog',
                    template:
                      '<div class="row-fluid">' +
                      ' <h4>您打开的窗口过多，这会影响工作效率，请关闭部分窗口。</h4>' +
                      ' <div>' +
                      '   <div class="codebox">' +
                      '   </div>\n' +
                      ' </div>\n' +
                      '</div>',
                    title: '提示',
                    backdrop: true
                });

                return true;
            }
            return false;
        };

        var selectOpenedTab = function (tab) {
            var list = [];
            if (tabs.length > 0) {
                angular.forEach(tabs, function (tabInfo) {
                    tabInfo.active = tabInfo.tabId === tab.tabId;
                });
            }

            return list;
        };

        tabs.insert = function (index, tab) {
            if (meetTabCeiling()) {
                return false;
            }

            tabs.splice(index, 0, tab);
            broadcastTabsChangedEvent();
            selectOpenedTab(tab);
            return true;
        };

        tabs.add = function (tab) {
            if (meetTabCeiling()) {
                return false;
            }

            tabs.push(tab);
            broadcastTabsChangedEvent();
            selectOpenedTab(tab);
            return true;
        };

        tabs.remove = function (index) {
            if (index > 0) {
                tabs.splice(index, 1);
                broadcastTabsChangedEvent();

                return true;
            }
            selectOpenedTab(tabs[0]);
            return false;
        }

    

        //get opened tabs data to save
        var getOpenedTabs = function (userId) {
            var list = [];
            if (tabs.length > 0) {
                angular.forEach(tabs, function (tabInfo, index) {
                    var tab = {};
                    tab.isWorking = tabInfo.active;
                    tab.position = index;
                    tab.tabId = tabInfo.tabId;
                    tab.tabType = tabInfo.tabType;
                    tab.userId = userId;
                    list.push(tab);
                });
            }

            return list;
        };


        // after tab closed, remove the dom element from ui-view
        var resetState = function (tab) {
            if (tab.route) {
                tab.route.tabId = '';
                tab.route.isWorking = false;
                tab.route = null;
            }

            $timeout(function () {
                $stickyState.reset(tab.state);
            }, 0);
        };

        var closeTabByIndex = function (index) {
            if (_.isNumber(index)) {
                var tab = tabs[index];
                tabs.remove(index);

                resetState(tab);

                selectOpenedTab(tabs[0]);
            } else {
                // do nothing
            }
        };

        var closeCurrentTab = function ()
        {
            _.each(tabs, function (item, index)
            {
                if (item.active)
                {
                    tabs.remove(index);
                }
            });

            selectOpenedTab(tabs[0]);
            
        };

        var closeTab = function (tabId) {
            var tab = _.findWhere(tabs, {
                tabId: tabId
            });
            if (tab) {
                var index = tabs.indexOf(tab);
                tabs.remove(index);

                resetState(tab);

                selectOpenedTab(tabs[0]);
            } else {
                // do nothing
            }
        };
 

        //main
        var createMainTab = function () {
            var mainTab = {
                tabType: enums.tabType.main,
                tabId: PWC.newGuid(),
                url: '/main',
                tabName: '主页' // just demo, need do i18n in future
            };

            return mainTab;
        };

        var loadMainTab = function (eventData, onTabLoaded) {
            var tabItem = _.findWhere(tabs, {
                tabType: enums.tabType.main
            });

            if (!tabItem)
            {
                tabItem = createMainTab();
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, eventData);
                }
            } else {
                onTabLoaded(tabItem, eventData);
                selectOpenedTab(tabItem);
            }
        };

        //dashboard
        var createDashboardTab = function ()
        {
            var mainTab = {
                tabType: enums.tabType.dashboard,
                tabId: PWC.newGuid(),
                url: '/dashboard/compare',
                tabName: '数据汇总'
            };

            return mainTab;
        };

        var loadDashboardTab = function (eventData, onTabLoaded)
        {
            var tabItem = _.findWhere(tabs, {
                tabType: enums.tabType.dashboard
            });

            if (!tabItem)
            {
                tabItem = createDashboardTab();
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, eventData);
                }
            }
            else
            {
                onTabLoaded(tabItem, eventData);
                selectOpenedTab(tabItem);
            }
        };

        //dashboard
        var createChartEditTab = function (chartSettingEventData)
        {
            var tabItem = {
                tabType: enums.tabType.chartEdit,
                tabId: PWC.newGuid(),
                chartId: chartSettingEventData.chartId,
                url: '/dashboardsetting/{0}'.format(chartSettingEventData.chartId), 
                tabName: $translate.instant('chartsetting')
            };

            return tabItem;
        };

        var loadChartEditTab = function (chartSettingEventData, onTabLoaded)
        {
            var tabItem = _.findWhere(tabs, {
                tabType: enums.tabType.chartEdit, chartId: chartSettingEventData.chartId
            });

            if (!tabItem)
            {
                tabItem = createChartEditTab(chartSettingEventData);
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, chartSettingEventData);
                }
            } else
            {
                selectOpenedTab(tabItem);
                onTabLoaded(tabItem, chartSettingEventData);
            }
        };

        //dashboard
        var createCommonUrlTab = function (comonEventData)
        {
            var tabItem = {
                tabType: enums.tabType.commonUrl,
                tabId: PWC.newGuid(),
                url: comonEventData.url.format(comonEventData.param),
                tabName: $translate.instant(comonEventData.stateName)
            };

            return tabItem;
        };

        var loadCommonUrlTab = function (comonEventData, onTabLoaded)
        {
            var tabItem = _.findWhere(tabs, {
                url: comonEventData.url
            });

            if (!tabItem)
            {
                tabItem = createCommonUrlTab(comonEventData);
                if (tabs.add(tabItem))
                {
                    onTabLoaded(tabItem, comonEventData);
                }
            }
            else
            {
                selectOpenedTab(tabItem);
            }
        };


        return {
            tabs: tabs,
            getOpenedTabs: getOpenedTabs,
            closeTabByIndex: closeTabByIndex,
            closeTab: closeTab,
            closeCurrentTab: closeCurrentTab,
            loadMainTab: loadMainTab,
            loadDashboardTab: loadDashboardTab,
            loadChartEditTab: loadChartEditTab,
            loadCommonUrlTab: loadCommonUrlTab,
            selectOpenedTab: selectOpenedTab
        };
    }
]);
/// <reference path="../../app.js" />
/// <reference path="../enums.js" />
commonModule.factory('appTabRouteProvider', ['$log', 'enums', 'constants',
    function ($log, enums, constants) {
    'use strict';
    $log.debug('appTabRouteProvider.ctor()...');
    var i;
    var reportDynamicRoutes = [];
    var getTabRouteUrl = function (tab)
    {
        if (tab.tabType === enums.tabType.worklist) {
            tab.state = 'dashboard'
            return '/dashboard/compare';
        } else if (tab.tabType === enums.tabType.registration) {
           
            return '/';
        } else if (tab.tabType === enums.tabType.report) {
            var availableTab = _.find(reportDynamicRoutes, function (route) { return route.tabId === tab.tabId; });
            if (availableTab) {
                return '/{0}/{1}'.format(availableTab.routeViewName, tab.tabId);
            }

            availableTab = _.find(reportDynamicRoutes, function (route) { return route.isWorking === false; });
            if (availableTab) {
                availableTab.tabId = tab.tabId;
                availableTab.isWorking = true;
                tab.state = availableTab.routeState;
                tab.route = availableTab;
                return '/{0}/{1}'.format(availableTab.routeViewName, tab.tabId);
            }

            $log.error('Registration met the ceiling!');
            return '/';
        } else if (tab.tabType === enums.tabType.clientSetting) {
            tab.state = 'progress';
            return '/progress';
        } else if (tab.tabType === enums.tabType.selfServiceSetting) {
            tab.state = 'ris.selfservicesetting'
            return '/selfservicesetting';
        } else {
            $log.error(tab.tabType + ' is not supported!');
            return '/';
        }
    };

    var tabCeiling = constants.tabCeiling - 1;
    var registrationDynamicRoutes = [];
    for (i = 1; i <= tabCeiling; i++) {
        registrationDynamicRoutes.push({
            routeState: 'ris.registration{0}'.format(i),
            routeViewName: 'registration{0}'.format(i),
            isWorking: false,
            tabId: ''
        });
    };

    
    for (i = 1; i <= tabCeiling; i++) {
        reportDynamicRoutes.push({
            routeState: 'ris.report{0}'.format(i),
            routeViewName: 'report{0}'.format(i),
            isWorking: false,
            tabId: ''
        });
    };

    return {
        getTabRouteUrl: getTabRouteUrl,
        registrationDynamicRoutes: registrationDynamicRoutes,
        reportDynamicRoutes: reportDynamicRoutes
    };
}
]);
var RIS = RIS || {};

// This class contains the customized error class.

PWC.ApplicationError = (function () {
    'use strict';

    var applicationError = function () {
        var tmp = Error.prototype.constructor.apply(this, arguments);
        this.message = tmp.message;
        this.name = "PWC.ApplicationError";

        // Generate stack trace, for now Firefox and Chrome support it, but IE not.
        var err = new Error();
        if (err.stack) {
            this.stack = err.stack;
        }

        //we should define how our toString function works as this will be used internally
        //by the browser's stack trace generation function
        this.toString = function () {
            return this.name + ': ' + this.message;
        };

        return this;
    }
    applicationError.prototype = new Error();
    applicationError.prototype.constructor = applicationError;

    return applicationError;
})();

PWC.ServiceError = (function () {
    'use strict';

    var serviceError = function () {
        var tmp = PWC.ApplicationError.prototype.constructor.apply(this, arguments);
        this.message = tmp.message;
        this.name = "PWC.ServiceError";
        return this;
    }
    serviceError.prototype = new PWC.ApplicationError();
    serviceError.prototype.constructor = PWC.ServiceError;

    return serviceError;
})();
var RIS = RIS || {};

/**
 * Loads javascript files or CSS files into the document
 */
PWC.Loader = function () {
    'use strict';

    function loadResource(resourceUrl, resoruceType, callback, element) {
        /// <summary>
        /// Loads the specified resource into the document. Supported are
        /// CSS and javascript files
        /// </summary>
        /// <param name="resourceUrl">The URL of the script or CSS file</param>
        /// <param name="resoruceType">The mime type of the library</param>
        /// <param name="callback">The function to call on successfull load</param>
        /// <param name="element">The document in which the library is to be loaded</param>
        if (!resourceUrl) {
            throw new PWC.ApplicationError('unknow resourceUrl when load resourse.');
        }
        var theElem = element || document;
        // if this library is already loaded just call the function
        if (isResoruceLoaded(resourceUrl, theElem)) {
            if (callback) {
                callback(resourceUrl, resoruceType, false);
            }
            return;
        }

        var isDoc = theElem.nodeType === 9;
        var libElem = createResourceElement(resourceUrl, resoruceType, (isDoc ? theElem : document));
        var hd = isDoc ? theElem.getElementsByTagName("head")[0] : theElem;

        if (libElem && hd) {
            if (resoruceType === "text/javascript" || resoruceType === "text/css") {
                libElem.addEventListener("load", function () {
                    callback(resourceUrl, resoruceType, true);
                }, false);
            } else {
                callback(resourceUrl, resoruceType, true);
            }
            hd.appendChild(libElem);

            var libs = theElem.libraries;
            if (typeof (libs) === "undefined") {
                libs = theElem.libraries = {};
            }
            libs[resourceUrl] = true;
        }// if(libElem...
    }

    function isResoruceLoaded(resourceUrl, element) {
        /// <summary>
        /// Determines if the resource is successfully loaded
        /// in the given document
        /// </summary>
        /// <param name="resourceUrl">The path of the library</param>
        /// <param name="element">The document obejct</param>
        /// <returns type="bool">true if the given library has already been loaded in the document</returns>
        element = element || document;
        var libs = element.libraries;
        if (typeof (libs) === "undefined") {
            return false;
        }
        return libs[resourceUrl] === true;
    }

    function createResourceElement(resourceUrl, resourceType, elementOwner) {
        /// <summary>
        /// Creates a script or a link elementOwner.
        /// </summary>
        /// <param name="resourceUrl">The URL of the script or CSS file</param>
        /// <param name="resourceType">The resourceType of library, currently supported are "text/javascirpt", "text/css"</param>
        /// <param name="elementOwner">The DOM document in which to create the library elementOwner</param>
        /// <returns>the dom elementOwner representing the library</returns>
        var resourceElement = null;
        if (resourceType === "text/javascript") {
            resourceElement = elementOwner.createElement("script");
            resourceElement.setAttribute("resourceType", resourceType);
            if (resourceUrl) {
                resourceElement.setAttribute("src", resourceUrl);
                resourceElement.src = resourceUrl;
            }
        } else if (resourceType === "text/css") {
            resourceElement = elementOwner.createElement("link");
            resourceElement.setAttribute("rel", "stylesheet");
            resourceElement.setAttribute("resourceType", resourceType);
            if (resourceUrl) {
                resourceElement.setAttribute("href", resourceUrl);
                resourceElement.href = resourceUrl;
            }
        }

        if (resourceElement) {
            resourceElement.setAttribute("id", resourceUrl.replace("/", "_", "g"));
        }
        return resourceElement;
    }

    function doCallback(resources, callback, hasNewJsLoaded) {
        try {
            callback(hasNewJsLoaded);
        } catch (err) {
            var s = "";
            for (var k = 0, klen = resources.length; k < klen; k++) {
                s += resources[k].url + "\n";
            }
            $log.debug(err + ": In call-back function while loading:\n\n" + s);
        }
    }

    return {
        loadJs: function (jsUrl, callback, domElement) {
            /// <summary>
            /// Loads a javascript file/resource into the specified domElement
            /// </summary>
            /// <param name="jsUrl">The jsUrl of the script.</param>
            /// <param name="callback">The function to call on successfull load</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            loadResource(jsUrl, "text/javascript", callback, domElement);
        },

        loadCss: function (cssUrl, domElement) {
            /// <summary>
            /// Loads the specified CSS stylesheet
            /// </summary>
            /// <param name="cssUrl">The url of the CSS stylesheet</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            loadResource(cssUrl, "text/css", null, domElement);
        },

        loadResource: function (resourceUrl, resourceType, callback, domElement) {
            /// <summary>
            /// Loads a javascript or CSS into the specified document.
            /// </summary>
            /// <param name="resourceUrl">The URL of the resource</param>
            /// <param name="resourceType">The mimetype of the reource, text/css OR text/javascript</param>
            /// <param name="callback">The function to call after successfull loading of the file</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            return loadResource(resourceUrl, resourceType, callback, domElement);
        },

        load: function (resources, callback, domElement) {
            /// <summary>
            /// Loads an array of resource into the specified dom document and calls
            /// the given function after successfully loading the scripts
            /// </summary>
            /// <param name="resources">The array of script info objects. The objects have
            /// following fields {url:"the url", type:"text/css | text/javacript"}</param>
            /// <param name="callback">The function to call after successfull loading of the file</param>
            /// <param name="domElement">The document or Element into which to load the resource</param>
            var idx = 0;
            var hasNewJsLoaded = false;
            var loadInternal = function () {
                if (resources.length > 0) {
                    var sInfo = resources[idx];
                    loadResource(sInfo.url, sInfo.type, loadCallback, domElement);
                } else {
                    doCallback(resources, callback);
                }
            };

            var loadCallback = function (resourceUrl, resoruceType, isNewLoaded) {
                if (resoruceType === "text/javascript") {
                    hasNewJsLoaded = hasNewJsLoaded | isNewLoaded;
                }
                ++idx;
                if (idx >= resources.length) {
                    doCallback(resources, callback, hasNewJsLoaded);
                } else {
                    loadInternal();
                }
            };

            loadInternal();
        },

        toString: function () {
            return "PWC.Loader";
        }
    };
}();
/// <reference path="../../app.js" />

// apiInterceptor is responsible to handle the aspect of each request and response.
webservices.factory('apiInterceptor', ['$q', 'loginContext', '$log', '$window', '$injector','$cookies',
    function ($q, loginContext, $log, $window, $injector,$cookies) {
        'use strict';

        $log.debug('apiInterceptor.ctor()...');

        var apiToken = loginContext.apiToken;
        var tokenType = loginContext.tokenType;
        var webApiHostUrl = loginContext.apiHost + constant.webapi.prefix;
        //for vat api
        var vatWebApiHostUrl = loginContext.vatApiHost + constant.webapi.prefix;

        var redirectToLogOut = loginContext.redirectToLogOutFunction;

        return {
            //token save to services for further usage
            tokenType: tokenType,
            apiToken: function () {
                return apiToken;
            },
            webApiHostUrl: webApiHostUrl,
            //for vat api
            vatWebApiHostUrl: vatWebApiHostUrl,

            // On request success
            request: function (config) {

                // Check if this request is a web api call, we should only update url and header for each web api request.
                // Because angular will use the $http service as well internally, such as ng-include to request a html file from server.
                // Set this config to send request to a different web server will break the functions of angularJS.
                if (config.isWebApiRequest) {
                    config.headers = config.headers || {};
                    config.headers.Authorization = tokenType + ' ' + apiToken;
                    if (config.apiType == 'vat') {
                        config.url = vatWebApiHostUrl + config.url;
                    }
                    else {
                        config.url = webApiHostUrl + config.url;
                    }
                    config.withCredentials = true;

                    //废弃 token有效期会自动判断
                    // before each api call, try to ensure user account has not been expired
                    // otherwise, force user to login again
                    // var $http = $injector.get('$http');
                    // $http.get(loginContext.serverUrl + '/Account/CheckLoginStatus?_=' + (new Date).valueOf(), { isBusyRequest: false }).success(function (data) {
                    //     if (data === false) {
                    //         redirectToLogOut();
                    //     }
                    // });
                }

                return config;
            },
            // On request failure
            requestError: function (rejection) {
                $log.error(rejection); // Contains the data about the error on the request.

                // Return the promise rejection.
                return $q.reject(rejection);
            },
            // On response success
            response: function (response) {
                if (response.status === 401) {
                    redirectToLogOut();
                }
                var tmpToken = response.headers('refreshToken');
                if (!!tmpToken) {
                    apiToken = tmpToken;
                    $log.info('refresh token: ' + apiToken);
                }
                return response || $q.when(response);
            },
            // On response failture
            responseError: function (rejection) {
                $log.error(rejection); // Contains the data about the error.

                if (rejection.status === 401) {
                    redirectToLogOut();
                }

                // Return the promise rejection.
                return $q.reject(rejection);
            }
        };
    }])
.factory('requestNotificationInterceptor', ['$q', '$injector', '$log', function ($q, $injector, $log) {
    'use strict';

    $log.debug('busyRequestNotificationInterceptor.ctor()...');

    var busyRequestNotificationHub;
    var busyRequestUrl = null;
    var requestOntheWay = 0;

    function onRequestStarted(config) {
        if (config.isWebApiRequest && config.isBusyRequest) {
            //$log.debug('busyRequestNotificationInterceptor: Start busy request ' + config.url);
            //busyRequestNotificationHub = busyRequestNotificationHub || $injector.get('busyRequestNotificationHub');
            //busyRequestNotificationHub.requestStarted();
            //busyRequestUrl = config.url;
        }

        if (config && typeof (config.ignoreLoadingBar) !== 'undefined' && !config.ignoreLoadingBar) {
            requestOntheWay++;
        }

        if (requestOntheWay > 0) {
            $('#busy-indicator-container').show();
        }
    }

    function onRequestEnded(config) {
        if (busyRequestUrl && config.url === busyRequestUrl) {
            //$log.debug('busyRequestNotificationInterceptor: Finish busy request ' + config.url);
            //busyRequestNotificationHub = busyRequestNotificationHub || $injector.get('busyRequestNotificationHub');
            //busyRequestNotificationHub.requestEnded();
            //busyRequestUrl = null;
        }

        if (config && typeof (config.ignoreLoadingBar) !== 'undefined' && !config.ignoreLoadingBar) {
            requestOntheWay--;
        }

        if (requestOntheWay <= 0) {
            $('#busy-indicator-container').hide();
        }
    }

    return {
        // On request success
        request: function (config) {
            onRequestStarted(config);
            return config;
        },
        // On request failure
        requestError: function (rejection) {
            onRequestEnded(rejection.config);
            return $q.reject(rejection);
        },
        // On response success
        response: function (response) {
            onRequestEnded(response.config);
            return response || $q.when(response);
        },
        // On response failture
        responseError: function (rejection) {
            onRequestEnded(rejection.config);
            return $q.reject(rejection);
        }
    }
}]);

webservices.config(['$httpProvider', function ($httpProvider) {
    $httpProvider.interceptors.push('apiInterceptor');
    $httpProvider.interceptors.push('requestNotificationInterceptor');
}]);

// All web api request should use this service to create its config for request.
webservices.factory('apiConfig', ['$log', 'vatSessionService',
    function ($log, vatSessionService) {

        $log.debug('apiConfig.ctor()...');

        return {
            create: function (config) {
                var cfg = {
                    apiType: 'admin',
                    ignoreLoadingBar: false
                };
                if (config) {
                    cfg = _.extend(cfg, config);
                }

                cfg.isWebApiRequest = true;
                if (config && config.dbName) {
                    cfg.headers = { 'from': config.dbName + '@cn.pwc.com' };
                }
                else {
                    if (vatSessionService.project && vatSessionService.project.dbName) {
                        cfg.headers = { 'from': vatSessionService.project.dbName + '@cn.pwc.com' };
                    }
                }
                return cfg;
            },
            createVat: function (config) {
                var cfg = {
                    apiType: 'vat',
                    ignoreLoadingBar: false
                };
                if (config) {
                    cfg = _.extend(cfg, config);
                }

                cfg.isWebApiRequest = true;
                if (config && config.dbName) {
                    cfg.headers = { 'from': config.dbName + '@cn.pwc.com' };
                }
                else {
                    cfg.headers = { 'from': vatSessionService.project.dbName + '@cn.pwc.com' };
                }
                //$httpProvider.defaults.headers.common['from'] = vatSessionService.project.dbName + '@cn.pwc.com';
                //cfg.headers.from = vatSessionService.project.dbName+'@cn.pwc.com';
                return cfg;
            }
        };
    }]);
frameworkModule.controller("appIndexAnalysisConfigController", ['$scope', '$uibModalInstance', '$log', 'vatSessionService', 'orgService', 'widget',
function ($scope, $uibModalInstance, $log, vatSessionService, orgService, widget) {
    'use strict';

    $scope.widget = widget;
    $scope.model = $.extend(true, {}, widget);
    var dataSources = {
        onSave: function (data) {
            $log.debug("calling ok from appIndexAnalysisConfigController!");
            $scope.model.dataModelOptions.chartConfig = data;
            $uibModalInstance.close($scope.model);
        },
        onCancel: function () {
            $log.debug("calling cancel from appIndexAnalysisConfigController!");
            $uibModalInstance.dismiss("cancel");
        }
    };

    orgService.getOrganizationFilterList().success(function (data) {
        if (_.isEmpty(data)) {
            dataSources.orgIds = [];
        }
        else {
            dataSources.orgIds = _.pluck(data, 'id');
        }

        $scope.dataSources = dataSources;

    });
}]);
// indexAnalysis
frameworkModule.directive('appIndexAnalysis', ['$log', '$translate', '$timeout', 'vatSessionService', 'dashboardConfigSummaryService', 'vatDashboardService',
    function ($log, $translate, $timeout, vatSessionService, dashboardConfigSummaryService, vatDashboardService) {
        'use strict';
        $log.debug('appIndexAnalysis.ctor()...');

        return {
            restrict: 'A',
            templateUrl: '/app/dashboard/app-index-analysis/app-index-analysis.html' + '?_=' + Math.random(),
            replace: true,
            scope: true,
            link: function (scope, element) {
                var thisConstant = {
                    filterMonth: 'filterMonth',
                    dateFormate: 'yyyy-MM',
                    dashSignSeparator: '-',
                    rowCountPerPage: 9,
                    defaultHeight: 400,
                    orgColumn: 'v1',
                    prefixField: 'v'
                };

                var thisDateService = {

                    // 获取当前月份的上一个月时间
                    getLastMonth: function () {
                        var date = new Date();
                        date.setMonth(date.getMonth() - 1);
                        return date;
                    },

                    // 获取查询条件
                    getQueryModel: function () {
                        var arr = scope.filterMonth.split(thisConstant.dashSignSeparator);
                        var year = parseInt(arr[0]);
                        var month = parseInt(arr[1]);

                        var model = {
                            year: year,
                            period: month,
                            organizationIDList: scope.selectedOrganizationList
                        };

                        return model;
                    },

                    // 验证有效月份
                    validDateMonth: function () {
                        var date = scope.filterMonth + '-01';
                        return window.PWC.checkDate(date);
                    },

                    // 转换为页面展示数据
                    parseShowData: function (data) {
                        if (!_.isEmpty(data)) {
                            var values = _.values(data.header);
                            var keys = _.keys(data.header);
                            var length = keys ? keys.length : 0;
                            data.keys = keys;
                            data.headerObj = JSON.parse(data.headerObj);
                        }

                        return data;
                    },

                    // 查询汇总数据
                    querySummaryProcess: function () {
                        if (!thisDateService.validDateMonth) {
                            return;
                        }

                        var model = thisDateService.getQueryModel();
                        vatSessionService.querySummayDashboardModel = model;
                        dashboardConfigSummaryService.querySingleSummaryData(model, scope.widget.dataModel.chartConfig).success(function (data) {
                            // 进行数据转换
                            scope.querySummaryResult = thisDateService.parseShowData(data);
                            if (!_.isEmpty(scope.querySummaryResult)) {
                                scope.hasData = true;
                            } else {
                                scope.hasData = false;
                            }

                            $timeout(function () {
                                thisDateService.drawTableList(scope.querySummaryResult);
                            }, 100);
                        });
                    },

                    drawTableList: function (data) {
                        if (!_.isEmpty(data)) {
                            thisDateService.drawTable(data);
                        }
                    },

                    drawTable: function (node) {
                        if (_.isEmpty(node.data)) {
                            node.isEmpty = true;
                        }
                        else {
                            node.isEmpty = false;
                            var vatGallery = thisDateService.createGalleryData(node);

                            var itemTemplate = function (item, index) {
                                var columns = thisDateService.createColumns(node);
                                if (index === 0) {
                                    var blankAreaHeight = (thisConstant.rowCountPerPage - item.dataValue.length) * 40;
                                    var newHeight = thisConstant.defaultHeight - blankAreaHeight;
                                    $timeout(function () {
                                        element.find('.table-content').height(newHeight);
                                    }, 100);
                                }

                                return $('<div class="gallery-table"/>').dxDataGrid({
                                    dataSource: item.dataValue,
                                    width: '100%',
                                    showRowLines: true,
                                    showColumnLines: false,
                                    noDataText: '',
                                    cellHintEnabled: true,
                                    showBorders: false,
                                    format: { type: 'fixedPoint', precision: 2 },
                                    columns: columns
                                });

                            };
                            var galleryWidget = element.find('.table-content').dxGallery({
                                dataSource: vatGallery,
                                loop: false,
                                width: '100%',
                                showIndicator: true,
                                noDataText: '',
                                showNavButtons: true,
                                itemTemplate: itemTemplate,

                            }).dxGallery("instance");
                        }
                    },
                    // 构造GalleryData
                    createGalleryData: function (node) {

                        var index = Math.ceil(node.data.length / thisConstant.rowCountPerPage);
                        // var x = node.data.length % thisConstant.rowCountPerPage;
                        // if (x !== 0) {
                        //     index = index + 1;
                        // }

                        var result = [];
                        for (var i = 0; i < index; i++) {
                            var item = {};
                            item.id = i;
                            item.dataValue = [];
                            var start = i * thisConstant.rowCountPerPage;
                            for (var j = start; j < start + thisConstant.rowCountPerPage; j++) {
                                var rowData = angular.copy(node.data[j]);
                                if (!rowData) {
                                    continue;
                                }

                                for (var k = 1; k < node.headerObj.length; k++) {
                                    var dataModel = node.headerObj[k];
                                    var field = thisConstant.prefixField + (k + 1);
                                    if (dataModel.dataType === 1) {
                                        rowData[field] = Number(rowData[field]).formatAmount();

                                    } else if (dataModel.dataType === 3) {
                                        rowData[field] = rowData[field] == 1 ? '是' : '否';
                                    }
                                    else {
                                        var percentData = Number(rowData[field]) * 100;
                                        rowData[field] = Number(percentData).formatAmount() + '%';
                                    }
                                }
                                item.dataValue.push(rowData);
                            }

                            result.push(item);
                        }

                        return result;
                    },

                    // 构造列表
                    createColumns: function (node) {
                        var result = [];
                        node.keys.forEach(function (key) {
                            var item = {};
                            item.dataField = key,
                                item.caption = $translate.instant(node.header[key]);
                            if (key !== thisConstant.orgColumn) {
                                item.format = { type: 'fixedPoint' };
                                item.cssClass = 'orange-color';
                                item.alignment = 'right';
                            }

                            result.push(item);
                        });

                        return result;
                    },

                    isChangedArray: function (newValue, oldValue) {
                        if (!newValue && !oldValue) {
                            return false;
                        }

                        if (!newValue) {
                            return true;
                        }

                        if (!oldValue) {
                            return true;
                        }

                        if (newValue.length !== oldValue.length) {
                            return true;
                        }

                        // 排序
                        newValue = newValue.sort();
                        oldValue = oldValue.sort();

                        for (var i = 0; i < newValue.length; i++) {
                            if (newValue[i] !== oldValue[i]) {
                                return true;
                            }
                        }

                        return false;
                    },
                    querySummary: function (queryModel) {
                        if (thisDateService.isChangedArray(queryModel, scope.selectedOrganizationList)) {
                            scope.selectedOrganizationList = queryModel;
                            thisDateService.querySummaryProcess();
                        }
                    }
                };

                var mainModule = {

                    // 初始化参数
                    initParams: function () {
                        scope.selectedOrganizationList = [];
                        scope.hasData = true;
                        mainModule.initFilterMonth();

                        mainModule.watchFilter();
                    },

                    // 初始化查询月份
                    initFilterMonth: function () {

                        //if (vatSessionService.lastDashboardSummaryQueryMonth) {
                        //    scope.filterMonth = vatSessionService.lastDashboardSummaryQueryMonth;
                        //} else {
                        //    var lastmonth = thisDateService.getLastMonth();
                        //    scope.filterMonth = lastmonth.formatDateTime(thisConstant.dateFormate);
                        //}

                        // TODO: Dashboard Demo for Edmond
                        var lastmonth = new Date(2017, 0, 1);
                        scope.filterMonth = lastmonth.formatDateTime(thisConstant.dateFormate);

                        var elem1 = $("#" + thisConstant.filterMonth);
                        elem1.datepicker({
                            minViewMode: 1,
                            autoclose: true,
                            language: "zh-CN",
                            format: "yyyy-mm",
                        });

                        elem1.datepicker('setDate', lastmonth);
                    },

                    // 监视查询条件变更
                    watchFilter: function () {

                        // 日期选择改变时
                        scope.$watch('filterMonth', function (newValue, oldValue) {
                            if (newValue !== oldValue) {
                                vatSessionService.lastDashboardSummaryQueryMonth = newValue;
                                thisDateService.querySummaryProcess();
                            }
                        });
                    },

                    // 入口函数
                    main: function () {
                        mainModule.initParams();
                    }
                };

                //开始
                (function initialize() {
                    $log.debug('appIndexAnalysis.link.initialize()...');
                    scope.querySummary = thisDateService.querySummary;
                    scope.showFilter = false;
                    mainModule.main();
                })();
            }
        };
    }
]);
// todoList
frameworkModule.directive('appTodoList', ['$log', '$translate', function ($log, $translate) {
    'use strict';
    $log.debug('appTodoList.ctor()...');

    return {
        restrict: 'A',
        templateUrl: '/app/dashboard/app-todo-list/app-todo-list.html' + '?_=' + Math.random(),
        replace: true,
        scope: false,
        link: function (scope, element) {
            //scope.todoDataSource = scope.widget.dataModel.items;
        }
    };
}]);
frameworkModule.controller("appTodoListConfigController", ['$scope', '$uibModalInstance', '$log', 'widget',
    function ($scope, $uibModalInstance, $log, widget) {
        'use strict';

        $scope.title = "APPTodoListConfigOTTitle";

        $scope.configOptions = {
            "Display": 1,
            "DisplayItemCount": 4,
            "OrderBy": 3
        };

        $scope.confirm = function () {
            $scope.$close($scope.configOptions);
        };

        $scope.cancel = function () {
            $scope.$dismiss("canceled");
        };
    }]);
frameworkModule.directive("appTodoListConfig", [function () {
    'use strict';

    return {
        restrict: "A",
        templateUrl: "/app/dashboard/app-todo-list/config/config.html",
        replace: true,
        scope: {},
        controller: "appTodoListConfigController",
        link: function ($scope, $element, $attr) {

        }
    };
}]);
frameworkModule.controller("dashboardDeferredTaxAnalysisConfigController", ['$scope', '$uibModalInstance', '$log', 'widget',
    function ($scope, $uibModalInstance, $log, widget) {
        'use strict';

        $scope.widget = widget;
        $scope.configOptions = $.extend(true, {}, widget);
        $scope.title = "DeferredTaxAnalysisConfigOTTitle";
        $scope.display = 1;

        if (!_.isEmpty($scope.configOptions.dataModelOptions)
            && !_.isEmpty($scope.configOptions.dataModelOptions.chartConfig)) {
            $scope.display = $scope.configOptions.dataModelOptions.chartConfig.display;
        }

        $scope.confirm = function () {
            $scope.configOptions.dataModelOptions.chartConfig = {
                display: $scope.display
            };

            $scope.$close($scope.configOptions);
        };

        $scope.cancel = function () {
            $scope.$dismiss("canceled");
        };
    }]);
frameworkModule.directive("dashboardDeferredTaxAnalysisConfig", [function () {
    'use strict';

    return {
        restrict: "A",
        templateUrl: "/app/dashboard/deferred-tax-analysis/config/config.html",
        replace: true,
        scope: {},
        controller: "dashboardDeferredTaxAnalysisConfigController",
        link: function ($scope, $element, $attr) {

        }
    };
}]);
frameworkModule.controller('dashboardDeferredTaxAnalysisController', ["$scope", "$compile", "$timeout", function ($scope, $compile, $timeout) {
    'use strict';

    /***************************************** DEMO CODE BEGIN *****************************************/
        //TODO:DEMO 数据正式版中应该动态取值
    var orgList = [
        {"ID": "root", "name": "XXX制造有限公司总公司", "expanded": true, "status": "未开始"},
        {"ID": "1", "categoryId": "root", "name": "XXX制造有限公司A1分公司", "expanded": true, "status": "已提交"},
        {"ID": "2", "categoryId": 'root', "name": "XXX制造有限公司A2分公司", "expanded": true, "status": "已提交"},
        {"ID": "3", "categoryId": 'root', "name": "XXX制造有限公司A3分公司", "expanded": true, "status": "未开始"},
        {"ID": "4", "categoryId": 'root', "name": "XXX制造有限公司A4分公司", "expanded": true, "status": "未开始"},
        {"ID": "5", "categoryId": 'root', "name": "XXX制造有限公司A5分公司", "expanded": true, "status": "未开始"},
        {"ID": "6", "categoryId": "root", "name": "XXX制造有限公司A6分公司", "expanded": true, "status": "未开始"}
    ];
    $scope.assetStructureDEMOData = [
        {value: 4000.00, name: '递延收益'},
        {value: 0.00, name: '公允价值变动'},
        {value: 15250, name: '预提性质费用'},
        {value: 6250, name: '预计负债'},
        {value: 139040, name: '折旧 / 摊销'},
        {value: 56500, name: '准备金或减值准备'},
        {value: 0.00, name: '特殊事项'},
        {value: 50000, name: '税务亏损'},
        {value: 0, name: '其他'},
        {value: 0.00, name: '未实现内部交易（合并层面）'}
    ];

    $scope.taxStructureDEMOData = [
        {value: 0.00, name: '递延收益'},
        {value: 8500, name: '公允价值变动'},
        {value: 0, name: '预提性质费用'},
        {value: 0, name: '预计负债'},
        {value: 0, name: '折旧 / 摊销'},
        {value: 0, name: '准备金或减值准备'},
        {value: 14000, name: '特殊事项'},
        {value: 0, name: '税务亏损'},
        {value: 5750, name: '其他'},
        {value: 0, name: '未实现内部交易（合并层面）'}
    ];

    $scope.variationAnalysisData = [4000, 0, 15250, 6250, 139040, 56500, 0, 50000, 0, 0];

    /***************************************** DEMO CODE END *****************************************/

    $scope.selectedOrgIds = ["root"];
    $scope.selectOrgBoxOptions = {
        bindingOptions: {
            value: "selectedOrgIds"
        },
        dataSource: orgList,
        displayExpr: "name",
        valueExpr: "ID",
        placeholder: '. . .',
        showClearButton: false,
        width: '22em',
        treeView: {
            dataSource: orgList,
            dataStructure: "plain",
            focusStateEnabled: false,
            keyExpr: "ID",
            parentIdExpr: "categoryId",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: false,
            showCheckBoxesMode: "none",
            selectionMode: 'single',
            treeViewInstance: null,
            onContentReady: function (e) {
                e.component.unselectAll();
                if ($scope.selectedOrgIds && $scope.selectedOrgIds.length > 0)
                    e.component.selectItem($scope.selectedOrgIds[0]);
            },
            onItemSelectionChanged: function (args) {
                var value = args.component.getSelectedNodesKeys();
                $scope.selectedOrgIds = value;
            }
        }
    };
    $scope.period = new Date();
    $scope.periodSelectorOption = {
        bindingOptions: {
            value: "period"
        },
        acceptCustomValue: false,
        displayFormat: "yyyy年MM月",
        maxZoomLevel: "year",
        minZoomLevel: "year",
        min: "2010/1/1",
        max: "2030/12/31"
    };
    $scope.dimensions = null;
    $scope.dimensionsSelectorOption = {
        width: '10em',
        value: '1',
        valueExpr: 'ID',
        displayExpr: 'name',
        dataSource: [
            {
                'ID': "1",
                'name': "按机构",
            },
            {
                'ID': "2",
                'name': "按区域",
            },
            {
                'ID': "3",
                'name': "按事业部",
            }
        ],
        onSelectionChanged: function (e) {
            $scope.dimensions = e.selectedItem;
        }
    };
}]);
frameworkModule.directive("dashboardDeferredTaxAnalysis", [function () {
    'use strict';

    return {
        restrict: "A",
        templateUrl: "/app/dashboard/deferred-tax-analysis/deferred-tax-analysis.html",
        replace: true,
        scope: true,
        controller: "dashboardDeferredTaxAnalysisController",
        link: function ($scope, $element, $attr) {

            var colourArray = ['#a32020', '#eb8c00', '#db536a', '#dc6900', '#e0301e', '#602320', '#3f3f40', '#968c6d'];

            var pieLegend = ["递延收益", "公允价值变动", "预提性质费用", "预计负债", "折旧 / 摊销", "准备金或减值准备", "特殊事项", "税务亏损", "其他", "未实现内部交易（合并层面）"];

            var chartsContainer = $($element).find(".charts-container");

            // display
            //  1 资产构成
            //  2 负债构成
            //  3 资产/负债变动数分析
            if ($scope.widget.dataModel.chartConfig.display === 1) {
                chartsContainer.css("height", 350);
                var assetStructure = echarts.init(chartsContainer[0], 'vintage');
                assetStructure.setOption({
                    color: colourArray,
                    tooltip: {
                        trigger: 'item',
                        formatter: "{a} <br/>{b} : {c} ({d}%)"
                    },
                    legend: {
                        orient: 'vertical',
                        left: (assetStructure.getWidth() * 0.55 - assetStructure.getHeight() * 0.5 - 300),
                        data: pieLegend
                    },
                    toolbox: {
                        show: false,
                        feature: {
                            mark: {show: true},
                            dataView: {show: true, readOnly: false},
                            restore: {show: true},
                            saveAsImage: {show: true}
                        }
                    },
                    series: [
                        {
                            name: '期末数',
                            type: 'pie',
                            center: ['55%', '50%'],
                            radius: ['40%', "80%"],
                            itemStyle: {
                                normal: {
                                    label: {
                                        show: true
                                    },
                                    labelLine: {
                                        show: true
                                    }
                                },
                                emphasis: {
                                    label: {
                                        show: true,
                                        position: 'center',
                                        textStyle: {
                                            fontSize: '20',
                                            fontWeight: 'bold'
                                        }
                                    }
                                }
                            },
                            minAngle: 5,
                            data: $scope.assetStructureDEMOData
                        }
                    ]
                });
            }

            if ($scope.widget.dataModel.chartConfig.display === 2) {
                chartsContainer.css("height", 350);
                var taxStructure = echarts.init(chartsContainer[0], 'vintage');
                taxStructure.setOption({
                    color: colourArray,
                    tooltip: {
                        trigger: 'item',
                        formatter: "{a} <br/>{b} : {c} ({d}%)"
                    },
                    legend: {
                        orient: 'vertical',
                        left: (taxStructure.getWidth() * 0.55 - taxStructure.getHeight() * 0.5 - 300),
                        data: pieLegend
                    },
                    toolbox: {
                        show: false,
                        feature: {
                            mark: {show: true},
                            dataView: {show: true, readOnly: false},
                            restore: {show: true},
                            saveAsImage: {show: true}
                        }
                    },
                    series: [
                        {
                            name: '期末数',
                            type: 'pie',
                            center: ['55%', '50%'],
                            radius: ['40%', "80%"],
                            itemStyle: {
                                normal: {
                                    label: {
                                        show: true
                                    },
                                    labelLine: {
                                        show: true
                                    }
                                },
                                emphasis: {
                                    label: {
                                        show: true,
                                        position: 'center',
                                        textStyle: {
                                            fontSize: '18',
                                            fontWeight: 'bold'
                                        }
                                    }
                                }
                            },
                            minAngle: 5,
                            data: $scope.taxStructureDEMOData
                        }
                    ]
                });
            }

            if ($scope.widget.dataModel.chartConfig.display === 3) {
                chartsContainer.css("height", 600);
                var variationAnalysis = echarts.init(chartsContainer[0], 'vintage');
                variationAnalysis.setOption({
                    color: colourArray,
                    grid: {
                        height: "380px",
                        bottom: "150px"
                    },
                    xAxis: [
                        {
                            axisLabel: {
                                rotate: 60
                            },
                            type: 'category',
                            data: pieLegend
                        }
                    ],
                    yAxis: [
                        {
                            type: 'value',
                            name: '金额',
                            axisLabel: {
                                formatter: '{value}'
                            }
                        }
                    ],
                    series: [
                        {
                            name: 'data',
                            type: 'bar',
                            barWidth: 20,
                            yAxisIndex: 0,
                            itemStyle: {
                                normal: {
                                    label: {
                                        show: true,
                                        position: 'top'
                                    }
                                }
                            },
                            data: $scope.variationAnalysisData
                        }
                    ]
                });
            }
        }
    };
}]);
frameworkModule.controller("dashboardTaxCashFlowAnalysisConfigController", ['$scope', '$uibModalInstance', '$log', 'widget',
    function ($scope, $uibModalInstance, $log, widget) {
        'use strict';

        $scope.title = "TaxCashFlowAnalysisConfigOTTitle";

        $scope.configOptions = {
            "Display": 1
        };

        $scope.confirm = function () {
            $scope.$close($scope.configOptions);
        };

        $scope.cancel = function () {
            $scope.$dismiss("canceled");
        };
    }]);
frameworkModule.directive("dashboardTaxCashFlowAnalysisConfig", [function () {
    'use strict';

    return {
        restrict: "A",
        templateUrl: "/app/dashboard/tax-cash-flow-analysis/config/config.html",
        replace: true,
        scope: {},
        controller: "dashboardTaxCashFlowAnalysisConfigController",
        link: function ($scope, $element, $attr) {

        }
    };
}]);
frameworkModule.controller('dashboardTaxCashFlowAnalysisController', ["$scope", "$compile", "$timeout", "$translate",
    function ($scope, $compile, $timeout, $translate) {
    'use strict';

    /***************************************** DEMO CODE BEGIN *****************************************/
        //TODO:DEMO 数据正式版中应该动态取值
    var orgList = [
            { "ID": "root", "name": $translate.instant("HeaderCompany"), "expanded": true, "status": "未开始"},
            { "ID": "1", "categoryId": "root", "name": $translate.instant("CompanyA1"), "expanded": true, "status": "已提交" },
            { "ID": "2", "categoryId": 'root', "name": $translate.instant("CompanyA2"), "expanded": true, "status": "已提交" },
            { "ID": "3", "categoryId": 'root', "name": $translate.instant("CompanyA3"), "expanded": true, "status": "未开始" },
            { "ID": "4", "categoryId": 'root', "name": $translate.instant("CompanyA4"), "expanded": true, "status": "未开始" },
            { "ID": "5", "categoryId": 'root', "name": $translate.instant("CompanyA5"), "expanded": true, "status": "未开始" },
            { "ID": "6", "categoryId": "root", "name": $translate.instant("CompanyA6"), "expanded": true, "status": "未开始" }
        ];

    $scope.categoryAxisData = ['增值税', '消费税', '流转税附加税费', '印花税', '房产税', '土地使用税', '车船税', '土地增值税', '契税', '车辆购置税', '关税', '个人所得税', '企业所得税'];

    $scope.valueAxisData = [
        [100000, 80000, 20000, 100, 5000, 4000, 300, 1000, 500, 2000, 0, 30000, 50000],
        [105000, 78000, 21000, 150, 4600, 4200, 280, 880, 520, 1800, 0, 32000, 48000]
    ];

    /***************************************** DEMO CODE END *****************************************/

    $scope.display = 2;

    $scope.categorySelectorOption = {
        placeholder: $translate.instant('Category'),
        width: '15em',
        value: $translate.instant('Organization'),
        dataSource: [$translate.instant('BusinessUnit'), $translate.instant('Area'), $translate.instant('Organization'), $translate.instant('Industry')],
        onValueChanged: function (e) {
        }
    };

    $scope.selectedOrgIds = ["root"];
    $scope.selectOrgBoxOptions = {
        bindingOptions: {
            value: "selectedOrgIds"
        },
        dataSource: orgList,
        displayExpr: "name",
        valueExpr: "ID",
        placeholder: '. . .',
        showClearButton: false,
        width: '15em',
        treeView: {
            dataSource: orgList,
            dataStructure: "plain",
            focusStateEnabled: false,
            keyExpr: "ID",
            parentIdExpr: "categoryId",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: false,
            showCheckBoxesMode: "none",
            selectionMode: 'single',
            treeViewInstance: null,
            onContentReady: function (e) {
                e.component.unselectAll();
                if ($scope.selectedOrgIds && $scope.selectedOrgIds.length > 0)
                    e.component.selectItem($scope.selectedOrgIds[0]);
            },
            onItemSelectionChanged: function (args) {
                var value = args.component.getSelectedNodesKeys();
                $scope.selectedOrgIds = value;
            }
        }
    };

    $scope.periodFrom = new Date();
    $scope.periodTo = new Date();
    var periodSelectorBasicOption = {
        bindingOptions: {
            value: null
        },
        acceptCustomValue: false,
        displayFormat: $translate.instant('dateFormat4YearMonthForDX'),
        maxZoomLevel: "year",
        minZoomLevel: "year",
        min: "2010/1/1",
        max: "2030/12/31",
        placeholder: ""
    };
    $scope.periodFromSelectorOption = $.extend(true, {}, periodSelectorBasicOption);
    $scope.periodFromSelectorOption.bindingOptions.value = "periodFrom";
    $scope.periodToSelectorOption = $.extend(true, {}, periodSelectorBasicOption);
    $scope.periodToSelectorOption.bindingOptions.value = "periodTo";
}]);
frameworkModule.directive("dashboardTaxCashFlowAnalysis", ['$translate', '$filter', 'region', function ($translate, $filter, region) {
    'use strict';

    return {
        restrict: "A",
        templateUrl: "/app/dashboard/tax-cash-flow-analysis/tax-cash-flow-analysis.html",
        replace: true,
        scope: {
            options: "=dashboardTaxCashFlowAnalysis"
        },
        controller: "dashboardTaxCashFlowAnalysisController",
        link: function ($scope, $element, $attr) {
            var colourArray = ['#a32020', '#eb8c00', '#db536a', '#dc6900', '#e0301e', '#602320', '#3f3f40', '#968c6d'];

            var chartsContainer = $($element).find(".charts-container");
            var cashFlowChart = echarts.init(chartsContainer[0], 'vintage');

            //用于使echart自适应高度和宽度,通过窗体高宽计算容器高宽
            var resizeEchart = function (width) {
                width = width || $element.width();

                // 如果渲染页面时该控件处于隐藏状态，则$element.width()会为0，此时不去重新计算
                if (width > 0) {
                    $element.find('.charts-container').width(width + 'px');
                    $element.find('.charts-container').show();
                }
                else {
                    $element.find('.charts-container').hide();
                }
            };

            var resizeCashFlowChart = function () {
                //重置容器高宽
                resizeEchart();
                cashFlowChart.resize();
            };

            // display
            //  1 资产构成
            //  2 负债构成
            if ($scope.display === 1) {
                chartsContainer.css("height", 350);
                cashFlowChart.setOption({
                    title: {
                        subtext: '单位(千元)'
                    },
                    dataZoom: {
                        show: true,
                        realtime: true,
                        start: 0,
                        end: 34,
                        //zoomLock: false
                    },
                    grid: {
                        x2: 50,
                        y: 50
                    },
                    tooltip: {
                        trigger: 'axis',
                        formatter: function (params) {
                            return params[0].name + '<br/>'
                                + params[0].seriesName + ' : ' + params[0].value.toString().replace(/(\d{1,2})(?=(\d{3})+\.)/g, '$1,') + ' 千元<br/>'
                                + params[1].seriesName + ' : ' + params[1].value.toString().replace(/(\d{1,2})(?=(\d{3})+\.)/g, '$1,') + ' 千元<br/>'
                        }
                    },
                    color: colourArray,
                    legend: {
                        data: ['预测税额', '实交税额']
                    },
                    xAxis: [
                        {
                            type: 'category',
                            data: $scope.categoryAxisData
                        }
                    ],
                    yAxis: [
                        {
                            type: 'value',
                            name: '金额',
                            axisLabel: {
                                formatter: '{value}'
                            }
                        }

                    ],
                    series: [
                        {
                            name: '预测税额',
                            type: 'bar',
                            barWidth: 20,
                            yAxisIndex: 0,
                            label: {
                                normal: {
                                    show: true,
                                    position: 'top'
                                }
                            },
                            data: $scope.valueAxisData[0]
                        },
                        {
                            name: '实交税额',
                            type: 'bar',
                            barWidth: 20,
                            yAxisIndex: 0,
                            label: {
                                normal: {
                                    show: true,
                                    position: 'top'
                                }
                            },
                            data: $scope.valueAxisData[1]
                        }
                    ]
                });
            }

            if ($scope.display === 2) {
                chartsContainer.css("height", 300);
                cashFlowChart.setOption({
                    tooltip: {
                        trigger: 'axis',
                        formatter: function (params) {
                            return params[0].name + '<br/>'
                                + params[0].seriesName + ' : ' + params[0].value + ' %<br/>'
                                + params[1].seriesName + ' : ' + params[1].value + ' %<br/>'
                        }
                    },
                    legend: {
                        data: [$translate.instant('ReturnRatioMunicipalLevel'), $translate.instant('ReturnRatioDistrictLevel')]
                    },
                    color: colourArray,
                    toolbox: {
                        show: false,
                        feature: {
                            mark: {show: true},
                            dataView: {show: true, readOnly: false},
                            magicType: {show: true, type: ['line', 'bar', 'stack', 'tiled']},
                            restore: {show: true},
                            saveAsImage: {show: true}
                        }
                    },
                    grid: [{
                        left: region === 'zh-CN' ? '10%': '205px'
                    }],
                    calculable: true,
                    xAxis: [
                        {
                            type: 'value'
                        }
                    ],
                    yAxis: [
                        {
                            type: 'category',
                            data: [$translate.instant('OtherTaxes'), $translate.instant('LocalEducationAttach'), $translate.instant('EducationAttach'),
                                $translate.instant('ConstructionTax'), $translate.instant('CIT'), $translate.instant('VAT')]
                        }
                    ],
                    series: [
                        {
                            name: $translate.instant('ReturnRatioMunicipalLevel'),
                            type: 'bar',
                            stack: '总量',
                            itemStyle: {
                                normal: {
                                    label: {
                                        show: true, position: 'insideRight', formatter: function (x) {
                                            if (x.data == 0) {
                                                return '';
                                            }

                                            return x.data + ' %';
                                        }
                                    }
                                }
                            },
                            data: [0.00, 0.00, 0.00, 5.25, 3.75, 5.10]
                        },
                        {
                            name: $translate.instant('ReturnRatioDistrictLevel'),
                            type: 'bar',
                            stack: '总量',
                            itemStyle: {normal: {label: {show: true, position: 'insideRight', formatter: '{c} %'}}},
                            data: [60.00, 40.00, 20.00, 64.75, 50.00, 5.10]
                        }
                    ]
                });
            }

            resizeCashFlowChart();

            //用于使echart自适应宽度
            $(window).bind('resize', resizeCashFlowChart);

            $scope.$on('$destroy', function () {
                $(window).unbind('resize', resizeCashFlowChart);
            });
        }
    };
}]);
frameworkModule.controller('dashboardTaxRiskAlertController', ["$scope", "$compile", "$timeout", "$translate", function ($scope, $compile, $timeout, $translate) {
    'use strict';
    /***************************************** DEMO CODE BEGIN *****************************************/
    var orgList = [
        { "ID": "root", "name": $translate.instant('HeaderCompany'), "expanded": true, "status": "未开始"},
        { "ID": "1", "categoryId": "root", "name": $translate.instant('CompanyA1'), "expanded": true, "status": "已提交"},
        { "ID": "2", "categoryId": 'root', "name": $translate.instant('CompanyA2'), "expanded": true, "status": "已提交" },
        { "ID": "3", "categoryId": 'root', "name": $translate.instant('CompanyA3'), "expanded": true, "status": "未开始" },
        { "ID": "4", "categoryId": 'root', "name": $translate.instant('CompanyA4'), "expanded": true, "status": "未开始" },
        { "ID": "5", "categoryId": 'root', "name": $translate.instant('CompanyA5'), "expanded": true, "status": "未开始" },
        { "ID": "6", "categoryId": "root", "name": $translate.instant('CompanyA6'), "expanded": true, "status": "未开始" }
    ];
    /***************************************** DEMO CODE BEGIN *****************************************/

    var riskLevelColors = [
        {
            name: "Low",
            color: "#feb100"
        },
        {
            name: "Mid",
            color: "#f06000"
        },
        {
            name: "High",
            color: "#b70707"
        }
    ];

    $scope.riskDesc = {
        dataSource: null,
        dxDataGridInstance: null,
        dxDataGridOptions: {
            bindingOptions: {
                dataSource: "riskDesc.dataSource"
            },
            allowColumnResizing: true,
            columns: [
                {
                    alignment: "left",
                    dataField: "taxName",
                    dataType: "string",
                    caption: $translate.instant('TaxType'),
                    width: "11em"
                },
                {
                    alignment: "left",
                    dataField: "riskLevel",
                    dataType: "string",
                    caption: $translate.instant('RiskLevel'),
                    width: "7em"
                },
                {
                    alignment: "left",
                    dataField: "desc",
                    dataType: "string",
                    caption: $translate.instant('RiskDescription'),
                    width: "auto"
                }
            ],
            editing: {
                allowAdding: false,
                allowDeleting: false,
                allowUpdating: false
            },
            focusStateEnabled: true,
            hoverStateEnabled: true,
            keyExpr: null,
            loadPanel: {
                enabled: true
            },
            noDataText: $translate.instant('NoDataText'),
            paging: {
                enabled: false
            },
            rowAlternationEnabled: false, //单双行颜色
            scrolling: {
                mode: "infinite"
            },
            selection: {
                allowSelectAll: false,
                mode: "single"
            },
            showBorders: true,
            showColumnLines: true,
            showRowLines: true,
            sorting: {
                mode: "single"
            },
            onInitialized: function (e) {
                $scope.riskDesc.dxDataGridInstance = e.component;
            },
            onCellPrepared: function (e) {
                if (!(e.rowType === "data" && e.column.dataField === "riskLevel"))
                    return;

                var i = $("<i class='fa fa-exclamation-circle' style='font-size: 1.1em;'></i>");
                i.css("margin-right", "3px");

                var color = _.find(riskLevelColors, function (item) {
                    return item.name == e.data["riskLevel"];
                });
                if (color)
                    i.css("color", color.color);

                $(e.cellElement).empty();
                $(e.cellElement).text($translate.instant(e.data["riskLevel"]));
                $(e.cellElement).prepend(i);
            }
        }
    };

    $scope.riskDesc.dataSource = [
        {
            riskLevel: 'Mid',
            taxName: $translate.instant('VATType'),
            desc: $translate.instant('VATTypeDesc')
        },
        {
            riskLevel: 'High',
            taxName: $translate.instant('CITType'),
            desc: $translate.instant('CITTypeDesc')
        },
        {
            riskLevel: 'Mid',
            taxName: $translate.instant('IITType'),
            desc: $translate.instant('IITTypeDesc')
        },
        {
            riskLevel: 'Mid',
            taxName: $translate.instant('LVATType'),
            desc: $translate.instant('LVATTypeDesc')
        },
        {
            riskLevel: 'Mid',
            taxName: $translate.instant('PropertyTax'),
            desc: $translate.instant('PropertyTaxTypeDesc')
        },
        {
            riskLevel: 'Low',
            taxName: $translate.instant('SpecialTaxType'),
            desc: $translate.instant('SpecialTaxTypeDesc')
        }
    ];

    $scope.selectedOrgIds = ["root"];
    $scope.selectOrgBoxOptions = {
        bindingOptions: {
            value: "selectedOrgIds"
        },
        dataSource: orgList,
        displayExpr: "name",
        valueExpr: "ID",
        placeholder: '. . .',
        showClearButton: false,
        width: '15em',
        treeView: {
            dataSource: orgList,
            dataStructure: "plain",
            focusStateEnabled: false,
            keyExpr: "ID",
            parentIdExpr: "categoryId",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: false,
            showCheckBoxesMode: "none",
            selectionMode: 'single',
            treeViewInstance: null,
            onContentReady: function (e) {
                e.component.unselectAll();
                if ($scope.selectedOrgIds && $scope.selectedOrgIds.length > 0)
                    e.component.selectItem($scope.selectedOrgIds[0]);
            },
            onItemSelectionChanged: function (args) {
                var value = args.component.getSelectedNodesKeys();
                $scope.selectedOrgIds = value;
            }
        }
    };

    $scope.period = new Date();

    $scope.periodSelectorOption = {
        bindingOptions: {
            value: "period"
        },
        acceptCustomValue: false,
        displayFormat: $translate.instant('dateFormat4YearMonthForDX'),
        maxZoomLevel: "year",
        minZoomLevel: "year",
        min: "2010/1/1",
        max: "2030/12/31",
        placeholder: "",
        width: '15em',
    };

    var checkListConfigs = {
        "businessUnit": {
            name: "businessUnit",
            data: ["事业部1", "事业部2", "事业部3", "事业部4"],
            width: "15em",
            selectedItemKeys: [],
            dropDownBoxInstance: null
        },
        "district": {
            name: "district",
            data: ["区域1", "区域2", "区域3", "区域4"],
            width: "15em",
            selectedItemKeys: [],
            dropDownBoxInstance: null
        },
        "taxCategory": {
            name: "taxType",
            data: [$translate.instant('VATType'), $translate.instant('ConsumptionTax'), '流转税附加税费', '印花税', $translate.instant('PropertyTax'),
                '土地使用税', '车船税', $translate.instant('LVATType'), '契税', '车辆购置税', '关税', $translate.instant('IITType'), $translate.instant('CITType')],
            width: "15em",
            selectedItemKeys: [],
            dropDownBoxInstance: null
        }
    };

    $scope.riskSectorChartOption = {
        data: [
            {
                name: $translate.instant('VATType'),
                value: 50
            },
            {
                name: $translate.instant('CITType'),
                value: 80
            },
            {
                name: $translate.instant('IITType'),
                value: 60
            },
            {
                name: $translate.instant('LVATType'),
                value: 55
            },
            {
                name: $translate.instant('PropertyTax'),
                value: 40
            },
            {
                name: $translate.instant('SpecialTaxType'),
                value: 20
            }
        ]
    };

    $scope.getDropDownBoxOptions = function (controllerName) {
        var checkList = checkListConfigs[controllerName];
        checkList.selectedItemKeys = checkList.data;

        var option = {
            width: checkList.width,
            value: checkList.selectedItemKeys,
            fieldTemplate: "field",
            contentTemplate: "content",
            dataSource: checkList.data,
            onInitialized: function (e) {
                checkList.dropDownBoxInstance = e.component;
            }
        };

        return option;
    };

    $scope.getDropDownListOptions = function (controllerName) {
        var checkList = checkListConfigs[controllerName];

        var option = {
            selectionMode: "multiple",
            dataSource: checkList.data,
            selectedItemKeys: checkList.selectedItemKeys,
            showSelectionControls: true,
            onSelectionChanged: function (e) {
                var selectedItemKeys = e.component.option("selectedItemKeys");
                checkList.selectedItemKeys = selectedItemKeys;
                checkList.dropDownBoxInstance.option("value", selectedItemKeys);
            }
        };

        return option;
    };

    $scope.getDropDownTextBoxOptions = function (controllerName) {
        var checkList = checkListConfigs[controllerName];

        var option = {
            value: checkList.data,
            readOnly: true,
            onValueChanged: function (e) {
                var displayText = "";
                if (checkList.selectedItemKeys.length == checkList.data.length) {
                    switch (checkList.name) {
                        case 'businessUnit':
                            displayText = $translate.instant('AllBusinessUnit');
                            break;
                        case 'district':
                            displayText = $translate.instant('AllArea');
                            break;
                        case 'taxType':
                            displayText = $translate.instant('AllTax');
                            break;
                        default:
                            displayText = $translate.instant("All") + checkList.name;
                            break;
                    }
                }

                if (checkList.selectedItemKeys.length > 0 && checkList.selectedItemKeys.length < checkList.data.length)
                    displayText = checkList.selectedItemKeys.join(",");

                e.component.option("value", displayText);
            },
            onInitialized: function (e) {
                e.component.option("onValueChanged")(e);
            }
        };

        return option;
    };
}]);
frameworkModule.directive("dashboardTaxRiskAlert", [function () {
    'use strict';

    return {
        restrict: "A",
        templateUrl: "/app/dashboard/tax-risk-alert/tax-risk-alert.html" + '?_=' + Math.random(),
        replace: true,
        scope: {
            options: "=dashboardTaxRiskAlert"
        },
        controller: "dashboardTaxRiskAlertController",
        link: function ($scope, $element, $attr) {
        }
    };
}]);